#ifdef RCS
static char rcsid[]="$Id: convert.c,v 1.9 1998/01/26 17:19:27 dast Exp $";
#endif
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 *  ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing authors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjorn.Stenberg@sth.frontec.se>
 *  - Andrew Gray <DarkDesigns@trader.com>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/convert.c,v $
 * $Revision: 1.9 $
 * $Date: 1998/01/26 17:19:27 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: convert.c,v $
 * Revision 1.9  1998/01/26 17:19:27  dast
 * Now uses local time zone instead of GMT for "now"
 *
 * Revision 1.8  1997/11/05 21:58:16  dast
 * Added includes
 *
 * Revision 1.7  1997/07/15 07:42:56  dast
 * Removed a bunch of extra newlines on the Send() calls
 *
 * Revision 1.6  1997/01/27 17:01:32  dast
 * time is behind, not after
 *
 * Revision 1.5  1997/01/11 20:33:22  dast
 * supports the extended EXCHANGE list command
 *
 * Revision 1.4  1997/01/07 18:19:53  dast
 * made the exchange function take the amount as a string to support floats
 *
 * Revision 1.3  1997/01/05 21:07:06  dast
 * added EXCHANGE
 *
 * Revision 1.2  1996/12/13 18:11:07  dast
 * limiting the sscanf()!
 *
 * Revision 1.1  1996/12/12 18:57:06  dast
 * Initial revision
 *
 ****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include "dancer.h"
#include "function.h"
#include "transfer.h"
#include "country.h"

extern char *errfrom;

tz tzinfo[328] = {
	{0,0,"GMT",0,0},
	{0,0,"UTC",0,0},
	{0,0,"CET",1,0},
	{0,0,"MET",1,0},
	{0,0,"EET",2,0},
	{0,0,"EAT",2,0},
	{0,0,"WAT",-1,0},
	{0,0,"AST",-4,0},
	{0,0,"EST",-5,0},
	{0,0,"CST",-6,0},
	{0,0,"MST",-7,0},
	{0,0,"PST",-8,0},
	{0,0,"HST",-10,0},
	{0,0,"Afghanistan",4,30},
	{0,0,"Albania",1,0},
	{0,0,"Algeria",1,0},
	{0,0,"American Samoa",-11 ,0},
	{0,0,"Andorra",1,0},
	{0,0,"Angola",1 ,0},
	{0,0,"Anguilla",-4 ,0},
	{0,0,"Antarctica",-2,0},
	{0,0,"Antigua",-4 ,0},
	{0,0,"Argentina",-3 ,0},
	{0,0,"Argentina western prov",-4 ,0},
	{0,0,"Armenia",4,0},
	{0,0,"Aruba",-4 ,0},
	{0,0,"Ascension",0 ,0},
	{0,0,"Australia Northern Territory",9,30},
	{0,0,"Australia Lord Howe Island",10,30},
	{0,0,"Australia New South Wales",10,0},
	{0,0,"Australia Queensland",10 ,0},
	{0,0,"Australia Victoria",10,0},
	{0,0,"Australia Australian Captial Territory",10,0},
	{0,0,"Australia South",9,30},
	{0,0,"Australia Tasmania",10,0},
	{0,0,"Australia Western",8 ,0},
	{0,0,"Austria",1,0},
	{0,0,"Azerbajian",3 ,0},
	{0,0,"Azores",-1,0},
	{0,0,"Bahamas",-5,0},
	{0,0,"Bahrain",3 ,0},
	{0,0,"Balearic Islands",1,0},
	{0,0,"Bangladesh",6 ,0},
	{0,0,"Barbados",-4 ,0},
	{0,0,"Belarus",2,0},
	{0,0,"Belgium",1,0},
	{0,0,"Belize",-6 ,0},
	{0,0,"Benin",1 ,0},
	{0,0,"Bermuda",-4,0},
	{0,0,"Bhutan",6 ,0},
	{0,0,"Bolivia",-4 ,0},
	{0,0,"Bonaire",-4 ,0},
	{0,0,"Bosnia Hercegovina",1,0},
	{0,0,"Botswana",2 ,0},
	{0,0,"Brazil Acre",-4,0},
	{0,0,"Brazil Atlantic Islands",-1,0},
	{0,0,"Brazil East",-3,0},
	{0,0,"Brazil West",-4,0},
	{0,0,"British Virgin Islands",-4 ,0},
	{0,0,"Brunei",8 ,0},
	{0,0,"Bulgaria",2,0},
	{0,0,"Burkina Faso",0 ,0},
	{0,0,"Burundi",2 ,0},
	{0,0,"Cambodia",7 ,0},
	{0,0,"Cameroon",1 ,0},
	{0,0,"Canada Central",-6,0},
	{0,0,"Canada Eastern",-5,0},
	{0,0,"Canada Mountain",-7,0},
	{0,0,"Canada Yukon & Pacific",-8,0},
	{0,0,"Canada Atlantic",-4,0},
	{0,0,"Canada Newfoundland",-3,-30},
	{0,0,"Canary Islands",0,0},
	{0,0,"Canton Enderbury Islands",-11 ,0},
	{0,0,"Cape Verde",-1 ,0},
	{0,0,"Caroline Island",11 ,0},
	{0,0,"Cayman Islands",-5 ,0},
	{0,0,"Central Africa",1 ,0},
	{0,0,"Chad",1 ,0},
	{0,0,"Channel Islands",0,0},
	{0,0,"Chatham Island",12,45},
	{0,0,"Chile",-4,0},
	{0,0,"China",8 ,0},
	{0,0,"Christmas Islands",-10 ,0},
	{0,0,"Cocos Islands",-10,0},
	{0,0,"Colombia",-5 ,0},
	{0,0,"Congo",1 ,0},
	{0,0,"Cook Islands",-10 ,0},
	{0,0,"Costa Rica",-6 ,0},
	{0,0,"Cote d'Ivoire",0 ,0},
	{0,0,"Croatia",1,0},
	{0,0,"Cuba",-5,0},
	{0,0,"Curacao",-4 ,0},
	{0,0,"Cyprus",2,0},
	{0,0,"Czech",1,0},
	{0,0,"Dahomey",1 ,0},
	{0,0,"Denmark",1,0},
	{0,0,"Djibouti",3 ,0},
	{0,0,"Dominica",-4 ,0},
	{0,0,"Dominican Republic",-4 ,0},
	{0,0,"Easter Island",-6,0},
	{0,0,"Ecuador",-5 ,0},
	{0,0,"Egypt",2,0},
	{0,0,"El Salvador",-6 ,0},
	{0,0,"England",0,0},
	{0,0,"Equitorial Guinea",1 ,0},
	{0,0,"Eritrea",3 ,0},
	{0,0,"Estonia",2,0},
	{0,0,"Ethiopia",3 ,0},
	{0,0,"Falkland Islands",-4,0},
	{0,0,"Faroe Island",0,0},
	{0,0,"Fiji",12 ,0},
	{0,0,"Finland",2,0},
	{0,0,"France",1,0},
	{0,0,"French Guiana",-3 ,0},
	{0,0,"French Polynesia",-10 ,0},
	{0,0,"Gabon",1 ,0},
	{0,0,"Galapagos Islands",-5 ,0},
	{0,0,"Gambia",0 ,0},
	{0,0,"Gambier Island",-9 ,0},
	{0,0,"Georgia",4 ,0},
	{0,0,"Germany",1,0},
	{0,0,"Ghana",0 ,0},
	{0,0,"Gibraltar",1,0},
	{0,0,"Greece",2,0},
	{0,0,"Greenland",-3,0},
	{0,0,"Greenland Thule",-4,0},
	{0,0,"Greenland Scoresbysun",-1,0},
	{0,0,"Grenada",-4,0},
	{0,0,"Grenadines",-4,0},
	{0,0,"Guadeloupe",-4,0},
	{0,0,"Guam",10 ,0},
	{0,0,"Guatemala",-6 ,0},
	{0,0,"Guinea",0 ,0},
	{0,0,"Guinea Bissau",-1,0},
	{0,0,"Guyana",-3 ,0},
	{0,0,"Haiti",-5,0},
	{0,0,"Honduras",-6 ,0},
	{0,0,"Hong kong",8 ,0},
	{0,0,"Hungary",1,0},
	{0,0,"Iceland",0 ,0},
	{0,0,"India",5,30},
	{0,0,"Indonesia Central",8 ,0},
	{0,0,"Indonesia East",9 ,0},
	{0,0,"Indonesia West",7 ,0},
	{0,0,"Iran",3,30},
	{0,0,"Iraq",3,0},
	{0,0,"Ireland",0,0},
	{0,0,"Israel",2,0},
	{0,0,"Italy",1,0},
	{0,0,"Jamaica",-5 ,0},
	{0,0,"Japan",9 ,0},
	{0,0,"Johnston Island",-10 ,0},
	{0,0,"Jordan",2,0},
	{0,0,"Kazakhstan",6,0},
	{0,0,"Kenya",3 ,0},
	{0,0,"Kiribati",12 ,0},
	{0,0,"Korea",9 ,0},
	{0,0,"Kusaie",12 ,0},
	{0,0,"Kuwait",3 ,0},
	{0,0,"Kwajalein",-12 ,0},
	{0,0,"Kyrgyzstan",5,0},
	{0,0,"Laos",7 ,0},
	{0,0,"Latvia",2,0},
	{0,0,"Lebanon",2,0},
	{0,0,"Leeward Islands",-4 ,0},
	{0,0,"Lesotho",2 ,0},
	{0,0,"Liberia",0 ,0},
	{0,0,"Libya",2 ,0},
	{0,0,"Lithuania",2,0},
	{0,0,"Luxembourg",1,0},
	{0,0,"Macedonia",1,0},
	{0,0,"Madagascar",3 ,0},
	{0,0,"Madeira",0,0},
	{0,0,"Malawi",2 ,0},
	{0,0,"Malaysia",8 ,0},
	{0,0,"Maldives",5 ,0},
	{0,0,"Mali",0 ,0},
	{0,0,"Mallorca",1,0},
	{0,0,"Malta",1,0},
	{0,0,"Mariana Island",10 ,0},
	{0,0,"Marquesas Islands",-9,-30},
	{0,0,"Marshall Islands",12 ,0},
	{0,0,"Martinique",-4 ,0},
	{0,0,"Mauritania",0 ,0},
	{0,0,"Mauritius",4 ,0},
	{0,0,"Mayotte",3 ,0},
	{0,0,"Melilla",1,0},
	{0,0,"Mexico",-6 ,0},
	{0,0,"Mexico Baja Calif Norte",-8,0},
	{0,0,"Mexico Nayarit",-7 ,0},
	{0,0,"Mexico Sinaloa",-7 ,0},
	{0,0,"Mexico Sonora",-7 ,0},
	{0,0,"Midway Island",-11 ,0},
	{0,0,"Moldova",2,0},
	{0,0,"Moldovian Rep Pridnestrovye",2,0},
	{0,0,"Monaco",1,0},
	{0,0,"Mongolia",8 ,0},
	{0,0,"Morocco",0 ,0},
	{0,0,"Mozambique",2 ,0},
	{0,0,"Myanmar",6,30},
	{0,0,"Namibia",1,0},
	{0,0,"Nauru Republic of",12 ,0},
	{0,0,"Nepal",5,45},
	{0,0,"Netherlands",1,0},
	{0,0,"Netherlands Antilles",-4 ,0},
	{0,0,"Nevis Montserrat",-4 ,0},
	{0,0,"New Caledonia",11 ,0},
	{0,0,"New Hebrides",11 ,0},
	{0,0,"New Zealand",12,0},
	{0,0,"Nicaragua",-6,0},
	{0,0,"Niger",1 ,0},
	{0,0,"Nigeria",1 ,0},
	{0,0,"Niue Island",-11 ,0},
	{0,0,"Norfolk Island",11,30},
	{0,0,"Northern Ireland",0,0},
	{0,0,"Northern Mariana Islands",10 ,0},
	{0,0,"Norway",1,0},
	{0,0,"Oman",4 ,0},
	{0,0,"Pakistan",5 ,0},
	{0,0,"Palau",9 ,0},
	{0,0,"Panama",-5 ,0},
	{0,0,"Papua New Guinea",10 ,0},
	{0,0,"Paraguay",-4,0},
	{0,0,"Peru",-5 ,0},
	{0,0,"Philippines",8 ,0},
	{0,0,"Pingelap",12 ,0},
	{0,0,"Poland",1,0},
	{0,0,"Ponape Island",11 ,0},
	{0,0,"Portugal",1,0},
	{0,0,"Principe Island",0 ,0},
	{0,0,"Puerto Rico",-4 ,0},
	{0,0,"Qatar",3 ,0},
	{0,0,"Reunion",4 ,0},
	{0,0,"Romania",2,0},
	{0,0,"Russian Federation zone eight",9,0},
	{0,0,"Russian Federation zone eleven",12,0},
	{0,0,"Russian Federation zone five",6,0},
	{0,0,"Russian Federation zone four",5,0},
	{0,0,"Russian Federation zone nine",10,0},
	{0,0,"Russian Federation zone one",2,0},
	{0,0,"Russian Federation zone seven",8,0},
	{0,0,"Russian Federation zone six",7,0},
	{0,0,"Russian Federation zone ten",11,0},
	{0,0,"Russian Federation zone three",4,0},
	{0,0,"Russian Federation zone two",4,0},
	{0,0,"Rwanda",2 ,0},
	{0,0,"Saba",-4 ,0},
	{0,0,"Samoa",-11 ,0},
	{0,0,"San Marino",1,0},
	{0,0,"Sao Tome e Principe",0 ,0},
	{0,0,"Saudi Arabia",3 ,0},
	{0,0,"Scotland",0,0},
	{0,0,"Senegal",0 ,0},
	{0,0,"Seychelles",4 ,0},
	{0,0,"Sierra Leone",0 ,0},
	{0,0,"Singapore",8 ,0},
	{0,0,"Slovakia",1,0},
	{0,0,"Slovenia",1,0},
	{0,0,"Society Island",-10 ,0},
	{0,0,"Solomon Islands",11 ,0},
	{0,0,"Somalia",3 ,0},
	{0,0,"South Africa",2 ,0},
	{0,0,"Spain",1,0},
	{0,0,"Sri Lanka",5,30},
	{0,0,"St Christopher",-4 ,0},
	{0,0,"St Croix",-4 ,0},
	{0,0,"St Helena",0 ,0},
	{0,0,"St John",-4 ,0},
	{0,0,"St Kitts Nevis",-4 ,0},
	{0,0,"St Lucia",-4 ,0},
	{0,0,"St Maarten",-4 ,0},
	{0,0,"St Pierre & Miquelon",-3,0},
	{0,0,"St Thomas",-4 ,0},
	{0,0,"St Vincent",-4 ,0},
	{0,0,"Sudan",2 ,0},
	{0,0,"Suriname",-3 ,0},
	{0,0,"Swaziland",2 ,0},
	{0,0,"Sweden",1,0},
	{0,0,"Switzerland",1,0},
	{0,0,"Syria",2,0},
	{0,0,"Tahiti",-10 ,0},
	{0,0,"Taiwan",8 ,0},
	{0,0,"Tajikistan",6 ,0},
	{0,0,"Tanzania",3 ,0},
	{0,0,"Thailand",7 ,0},
	{0,0,"Togo",0 ,0},
	{0,0,"Tonga",13 ,0},
	{0,0,"Trinidad and Tobago",-4 ,0},
	{0,0,"Tuamotu Island",-10 ,0},
	{0,0,"Tubuai Island",-10 ,0},
	{0,0,"Tunisia",1 ,0},
	{0,0,"Turkey",2,0},
	{0,0,"Turkmenistan",5 ,0},
	{0,0,"Turks and Caicos Islands",-5,0},
	{0,0,"Tuvalu",12 ,0},
	{0,0,"Uganda",3 ,0},
	{0,0,"Ukraine",2,0},
	{0,0,"United Arab Emirates",4 ,0},
	{0,0,"United Kingdom",0,0},
	{0,0,"USA Central",-6,0},
	{0,0,"USA Eastern",-5,0},
	{0,0,"USA Mountain",-7,0},
	{0,0,"USA Arizona",-7 ,0},
	{0,0,"USA Indiana East",-5 ,0},
	{0,0,"USA Pacific",-8,0},
	{0,0,"USA Alaska",-9,0},
	{0,0,"USA Aleutian",-10 ,0},
	{0,0,"USA Hawaii",-10 ,0},
	{0,0,"Uruguay",-3 ,0},
	{0,0,"Uzbekistan",5 ,0},
	{0,0,"Vanuatu",11,0},
	{0,0,"Vatican City",1,0},
	{0,0,"Venezuela",-4 ,0},
	{0,0,"Vietnam",7 ,0},
	{0,0,"Virgin Islands",-4 ,0},
	{0,0,"Wake Island",12 ,0},
	{0,0,"Wales",0,0},
	{0,0,"Wallis and Futuna Islands",12 ,0},
	{0,0,"Windward Islands",-4 ,0},
	{0,0,"Yemen",3 ,0},
	{0,0,"Yugoslavia",1,0},
	{0,0,"Zaire Kasai",2 ,0},
	{0,0,"Zaire Kinshasa Mbandaka",1 ,0},
	{0,0,"Zaire Haut Zaire",2 ,0},
	{0,0,"Zaire Kivu",2 ,0},
	{0,0,"Zaire Shaba",2 ,0},
	{0,0,"Zambia",2 ,0},
	{0,0,"Zimbabwe",2 ,0}
  };


/* --- CmdConvert ------------------------------------------------- */

float findprefix( char* s, char** newptr )
{
  float exp;
  char* ptr;

  if     (!strncasecmp(s,"atto", 4)) { exp=0.000000000000000001; ptr=s+4; }
  else if(!strncasecmp(s,"femto",5)) { exp=0.000000000000001; ptr=s+5; }
  else if(!strncasecmp(s,"pico", 4)) { exp=0.000000000001; ptr=s+4; }
  else if(!strncasecmp(s,"nano", 4)) { exp=0.000000001; ptr=s+4; }
  else if(!strncasecmp(s,"micro",5)) { exp=0.000001; ptr=s+5; }
  else if(!strncasecmp(s,"milli",5)) { exp=0.001; ptr=s+5; }
  else if(!strncasecmp(s,"centi",5)) { exp=0.01; ptr=s+5; }
  else if(!strncasecmp(s,"deci", 4)) { exp=0.1; ptr=s+4; }
  else if(!strncasecmp(s,"hecto",5)) { exp=100; ptr=s+5; }
  else if(!strncasecmp(s,"kilo", 4)) { exp=1000; ptr=s+4; }
  else if(!strncasecmp(s,"mega", 4)) { exp=1000000; ptr=s+4; }
  else if(!strncasecmp(s,"giga", 4)) { exp=1000000000; ptr=s+4; }
  else if(!strncasecmp(s,"tera", 4)) { exp=1000000000000.0; ptr=s+4; }
  else if(!strncasecmp(s,"penta",5)) { exp=1000000000000000.0; ptr=s+5; }
  else { exp=1; ptr=s; }

  *newptr = ptr;
  return exp;
}

void Convert(char *from, char *line)
{
  if ( line && *line ) {
/*	char line[128]; */
	float value,meter=0,celsius=0,gram=0,liter=0,sqm=0;
	float exp;
	char   ustr[32];
	int	   dec,x;
	int		 len=0,temp=0,mass=0,vol=0,area=0;
	char*	 unit;

/*	fgets( line, 80, stdin ); */

	x = sscanf( line, "%g %31s %d", &value, ustr, &dec );
	if ( x >= 2 ) {
	  if ( x == 2 )
		dec=1;
	  if (dec > 4)
	    dec = 4;

	  exp = findprefix( ustr, &unit );

	  /* length conversion */
	  if     (!strncasecmp(unit,"me",2))  {len=1;meter=value;}
	  else if(!strncasecmp(unit,"dm",2))  {len=1;meter=value/10;}
	  else if(!strncasecmp(unit,"cm",2))  {len=1;meter=value/100;}
	  else if(!strncasecmp(unit,"mm",2))  {len=1;meter=value/1000;}
	  else if(!strncasecmp(unit,"mi",2))  {len=1;meter=value*1609.344;}
	  else if(!strncasecmp(unit,"ya",2))  {len=1;meter=value*0.9144;}
	  else if(!strncasecmp(unit,"fe",2)||
			  !strncasecmp(unit,"fo",2)||
			  !strncasecmp(unit,"ft",2))  {len=1;meter=value*0.3048;}
	  else if(!strncasecmp(unit,"in",2))  {len=1;meter=value*0.0254;}
	  else if(!strncasecmp(unit,"nau",3)) {len=1;meter=value*1852;}
	  else if(!strncasecmp(unit,"cha",3)) {len=1;meter=value*20.11684023;}
	  else if(!strncasecmp(unit,"rod",3)) {len=1;meter=value*5.02921006;}
	  else if(!strncasecmp(unit,"fat",3)) {len=1;meter=value*1.82880366;}
	  
	  /* temperature conversion */
	  else if(!strncasecmp(unit,"cel",3)) {temp=1;celsius=value;}
	  else if(!strncasecmp(unit,"fah",3)||
			  !strncasecmp(unit,"far",3)) {temp=1;celsius=(value - 32) * (5.0/9.0);}
	  else if(!strncasecmp(unit,"ke",2))   {temp=1;celsius=value - 273.15;}
	  
	  /* weight conversion */
	  else if(!strncasecmp(unit,"gram",4)){mass=1;gram=value;}
	  else if(!strncasecmp(unit,"kg",2))  {mass=1;gram=value*1000;}
	  else if(!strncasecmp(unit,"lb",2)||
			  !strncasecmp(unit,"po",2))  {mass=1;gram=value*453.59237;}
	  else if(!strncasecmp(unit,"oz",2)||
			  !strncasecmp(unit,"ou",2))  {mass=1;gram=value*28.349523125;}
	  
	  /* volume conversion */
	  else if(!strncasecmp(unit,"li",2))  {vol=1;liter=value;}
	  else if(!strncasecmp(unit,"gal",2)) {vol=1;liter=value*4.546092;}
	  else if(!strncasecmp(unit,"us",2))  {vol=1;liter=value*3.7858411784;}
	  else if(!strncasecmp(unit,"qua",3)) {vol=1;liter=value*0.946352946;}
	  else if(!strncasecmp(unit,"pin",3)) {vol=1;liter=value*0.473176473;}
	  else if(!strncasecmp(unit,"cup",3)) {vol=1;liter=value*0.2365882365;}
	  else if(!strncasecmp(unit,"fl",2))  {vol=1;liter=value*0.0295735295625;}
	  else if(!strncasecmp(unit,"tabl",4)||
			  !strncasecmp(unit,"tbsp",4)){vol=1;liter=value*0.01478676478125;}
	  else if(!strncasecmp(unit,"tea",3)||
			  !strncasecmp(unit,"tsp",3)) {vol=1;liter=value*0.00492892159375;}
	  else if(!strncasecmp(unit,"bush",4)){vol=1;liter=value*35.23907;}
	  else if(!strncasecmp(unit,"peck",4)){vol=1;liter=value*8.8097675;}
	  else if(!strncasecmp(unit,"cuya",4)||
			  !strncasecmp(unit,"cuyr",4)){vol=1;liter=value*764.554857984;}
	  else if(!strncasecmp(unit,"cufe",4)||
			  !strncasecmp(unit,"cufo",4)||
			  !strncasecmp(unit,"cuft",4)){vol=1;liter=value*28.316846592;}
	  else if(!strncasecmp(unit,"cuin",4)){vol=1;liter=value*0.016387064;}
	  else if(!strncasecmp(unit,"cum",3)) {vol=1;liter=value*1000;}
	  
	  /* area conversion */
	  else if(!strncasecmp(unit,"sqme",4)){area=1;sqm=value;}
	  else if(!strncasecmp(unit,"sqkm",4)){area=1;sqm=value*1000000;}
	  else if(!strncasecmp(unit,"ha",2)||
			  !strncasecmp(unit,"hec",3)) {area=1;sqm=value*10000;}
	  else if(!strncasecmp(unit,"ac",2))  {area=1;sqm=value*4046.872609874252;}
	  else if(!strncasecmp(unit,"sqmi",4)){area=1;sqm=value*2589988.110336;}
	  else if(!strncasecmp(unit,"sqy",3)) {area=1;sqm=value*0.83612736;}
	  else if(!strncasecmp(unit,"sqf",3)) {area=1;sqm=value*0.09290304;}
	  else if(!strncasecmp(unit,"sqi",3)) {area=1;sqm=value*0.00064516;}     

	  /* unknown conversion */
	  else
		Sendf(from, GetText(msg_unknown_unit), unit);

	  /* apply exponent */
	  meter*=exp;
	  celsius*=exp;
	  gram*=exp;
	  liter*=exp;
	  sqm=exp;
	  
	  if ( len )
		Sendf(from, GetText(msg_convert_length),
			  dec, meter,
			  dec, meter/1609.344,
			  dec, meter/0.9144,
			  dec, meter/0.3048,
			  dec, meter/0.0254,
			  dec, meter/1852,
			  dec, meter/20.11684023,
			  dec, meter/5.02921006,
			  dec, meter/1.82880366);
			
	  if ( temp )
		Sendf(from, GetText(msg_convert_temperature),
			  dec, celsius,
			  dec, celsius * (9.0/5.0) + 32,
			  dec, celsius + 273.15 );
	  
	  if ( mass )
		Sendf(from, GetText(msg_convert_mass),
			  dec, gram,
			  dec, gram/453.59237,
			  dec, gram/28.349523125);

	  if ( vol )
		Sendf(from, GetText(msg_convert_volume),
			  dec, liter,
			  dec, liter/4.546092,
			  dec, liter/3.7858411784,
			  dec, liter/0.0295735295625,
			  dec, liter/0.473176473,    
			  dec, liter/0.2365882365,   
			  dec, liter/0.01478676478125,
			  dec, liter/0.00492892159375,
			  dec, liter/0.946352946,
			  dec, liter/35.23907,       
			  dec, liter/8.8097675,      
			  dec, liter/1000,
			  dec, liter/764.554857984,  
			  dec, liter/28.316846592,   
			  dec, liter/0.01638706 );

	  if ( area )
		Sendf(from, GetText(msg_convert_area),
			  dec, sqm,
			  dec, sqm/1000000,
			  dec, sqm/10000,
			  dec, sqm/4046.872609874252,
			  dec, sqm/2589988.110336,
			  dec, sqm/0.83612736,
			  dec, sqm/0.09290304,
			  dec, sqm/0.00064516 );
	}
  }
}


/* --- CmdTz ------------------------------------------------------ */

tz* FindZoneByName(char *name)
{
  int i, j, d, min;
  unsigned long sig, let;

  if('.' == *name) {
    land *country;
    /* get name from extention */
    country = FindByCode(name);
    if(!country)
      return NULL; /* no success */
    name = country->country;
  }

  sig = HashSignature(name);
  let = MarkLetters(name);
  min = INT_MAX;
  j = -1;
  for (i=0; i < sizeof(tzinfo)/sizeof(tzinfo[0]); i++) {
    d = HammingDistance(tzinfo[i].sig, sig) + 
	    UnequalBits(tzinfo[i].let, let);
    if (min > d) {
      min = d;
      j = i;
    }
  }
  return (j >= 0 ? &tzinfo[j] : NULL);
}

void TimeZone(char *from, char *line)
{
  time_t t;
  struct tm tm;
  struct tm* tp;
  int i;
  char tzcmd[16];

  tzcmd[0]=0;
  sscanf(line, " %15s", tzcmd);

  t = time( NULL );
  tp = localtime( &t );
  tm = *tp;

  for (i=0; i < sizeof(tzinfo)/sizeof(tzinfo[0]); i++) {
    tzinfo[i].sig = HashSignature(tzinfo[i].name);
    tzinfo[i].let = MarkLetters(tzinfo[i].name);
  }

  /* eat space */
  while(isspacechar(*line)) line++;
  /* After this, line points to the first character in the already
     parsed 'tzcmd' keyword. You may use whichever you prefer.
     - Bagder */

  /*
	 1: convert tzinfo
	 darx tz 12:00 [am/pm] GMT [ AST ]
  */

  if ( isdigit( *tzcmd ) ) {
    char* ptr=line;
    char* p;
    int h,m,i;
    tz* first=NULL;
    tz* second=NULL;
    tz* z;

    /* parse time */
    p=strchr(ptr,' ');
    if (!p) {
      Send(from, GetText(msg_specify_tz));
      return;
    }
    i=p-ptr;
    if ( i > 2 ) {
      if ( strchr( ptr, ':' ) )
	sscanf(ptr, "%d:%d", &h,&m);
      else {
	if ( i > 3 )
	  sscanf(ptr, "%02d%d", &h, &m);
	else
	  sscanf(ptr, "%1d%02d", &h, &m);
      }
    }
    else {
      h = atoi( ptr );
      m = 0;
    }
    p++;

    /* am/pm ? */
    if ( !strncasecmp( "pm", p, 2 ) ) {
      h += 12;
      ptr = p+3;
    }
    else if ( !strncasecmp( "am", p, 2 ) ) {
      ptr = p+3;
    }
    else
      ptr = p;

    /* parse first tzinfo */
    if ( ptr[0] == '\"' ) {
      ptr++;
      p=strchr( ptr, '\"' );
      if (!p) {
	Send(from, GetText(msg_unbalanced_quote));
	return;
      }
      *p=0;
      p+=2;
    }
    else {
      p=strchr( ptr, ' ' );
      if (!p)
	second = &tzinfo[0];
      else {
	*p=0;
	p++;
      }
    }
    z = FindZoneByName( ptr );
    if (!z) {
      Sendf(from, GetText(msg_unknown_zone), ptr);
      return;
	}
    
    first = z;
    h -= z->hdiff;
    m -= z->mdiff;

    if ( !second ) {
      /* parse second timezone */
      ptr = p;
      if ( ptr[0] == '\"' ) {
	ptr++;
	p=strchr( ptr, '\"' );
	if (!p) {
	  Send(from, GetText(msg_unbalanced_quote));
	  return;
	}
	*p=0;
      }

      z = FindZoneByName( ptr );
      if (!z) {
	Sendf(from, GetText(msg_unknown_zone), ptr);
	return;
      }

      second = z;
    }

    tm.tm_hour = h + second->hdiff;
    tm.tm_min  = m + second->mdiff;
    t = mktime( &tm );
    tp = localtime( &t );
    
    Sendf(from, GetText(msg_time_equals_time_in),
	  h + first->hdiff, m + first->mdiff, first->name,
	  tp->tm_hour, tp->tm_min, second->name);
  }

  /* 
	 4: display current time in zone
	 darx tz now GMT
  */

  else if (!strcasecmp( tzcmd, "now") ) {
    tz* z;
    char* ptr;
    char tzbuffer[8]; /* in case we need this */
    ptr = strchr( line, ' ');
    if(ptr && ptr[1])
      ptr++;
    else {
      /* We use default zone GMT, this should be changed to become the
	 bot's own local time (IMHO) - Bagder */
      ptr = "GMT";
      if(strftime(tzbuffer, 8, "%Z", &tm))
        ptr=tzbuffer;
    }

    z = FindZoneByName( ptr );
    if (!z) {
      Sendf(from, GetText(msg_unknown_zone), ptr);
      return;
    }
    tm.tm_hour += z->hdiff -1; /* time() returns swedish time here! */
    tm.tm_min  += z->mdiff;
    t = mktime( &tm );
    tp = localtime( &t );

    Sendf(from, GetText(msg_current_time),
	  z->name, ptr, tp->tm_hour, tp->tm_min );
  }

  /* list countries/zones */
  else if (!strcasecmp( tzcmd, "list") ) {
    int total=0;
    int actual=0;
    bool send=TRUE;

    char *p;
    char buf[MIDBUFFER];
    char pattern[MINIBUFFER]="*";
    char* ptr = buf;

    p = strchr(line, ' ');
    if(p) {
      p++;
      sscanf(p, "%"MINIBUFFERTXT"s", pattern);
    }

    for (i=0; i < sizeof(tzinfo)/sizeof(tzinfo[0]); i++) {
      if ( Match( tzinfo[i].name, pattern ) ) {
	if ( ((ptr - buf) + strlen( tzinfo[i].name )) < MIDBUFFER ) {
	  sprintf( ptr, "%s%s", actual?", ":"", tzinfo[i].name );
	  ptr += strlen( ptr );
	  actual++;
	}
	else
	  send=FALSE;
	total++;
      }
    }
    if (!actual)
      Sendf(from, GetText(msg_pattern_doesnt_match), pattern);
    else
      Sendf(from, buf);
    if (!send) {
      Sendf(from, GetText(msg_limit_searchpattern),
	    total-actual);
    }
  }

  /*
	 2: display timezone
	 darx tz <where>

	 3: display timezone relative
	 darx tz <where> [where]
  */
  else {
    char  tmp1[64];
    char  tmp2[64];
    char* p=line;
    char* ptr=line;
    tz*   z;
    tz*	  first;
    tz*   second;
    int	  h,m,ahead;

    /* parse first timezone */
    if ( ptr[0] == '\"' ) {
      ptr++;
      p=strchr( ptr, '\"' );
      if (!p) {
	Send(from, GetText(msg_unbalanced_quote));
	return;
      }
      *p=0;
      p++;
    }
    else {
      p=strchr( ptr, ' ' );
      if (p) {
	*p = 0;
	p++;
      }
    }

    z = FindZoneByName( ptr );
    if (!z) {
      Sendf(from, GetText(msg_unknown_zone), line);
      return;
    }
    first = z;

    if ( p )
      /* eat space */
      while(isspacechar(*p)) p++;

    /* parse second timezone */
    if (p && strlen(p)) {
      ptr = p;
      if ( ptr[0] == '\"' ) {
	ptr++;
	p=strchr( ptr, '\"' );
	if (!p) {
	  Send(from, GetText(msg_unbalanced_quote));
	  return;
	}
	*p=0;
      }
	  
      z = FindZoneByName( ptr );
      if (!z) {
	Sendf(from, GetText(msg_unknown_zone), ptr);
	return;
      }
      second = z;
    }
    else
      second = &tzinfo[0];

    h = first->hdiff - second->hdiff;
    m = first->mdiff - second->mdiff;

    if ( h )
      sprintf(tmp1, "%d %s ", abs(h),
              (abs(h) > 1) ? GetText(msg_hours) : GetText(msg_hour));
    else
      tmp1[0] = 0;

    if ( m )
      sprintf(tmp2, "%s%s%d %s ", h ? GetText(msg_and) : "", h ? " " : "",
              abs(m), GetText(msg_minutes));
    else
      tmp2[0] = 0;

    if ( h > 0 || m > 0 )
      ahead = 1;
    else
      ahead = 0;

    if ( h || m )
      Sendf(from, "%s %s %s%s%s %s.",
	    first->name, GetText(msg_is), tmp1, tmp2,
	    ahead?GetText(msg_ahead_of):GetText(msg_behind), second->name);
    else
      Sendf(from, GetText(msg_is_the_same_as),
            first->name, second->name);
  }
}




int Exchange(char *from, char *line)
{
  extern char exchangecmd[];
  char convfrom[MINIBUFFER]="";
  char convto[MINIBUFFER]="";
  char amount[MINIBUFFER];
  land *n_from;
  land *n_to;
  if(3 == sscanf(line, "%"MINIBUFFERTXT"s %"MINIBUFFERTXT"s %"MINIBUFFERTXT"s",
		 amount, convfrom, convto)) {
    if('.' == *convfrom)
      n_from=FindByCode(&convfrom[1]);
    else
      n_from=FindByCurrency(convfrom);
    if(!n_from)
      n_from = FindByCountry(convfrom);

    if('.' == *convto)
      n_to=FindByCode(&convto[1]);
    else
      n_to=FindByCurrency(convto);
    if(!n_to)
      n_to = FindByCountry(convto);
   
    if(n_from && !n_from->currency) {
      Sendf(errfrom, GetText(msg_no_currency_info), convfrom);
      return FALSE;
    }
    if(n_to && !n_to->currency) {
      Sendf(errfrom, GetText(msg_no_currency_info), convto);
      return FALSE;
    }

    Execute(from, "%s %s %s %s \"%s\" \"%s\" \"%s\" \"%s\" 2>/dev/null",
	    exchangecmd, amount,
	    n_from?n_from->currency:convfrom, n_to?n_to->currency:convto,
	    n_from?n_from->onemoney:"-", n_to?n_to->onemoney:"-",
	    n_from?n_from->country:"-",  n_to?n_to->country:"-"
	    );
/*
    fprintf(stderr, "%s %s %s %s \"%s\" \"%s\" \"%s\" \"%s\" 2>/dev/null",
	    exchangecmd, amount,
	    n_from?n_from->currency:convfrom, n_to?n_to->currency:convto,
	    n_from?n_from->onemoney:"-", n_to?n_to->onemoney:"-",
	    n_from?n_from->country:"-",  n_to?n_to->country:"-"
	    );
*/
    return FALSE;
  }
  else if(sscanf(line, "%"MINIBUFFERTXT"s %"MINIBUFFERTXT"s" ,
		 convfrom, convto)) {
    if(!strcasecmp(convfrom, "list")) {
      /* list available currencies for the exchange service */
      Execute(from, "%s list %s 2>/dev/null", exchangecmd, convto);
    }
    else {
      /* present all available information about the convfrom currency */
      if('.' == *convfrom)
	n_from=FindByCode(&convfrom[1]);
      else
	n_from=FindByCurrency(convfrom);
      if(!n_from)
	n_from = FindByCountry(convfrom);
      if(!n_from) {
	Sendf(errfrom, GetText(msg_no_country_or_currency), convfrom);
      }
      else if(!n_from->currency) {
	Sendf(errfrom, GetText(msg_no_currency_info), convfrom);
      }
      else {
	Sendf(from,
	      GetText(msg_currency_is),
	      n_from->country,
	      n_from->currency,
	      n_from->onemoney);
      }
    }
    return FALSE;
  }
  else
    return TRUE;
}

