/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 * ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing autors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjrn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/country.h,v $
 * $Revision: 1.8 $
 * $Date: 1997/04/28 16:51:14 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: country.h,v $
 * Revision 1.8  1997/04/28 16:51:14  dast
 * removed ancient header
 *
 * Revision 1.7  1997/01/11 20:35:45  dast
 * improved the tz struct to use less memory overhead
 *
 * Revision 1.6  1997/01/05 21:07:36  dast
 * added currency information
 *
 * Revision 1.5  1996/07/10 16:15:00  dast
 * Added the source header.
 *
 *
 *****************************************************************************/

#ifndef __COUNTRY_H
#define __COUNTRY_H

enum {
  eu=0, /* europe */
  as, /* asia */
  af, /* africa */
  au, /* australia */
  na, /* north america */
  sa, /* south america */
  an  /* antarctica */
};

typedef struct {
  char  continent;
  char *code;
  char *country;
  char *fullname;
  char *onemoney; /* name of one unit of the country's currency */
  char *currency; /* three-letter name of the currency */
  ulong sig;
  ulong let;  /* Marks used letters */
} land;

typedef struct {
  ulong sig;
  ulong let;
  char  *name;
  int	hdiff;
  int	mdiff;
} tz;

extern char* continents[7];
extern tz    tzinfo[328];

void CountryInit(void);
void Country(char *, char *);
land *FindByCode(char *);
land *FindByCurrency(char *);
land *FindByCountry(char *);

#endif

