#ifdef RCS
static char rcsid[]="$Id: dancer.c,v 3.6 1998/05/16 20:45:36 dast Exp dast $";
#endif
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 *  ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing authors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjorn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/dancer.c,v $
 * $Revision: 3.6 $
 * $Date: 1998/05/16 20:45:36 $
 * $Author: dast $
 * $State: Exp $
 * $Locker: dast $
 *
 * ---------------------------------------------------------------------------
 * $Log: dancer.c,v $
 * Revision 3.6  1998/05/16 20:45:36  dast
 * Chrs Larsen's __CYGWIN32__-fix
 *
 * Revision 3.5  1998/03/23 18:30:34  dast
 * Ulf Heiman's OVERRIDE_USER patch was included
 *
 * Revision 3.4  1997/11/05 21:59:25  dast
 * removed compiler warnings
 *
 * Revision 3.3  1997/08/25 17:44:25  dast
 * ints are now assigned with 0 instead of NULL
 *
 * Revision 3.2  1997/07/15 07:43:45  dast
 * Fixed a small include matter that caused a compiler error on hpux
 *
 * Revision 3.1  1997/05/28 06:08:56  dast
 * News init and cleanup functions called
 *
 * Revision 2.1  1997/05/12 16:24:17  dast
 * Made the bot timeout when the lag and last contact with server is larger
 * than 20 minutes
 *
 * Revision 1.41  1997/04/28 16:38:23  dast
 * made it support the 'config' argument
 *
 * Revision 1.40  1997/02/10 19:37:37  dast
 * gets time again after sleep()
 *
 * Revision 1.39  1997/01/27 17:03:47  dast
 * milisecond ping support added
 *
 * Revision 1.37  1997/01/11 20:39:12  dast
 * just new debug source
 *
 * Revision 1.36  1997/01/05 21:09:03  dast
 * removed stderr writing
 *
 * Revision 1.35  1996/12/11 18:31:55  dast
 * cut some of the header ;)
 *
 * Revision 1.34  1996/12/10 18:04:12  dast
 * uses the new ScanSplitServers()
 *
 * Revision 1.33  1996/12/09 18:19:24  dast
 * new autoop, new initcommmands()
 *
 * Revision 1.32  1996/12/03 17:10:20  dast
 * new server stuff
 * better error report on missing .config or .users file
 *
 * Revision 1.31  1996/12/03 16:59:54  dast
 * new sigstuff
 *
 * Revision 1.30  1996/11/27 20:42:28  dast
 * breese remade the signal system slightly
 *
 * Revision 1.29  1996/11/16 13:21:35  dast
 * now includes files.h
 *
 * Revision 1.28  1996/11/04 19:16:03  dast
 * Nicer usage of getpwuid() (by breese)
 *
 * Revision 1.27  1996/09/03 15:23:12  dast
 * Now does a WriteUsers() on cleanup
 * fixed a non-fpl #define
 *
 * Revision 1.26  1996/08/30 11:29:13  dast
 * uses the 'now' variable
 * prefix fixed
 * checks for fpl timers
 *
 * Revision 1.25  1996/08/29 08:53:02  dast
 * Uses the right #ifdef symbol
 *
 * Revision 1.24  1996/08/21 12:08:23  dast
 * better fpl integration
 *****************************************************************************/

/* (970620) previously, config.h was included here and dancer.h below all the
   system includes. This wasn't good at all since dancer.h itself includes
   config.h and it doesn't prevent multiple includes (and thus could lead to
   multiple typedef-problems). */

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>

#include "dancer.h"

#ifdef HAVE_PWD_H
#include <pwd.h>
#endif

/*#include "dancer.h"*/
#include "list.h"
#include "setup.h"
#include "server.h"
#include "netstuff.h"
#include "function.h"
#include "user.h"
#include "explain.h"
#include "seen.h"
#include "country.h"
#include "bans.h"
#include "transfer.h"
#include "parse.h"
#include "link.h"
#include "servfunc.h"
#include "regex.h"
#include "tell.h"
#include "news.h"
#include "files.h"

#ifdef HAVE_LIBFPL
#include "fplrun.h"
#else
#define runfpl(x,y)
#define fTimerCheck()
#endif


#ifdef PROFILING
extern etext();
#endif

/* --- Global ----------------------------------------------------- */

extern time_t now;

extern char channel[], expfile[];
extern char userfile[], logfile[], realname[];
extern char nickname[];
extern char myhost[];
extern bool talkative;
extern bool masterflood;
extern int numretry;
extern int netburp;

extern itemclient *client;
extern time_t lastpost;
extern int pendingpings;
extern struct timeval pongval;
extern time_t commontime;
extern bool autoop;

extern itemserv *servHead;
itemserv *currentserv;

char servername[MIDBUFFER];
char serverpasswd[MINIBUFFER] = "";
int serverport;

bool connected    = FALSE; /* Are we connected? */
bool cleanup      = FALSE;
bool restart      = TRUE; /* Restart or try next server? */
bool shuttingdown = FALSE;
bool nickflag     = TRUE;

int serverSocket  = -1;
int numUsers      = 0;
int numGuests     = 0;
int numClients    = 0;
int retry         = 0;

time_t uptime     = 0; /* not NULL, NULL is a pointer */
time_t lastevent  = 0;
time_t mastertime = 0;
time_t shutdowntime = 0;

char shutdownreason[MIDBUFFER] = "";
char shutdownby[NICKLEN+1] = "";


/* --- SloppyEvents ----------------------------------------------- */

time_t lastserverscan = 0;
time_t filesaved = 0;

void SloppyEvents()  /* Events where timing isn't critical */
{
  extern time_t lastservertime;
  snapshot;

  if (masterflood && ((now - mastertime) > netburp))
    masterflood = FALSE;

  if ( (now - lastserverscan) > 15*SECINMIN) {
    ScanSplitServers(FALSE);
    lastserverscan = now;
  }

  if ( connected && (!pendingpings) && (now - pongval.tv_sec > PINGDELAY) )
    PingServer();

  if( connected &&
      (now - pongval.tv_sec > 20*SECINMIN) &&
      (now - lastservertime > 20*SECINMIN)
      ) {
    /* X minutes since last server-PONG and
       Y minutes since last line was received */
    Debug("Lost contact with server");
    restart = cleanup = TRUE;
  }

  /* Periodically save important files */
  if ( (now - filesaved) > 2*SECINHOUR ) {
    SeenSave();
    /*TellSave();*/
    BanSave();
    WarnSave();
    WriteUsers();
    filesaved = now;
  }
  
  /* Try to connect to server for two minutes max */
  if ( !connected && ((now - lastevent) > 2*SECINMIN) ) {
    if (retry < numretry) {
      retry++;
      sleep(retry);
      cleanup = restart = TRUE;
    } else {
      Debug("Timeout while trying to connect to server");
      restart = FALSE;
      cleanup = TRUE;
    }
  }

  /* Idle talk */
#if 0
  if (talkative && numGuests > 2 && (now - lastpost > 30*SECINMIN))
    Say(GIMMEPICK(MSG_IDLE_1, 6));
  /* removed since I doubt anyone enjoys these, Bagder 960320 */
#endif
  if(autoop)
    CheckForAutoOp();
}

/* --- TimeEvents ------------------------------------------------- */

time_t bantime = 0;

void TimeEvents(void)  /* Events where timing is critical */
{
  static cnt = 0;
  snapshot;

  CheckLinkQueue();
  MessageQueue();

  /* Shutdown */
  if ( shuttingdown && (now >= shutdowntime) )
    Quit(shutdownby, shutdownreason);

  if ( (now - bantime) > 5) {
    BanTimeout();
    bantime = now;
  }

  fTimerCheck();

  if ( (cnt++ % TIMERCHK) == 0 )
    SloppyEvents();
}

/* --- Hello ------------------------------------------------------ */

/* Introduce ourselves to the server */

void Hello(itemserv *serv)
{
  char *uname;
#ifdef HAVE_PWD_H
  struct passwd *pw;
#endif

  snapshot;
  connected = FALSE;
  /* Recommended order is PASS, NICK, then USER */
  if (*serverpasswd)
    WriteServer("PASS %s", serverpasswd);
  NewNick();
  WriteServer("NICK %s", nickname);
#ifdef HAVE_PWD_H
  pw = getpwuid(getuid());
  if (pw)
    uname = pw->pw_name;
  else /* getenv() below */
#endif
    uname = getenv("LOGNAME");

#if defined(OVERRIDE_USER) || defined(__CYGWIN32__)
  if(getenv("BOTUSER") != NULL)
    uname = getenv("BOTUSER");
#endif

  /* Client cannot provide host and server, but we're just being nice */
  WriteServer("USER %s %s %s :%s", (uname ? uname : "bot"),
              myhost, servername, (realname ? realname : "An IRC bot"));
  if(!serv)
    serv = FindServ(servername, serverport);
  ConnectServ(serv); /* report "we're connected" */
}

/* --- Start ------------------------------------------------------ */

/*
 * Returns whether the next server should be tried.
 */
bool Start(itemserv *serv)
{
  snapshot;

  strcpy(servername, serv->s.name);
  serverport = serv->s.port;
  strcpy(serverpasswd, serv->s.passwd?serv->s.passwd:"");

#if 0
  /* Check valid chars in RFC952 */
  switch (sscanf(server, "%[a-zA-Z0-9.-]%*[ :]%d%*[ :]%[^\n]",
                 servername, &serverport, serverpasswd) ) {
  case 0:
    return TRUE; /* No server, let's try the next */
  case 1:
    serverport = IRCPORT;
    *serverpasswd = NIL;
    break;
  case 2:
    *serverpasswd = NIL;
    break;
  default:
    break;
  }
#endif

  if ( (serverSocket = OpenServerConnection(servername, serverport)) != -1 ) {
  
    lastevent = time(NULL);
    Logf(LOG, "Connected to %s on port %d", servername, serverport);    
    Logf(LOG, "Logfile for %s started", channel);
    Hello(serv);
    EventLoop();

    return !restart;

  }

  return TRUE;
}


/* --- SigCatch --------------------------------------------------- */

const char *GetSigName(int sigtype)
{
  switch (sigtype) {
#ifdef SIGSEGV
  case SIGSEGV:
    return "SIGSEGV";
#endif
#ifdef SIGBUS
  case SIGBUS:
    return "SIGBUS";
#endif
#ifdef SIGPIPE
  case SIGPIPE:
    return "SIGPIPE";
#endif
#ifdef SIGQUIT
  case SIGQUIT:
    return "SIGQUIT";
#endif
#ifdef SIGINT
  case SIGINT:
    return "SIGINT";
#endif
#ifdef SIGTERM
  case SIGTERM:
    return "SIGTERM";
#endif
#ifdef SIGKILL
  case SIGKILL:
    return "SIGKILL";
#endif
  default:
    return "UNKNOWN";
  }
}

void SigCatch(int sigtype)
{
  Debug("Received signal %d (%s)", sigtype, GetSigName(sigtype));
  switch (sigtype) {
#ifdef SIGBUS
  case SIGBUS:
#endif
#ifdef SIGSEGV
  case SIGSEGV:
#endif
#ifdef SIGTERM
  case SIGTERM:
#endif
#ifdef SIGINT
  case SIGINT:
#endif
#ifdef SIGKILL
  case SIGKILL:
#endif
#ifdef SIGQUIT
  case SIGQUIT:
#endif
#if defined(SIGSEGV) || defined(SIGBUS) || defined(SIGTERM) || defined(SIGINT) || defined(SIGKILL) || defined(SIGQUIT)
    restart = FALSE;
    cleanup = TRUE;
    /* Install default signal handler to avoid race conditions */
    signal(sigtype, SIG_DFL);
    break;
#endif

#ifdef SIGPIPE
  case SIGPIPE:
    if ( !Alive(serverSocket)  ) {
      restart = FALSE;
      cleanup = TRUE;
    }
    if (client) {
      Debug("Broken pipe from %s", client->ident->userdomain);
      RemoveClient(client);
      client = NULL;
    }
    signal(sigtype, SigCatch);
    break;
#endif

  default:
    break;
  }
}

/* --- InitSignals ------------------------------------------------ */

void InitSignals(void)
{
#ifdef SIGQUIT
  signal(SIGQUIT, SigCatch);  /* CTRL-| */
#endif
#ifdef SIGBUS
  signal(SIGBUS,  SigCatch);  /* Bus error */
#endif
#ifdef SIGKILL
  signal(SIGKILL, SigCatch);  /* Kill (cannot be ignored) */
#endif
#ifdef SIGPIPE
  signal(SIGPIPE, SigCatch);  /* Write on a pipe with no one to read it */
#endif
#ifdef SIGINT
  signal(SIGINT,  SigCatch);  /* CTRL-C */
#endif
#ifdef SIGSEGV
  signal(SIGSEGV, SigCatch);  /* Segmentation violation */
#endif
#ifdef SIGTERM
  signal(SIGTERM, SigCatch);  /* Software termination signal from kill */
#endif

  /* Ignore the rest */

#ifdef SIGHUP
  signal(SIGHUP,  SIG_IGN);   /* Hangup */
#endif
#ifdef SIGTSTP
  signal(SIGTSTP, SIG_IGN);   /* CTRL-Z (stop signal from tty) */
#endif
#ifdef SIGSTOP
  signal(SIGSTOP, SIG_IGN);   /* Sendable stop signal not from tty */
#endif
#ifdef SIGABRT
  signal(SIGABRT, SIG_IGN);   /* abort(3) */
#endif
}

/* --- Cleanup ---------------------------------------------------- */

void Cleanup(void)
{
  Log(LOG, "Cleanup");
  DeleteGuests();
  FlushMessages();
  BanDisable();
  if (restart) {
    cleanup = FALSE;
    CleanupNet();
  } else {
    CleanupNet();
    LinkQuit();
    TellCleanup();
    SeenCleanup();
    ExplainCleanup();
    UsersCleanup();
    ConfigCleanup();
    BanCleanup();
    KickCleanup();
    WarnCleanup();
    ServCleanup();
    NewsCleanup();
    Log(LOG, "Exit");
    exit(0);
  }
}

/* --- InitTime --------------------------------------------------- */

void InitTime(void)
{
  snapshot;
  uptime = time(NULL);
  lastevent = lastpost = lastserverscan = filesaved = bantime = commontime = uptime;
}

/* --- main ------------------------------------------------------- */

int main(int argc, char *argv[])
{
  itemserv *serv;
  char pid[128];
  int configok;

  snapshot;
  now = time(NULL);
  sprintf(pid, "echo %d > .pid", (int)getpid());
  system(pid);

  InitSignals();

  /* Any background process should be made nice */
  nice(NICE);

#ifdef PROFILING
  monstartup(2, etext);
#endif

  re_syntax_options |= RE_NO_BK_VBAR | RE_NO_BK_PARENS;

  InitCommands(); /* must be done prior to new command levels */

  configok = ConfigInit();

  if(argc>1 && !strncasecmp(argv[1], "conf", 4)) {
    MakeConfig();
    exit(1);
  }
  
  if ( configok ) {

    UsersInit();
    if ( ReadUserfile(userfile) ) {

      InitTime();
      InitRandom(uptime);
      InitLog();
      InitNet();
      SeenInit();
      InitExplain(expfile);
      TellInit();
      CountryInit();
      BanInit();
      KickInit();
      WarnInit();
      FuncInit();
      PatternInit();
      InitServ();
      NewsInit();

#ifdef HAVE_LIBFPL
      initfpl();
#endif

      Log(LOG, "Started " VERSIONMSG );

      snapshot;
      for (serv=(itemserv *)Succ(servHead); serv && restart;
           serv=(itemserv *)Succ(serv)) {
	if(serv->s.flags & SERV_DISABLED) {
	  /* server made disabled, please continue */
	  Logf(LOG, "Server %s is disabled", serv->s.name);
	  continue;
	}
        retry = 0; /* try enough number of times */
        do {
          cleanup = FALSE;
          if(!Start(serv)) {
            /* This means it exited properly. */
            break;
          }
          if(!restart)
            break;
          if (++retry >= numretry) {
            Logf(LOG, "Unable to connect to %s on port %d (tried %d times)",
                 servername, serverport, retry);
            break;
          }
          /* try again! */
          sleep(retry);
          now = time(NULL);
        } while(1);
        if(restart) {
          /* We should loop, cleanup! */
          Cleanup();
        }
        /* now, try next server or exit */
      }
      restart = FALSE;
      cleanup = TRUE;
      Cleanup();
    }
    else {
      Logf(LOG, "Userfile \"%s\" not found!", userfile);
    }
  }
  else {
    Logf(LOG, CONFIGFILE " not found!");
  }
  restart = FALSE;
  Cleanup();

  return 0;
}
