/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 *  ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing authors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjorn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/flood.h,v $
 * $Revision: 1.6 $
 * $Date: 1997/01/05 21:12:53 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: flood.h,v $
 * Revision 1.6  1997/01/05 21:12:53  dast
 * changed multicheck proto
 *
 * Revision 1.5  1996/08/30 11:29:13  dast
 * improved a defined
 *
 * Revision 1.4  1996/08/20 14:33:36  dast
 * new alertmode support
 *
 * Revision 1.3  1996/08/06 10:52:43  dast
 * AlertMode stuff
 *
 * Revision 1.2  1996/07/26 11:34:58  dast
 * breese clean up
 *
 * Revision 1.1  1996/07/18 13:51:50  dast
 * Initial revision
 *
 *
 *****************************************************************************/
#ifndef __FLOOD_H
#define __FLOOD_H

#include "dancer.h"
#include "user.h"

/* This define sets the *longest* interval accepted between two failed sitebans
   to trigger the RED alert situation. RED alert will most likely set the
   channel +i */
#define TRIGGER_RED_ALERT (10*SECINMIN) 

typedef enum {
  ALERT_NONE,
  ALERT_ON,
  ALERT_OFF,
  ALERT_RED,
  ALERT_LAST
} Alert;

int AlertMode(Alert);

bool Warning(itemguest *, char *, char *);
void FloodCheck(itemguest *);
void Check(itemguest *, char *);
void RepeatCheck(itemguest *, char *);
void AvalanceCheck(itemguest *, char *);
bool CTCPFloodCheck(itemguest *, bool);
void MultiCheck(char *domain);

#endif

