#ifdef RCS
static char rcsid[]="$Id: fplrun.c,v 2.4 1998/04/14 11:29:14 dast Exp $";
#endif
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 *  ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing authors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjorn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/fplrun.c,v $
 * $Revision: 2.4 $
 * $Date: 1998/04/14 11:29:14 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: fplrun.c,v $
 * Revision 2.4  1998/04/14 11:29:14  dast
 * Implemented Do()
 *
 * Revision 2.3  1998/02/14 11:33:21  dast
 * amiga adjusted by tero
 *
 * Revision 2.2  1998/01/26 17:20:39  dast
 * LAB_PATCH patch
 *
 * Revision 2.1  1997/11/05 22:00:56  dast
 * updated
 *
 * Revision 1.11  1997/08/25 17:45:02  dast
 * UserInfo() is revised and improved a lot
 *
 * Revision 1.10  1996/12/16 18:19:52  dast
 * TimeToSec() added
 *
 * Revision 1.9  1996/12/11 18:34:21  dast
 * label cleanup function
 *
 * Revision 1.8  1996/11/04 19:16:47  dast
 * compiles without HAVE_LIBFPL
 *
 * Revision 1.7  1996/09/05 06:02:22  dast
 * removed a few hooks
 *
 * Revision 1.6  1996/09/03 15:24:30  dast
 * the label systems seem to work ok now
 *
 * Revision 1.5  1996/08/30 11:29:13  dast
 * fixed TimerAdd() and TimerKill()
 *
 ****************************************************************************/
#include "config.h"

#ifdef HAVE_LIBFPL

#include <string.h>
#include <ctype.h>

#include "FPL.h"
#include "FPL_protos.h"

#include "dancer.h"
#include "list.h"
#include "transfer.h"
#include "user.h"
#include "function.h"
#include "fplrun.h"

extern char cmodes[], chanmodes[], ckey[], chankey[];
extern char channel[], nickname[], servername[];

extern int numGuests;
extern itemident *current;
extern char channel[];
extern itemguest *guestHead;
extern itemsplit *splitHead;
extern itemuser *userHead;
extern bool botop;

itemfpl *fplentry[RUN_LAST][2];

static void *key; /* FPL anchored data */

itemfplcmd *fcmdHead;
itemtimefpl *timefplHead;
itemlabel *labelHead;

bool Cancel=FALSE; /* cancel the rest of the fpl chained invokes */


struct fpldata {
  char *label;
  runitem item;
};

struct fpldata fplcfg[]=
{
  {"action",  RUN_ACTION }, /* done */
  {"ctcppriv",RUN_CTCPPRIV}, /* done */
  {"ctcppub", RUN_CTCPPUB}, /* done */
  {"dcc",     RUN_DCC },
  {"init",    RUN_INIT},   /* done */
  {"input",   RUN_INPUT },
  {"invite",  RUN_INVITE}, /* done */
  {"join",    RUN_JOIN}, /* done */
  {"kick",    RUN_KICK}, /* done */
  {"kickbot", RUN_KICKBOT}, /* done */
  {"leave",   RUN_LEAVE}, /* done */
  {"mode",    RUN_MODE},
  {"msg",     RUN_MSG },
  {"nick",    RUN_NICK}, /* done */
  {"numeric", RUN_NUMERIC}, /* done */
  {"offmsg",  RUN_OFFMSG}, /* done */
  {"public",  RUN_PUBLIC },/* done */
  {"signoff", RUN_QUIT}, /* done */
  {"topic",   RUN_TOPIC}, /* done */

  {"send_action",   RUN_SEND_ACTION},
  {"send_dcc_chat", RUN_SEND_DCC_CHAT},
  {"send_msg",      RUN_SEND_MSG},
  {"send_notice",   RUN_SEND_NOTICE},
  {"send_public",   RUN_SEND_PUBLIC},

  {"connect",    RUN_CONNECT}, /* done */
  {"disconnect", RUN_DISCONNECT}, /* done */
  {"error",      RUN_ERROR}, /* done */

  {"alertmode", RUN_ALERTMODE},
  {"alert",   RUN_ALERT}, /* done */
  {"flood",   RUN_FLOOD},
  
  {"nethack",  RUN_NETHACK},
  {"netsplit", RUN_NETSPLIT},
  {"nethead",  RUN_NETHEAD},
  {"netleave", RUN_NETLEAVE},
  {"netjoin",  RUN_NETJOIN},

};

void fpladditem(runitem item,
                char which,
                char *prog,
                char *regex)
{
  itemfpl *f;
  if(!fplentry[item][(int)which])
    fplentry[item][(int)which]=CreateList(sizeof(itemfpl));
  if((f = (itemfpl *)NewEntry(sizeof(itemfpl)))) {
    AddTail(fplentry[item][(int)which], f);
    f->prog=strdup(prog);
    f->regex=regex[0]?strdup(regex):NULL;
  }
}


void LabelInit(void)
{
  labelHead = (itemlabel*)CreateList(sizeof(itemlabel));
}

itemlabel *LabelFind(char *name)
{
  itemlabel *l;
  if(labelHead) {
    for(l=(itemlabel *)Succ(labelHead); l; l=(itemlabel *)Succ(l)) {
      if(!strcasecmp(name, l->name)) {
        return l;
      }
    }
  }
  return NULL;
}

void static refinelabel(itemuserlabel *head, char *name, itemlabel *label)
{
  itemuserlabel *ul;
  if(head) {
    for(ul = Succ(head); ul; ul=Succ(ul)) {
      if(ul->name && !strcasecmp(ul->name, name)) {
        ul->label = label;
        free(ul->name);
        if(!(label->flags&LAB_STRING)) {
          int val=atoi(ul->cont.str);
          free(ul->cont.str);
          ul->cont.val = val;
        }
        ul->name=NULL;
      }
    }
  }

}

int LabelDefine(char *name, int flags, void *def)
{
  itemlabel *l;
  itemguest *g;
  itemuser *u;
  itemsplit *p;
  if(LabelFind(name))
    return 1;
  l = (itemlabel *)NewEntry(sizeof(itemlabel));
  if(l) {
    AddTail(labelHead, l);
    l->name = strdup(name);
    l->flags = flags;
    if(flags&LAB_STRING)
      l->def.str=strdup((char *)def);
    else
      l->def.val=(int)def;

    /*
     * We must now scan all users to see if they use this stuff properly.
     * Guests+users.
     */
    for (g=Succ(guestHead); g; g=Succ(g))
      refinelabel(g->ident->label, name, l);

    for (p=Succ(splitHead); p; p=Succ(p))
      refinelabel( g->ident->label, name, l);

    for (u=Succ(userHead); u; u=Succ(u))
      refinelabel(u->label, name, l);

  }
  return 0;
}

static void freeuserlabel(void *v)
{
  itemuserlabel *l=(itemuserlabel *)v;
  if(l) {
    if(l->name)
      free(l->name);
    if(l->label->flags&LAB_STRING)
      free(l->cont.str);
  }
}

void LabelCleanup(void *v)
{
  itemuserlabel **ulabel=(itemuserlabel **)v;
  if(*ulabel) {
    DestroyList((void **)ulabel, freeuserlabel);
  }
}

void UserlabelRead(char *name, itemuserlabel *ulabel)
{
  itemuserlabel *l=NULL;
  itemlabel *lab;
  if(ulabel) {
    for(l=(itemuserlabel *)Succ(ulabel); l; l=(itemuserlabel *)Succ(l)) {
      if(!strcasecmp(name, l->label->name))
        break;
    }
  }
  if(l) {
    if(l->label->flags&LAB_STRING)
      fplSendTags(key, FPLSEND_STRING, l->cont.str, FPLSEND_DONE);
    else
      fplSendTags(key, FPLSEND_INT, l->cont.val, FPLSEND_DONE);
    return;
  }
  lab = LabelFind(name);
  if(lab) {
    if(lab->flags&LAB_STRING)
      fplSendTags(key, FPLSEND_STRING, lab->def.str, FPLSEND_DONE);
    else
      fplSendTags(key, FPLSEND_INT, lab->def.val, FPLSEND_DONE);
  }
  return;
}

void UserlabelSet(char *name, void *set, int flags, itemuserlabel **ulabel)
{
  itemuserlabel *l=NULL;
  itemlabel *lab;
  if(*ulabel) {
    for(l=(itemuserlabel *)Succ(*ulabel); l; l=(itemuserlabel *)Succ(l)) {
      if(!strcasecmp(name, l->label->name))
        break;
    }
  }
  if(!l) {
    lab = LabelFind(name);

    if(!*ulabel)
      *ulabel = (itemuserlabel*)CreateList(sizeof(itemuserlabel));

    l = (itemuserlabel *)NewEntry(sizeof(itemuserlabel));
    if(l) {
      AddTail(*ulabel, l);
      if(lab)
        l->label = lab;
      else
        l->name = strdup(name);

      if(flags&LAB_STRING)
        l->cont.str=strdup((char *)set);
      else
        l->cont.val=(int)set;
    }
  }
  else {
    if(l->label->flags&LAB_STRING) {
      free(l->cont.str);
      l->cont.str=strdup((char *)set);
    }
    else
      l->cont.val = (int)set;
  }
}

void fTimerInit(void)
{
  timefplHead = (itemtimefpl *)CreateList(sizeof(itemtimefpl));
}

int fTimerAdd(int timeout,
              char *fpl)              
{
  itemtimefpl *f;
  f = (itemtimefpl *)NewEntry(sizeof(itemtimefpl));
  if(f) {
    AddTail(timefplHead, f);
    f->fpl = strdup(fpl);
    f->timeout = time(NULL)+timeout;
  }
  return (int)f;
}

void FreefTimer(void *v)
{
  itemtimefpl *f=(itemtimefpl *)v;
  if(f) {
    free(f->fpl);
  }
}

int fTimerCheck(void)
{
  int now = time(NULL);
  itemtimefpl *f;
  if(timefplHead) {
    for(f=(itemtimefpl *)Succ(timefplHead); f; f=(itemtimefpl *)Succ(f)) {
      if(now >= f->timeout) {
        fplrunner(f->fpl, "");
        DeleteEntry(timefplHead, f, FreefTimer); /* removed */
        return 1;
      }
    }
  }
  return 0;
}

void fTimerCleanup(void)
{
  DestroyList((void **)&timefplHead, FreefTimer);
}

int fTimerKill(int i)
{
  int now = time(NULL);
  itemtimefpl *check=(itemtimefpl *)i;
  itemtimefpl *f;
  if(timefplHead) {
    for(f=(itemtimefpl *)Succ(timefplHead); f; f=(itemtimefpl *)Succ(f)) {
      if(check == f) {
        now = f->timeout-now;
        DeleteEntry(timefplHead, f, FreefTimer); /* removed */
        return now;
      }
    }
  }
  return 0;
}

void fCmdInit(void)
{
  fcmdHead = (itemfplcmd *)CreateList(sizeof(itemfplcmd));
}

/*

 int CmdAdd(string name,   // name of new command, preferable specified in
                           // uppercase like the rest of the commands
                           //  NO, you can't add aliases to this one.
            int level,     // level required for use
            string syntax, // syntax string
            string help,   // help string
            string flags,  // flags as below
            string fpl)    // complete FPL program to run at invoke in full
                           // fpl-invoke style with %-support

 the flags are strings separated with a '|' letter. Available flags are:
   showable  - Output can be redirected to another person
   passwd    - Password protected
   needcomma - Comma is part of argument, not argument seperator
   public    - Command can be used in public

 Example:

  CmdAdd("TEST",
         10,
         "[nick]",
         "tests <nick>",
         "passwd|public",    // publicly available and require password
         "mytestfpl(%i);")); // this function must be exported prior to the
                             // invoke
*/

int fCmdAdd(char *name,
            int level,
            char *syntax,
            char *help,
            char *flags,
            char *fpl)
{
  itemfplcmd *f;
  f = (itemfplcmd *)NewEntry(sizeof(itemfplcmd));
  if(f) {
    AddTail(fcmdHead, f);
    f->fpl = strdup(fpl);
    f->help = strdup(help);
    f->command.name = strdup(name);
    f->command.level = level;
    f->command.showable = strstr(flags, "show")?TRUE:FALSE;
    f->command.needpass = strstr(flags, "pass")?TRUE:FALSE;
    f->command.needcomma = strstr(flags, "needc")?TRUE:FALSE;
    f->command.public = strstr(flags, "public")?TRUE:FALSE;
    f->command.syntax = strdup(syntax);
  }
  return 0;
}

void FreefCmd(void *v)
{
  itemfplcmd *f=(itemfplcmd *)v;
  if(f) {
    free(f->fpl);
    free(f->help);
    free(f->command.name);
    free(f->command.syntax);
  }
}

void fCmdCleanup(void)
{
  DestroyList((void **)&fcmdHead, FreefCmd);
}

itemfplcmd *fCmdFind(char *name)
{
  itemfplcmd *f;
  if(fcmdHead) {
    for(f=(itemfplcmd *)Succ(fcmdHead); f; f=(itemfplcmd *)Succ(f)) {
      if(!strcasecmp(name, f->command.name))
        return f;
    }
  }
  return NULL;
}

long fplinterface(struct fplArgument *arg)
{
  int retcode=0;
  int *retpnt=NULL;
  itemident *ident;
#if defined(LAB_PATCH)
  itemuserlabel **iulabel;
#endif
  int flags;
  switch(arg->ID) {
  case FPR_ACTION:
    Action(arg->argv[0]);
    break;
  case FPR_CANCEL:
    retcode=Cancel;
    retpnt = &retcode;
    if(arg->argc)
      Cancel=(int)arg->argv[0];
    else
      Cancel=TRUE;
    break;
  case FPR_CHANINFO:
    if(!strcasecmp((char *)arg->argv[0], "guests")) {
      retcode = numGuests;
      retpnt = &retcode;
    }
    break;
  case FPR_CMDADD:
    fCmdAdd(arg->argv[0],
            (int)arg->argv[1],
            arg->argv[2],
            arg->argv[3],
            arg->argv[4],
            arg->argv[5] );
    break;

  case FPR_DO:
    WriteServer("%s", arg->argv[0]);
    break;

  case FPL_GENERAL_ERROR:
    {
      char buffer[FPL_ERRORMSG_LENGTH];
      int col;
      char *name;
      fplSendTags(key,
		  FPLSEND_GETVIRLINE, &col,
		  FPLSEND_GETVIRFILE, &name,
		  FPLSEND_DONE);
      Logf(LOGDBUG, "[FPL] '%s' => Line %d in file \"%s\"\n",
           fplGetErrorMsg(key, (long)arg->argv[0], buffer),
           col, name?name:"unknown");
    }
    break;
    /* not documented: */
  case FPR_GETUSER:
    retcode = User2ID((char *)arg->argv[0], arg->argc>1?arg->argv[1]:"");
    retpnt = &retcode;
    break;
  case FPR_HOOK:
    {
      int which = FPLRUN_PRE;
      int i;
      if(arg->argc>3)
        which = strcasecmp((char *)arg->argv[3], "post")?
          FPLRUN_PRE:FPLRUN_POST;

      for(i=0; i<sizeof(fplcfg)/sizeof(fplcfg[0]); i++) {
        if(!strcasecmp((char *)arg->argv[0], fplcfg[i].label)) {  /* match */
          fpladditem(fplcfg[i].item,
                     which,
                     (char *)arg->argv[2],  /* program to run */
                     (char *)arg->argv[1]); /* regex */
          i=-1;
          break;
        }
      }
      retcode=i>=0?1:0;
      retpnt = &retcode;
    }
    break;
  case FPR_JOIN:
    if(arg->argc) {
      if(strlen(arg->argv[0]))
        strcpy(channel, arg->argv[0]);
      if(arg->argc>1)
        strcpy(chankey, arg->argv[1]);
    }
    WriteServer("JOIN %s %s", channel, chankey);
    break;
  case FPR_KICK:
    Kick(arg->argv[0], arg->argv[1]);
    break;
  case FPR_LABDEFINE:
    flags = LAB_DEFINED;
    flags |= strstr((char *)arg->argv[1], "save")?LAB_SAVE:0;
    flags |= strstr((char *)arg->argv[1], "solo")?LAB_SOLO:0;
    flags |= strstr((char *)arg->argv[1], "str")?LAB_STRING:0;
    if('S' == arg->format[2])
      flags |= LAB_STRING;
    LabelDefine((char *)arg->argv[0], flags, arg->argv[2]);
    break;
  case FPR_LABREAD:
#if defined(LAB_PATCH)
    iulabel = NULL;
    if(arg->argc>1) {
      iulabel = (itemuserlabel **)ID2Label((int)arg->argv[1]);
    }
    if(!iulabel)
      iulabel = (itemuserlabel **)&current->label;
    UserlabelRead(arg->argv[0], (itemuserlabel *)*iulabel);
#else
    ident = NULL;
    if(arg->argc>1) {
      ident = ID2Ident((int)arg->argv[1]);
    }
    if(!ident)
      ident = current;
    UserlabelRead(arg->argv[0], ident->label);
#endif
    break;
  case FPR_LABSET:
#if defined(LAB_PATCH)
    iulabel = NULL;
    if(arg->argc>2) {
      iulabel = (itemuserlabel **)ID2Label((int)arg->argv[2]);
    }
    if(!iulabel)
      iulabel = (itemuserlabel **)&current->label;
    UserlabelSet(arg->argv[0], arg->argv[1],
		 'S' == arg->format[1]?LAB_STRING:0, 
		 (itemuserlabel **)iulabel);
#else
    ident = NULL;
    if(arg->argc>2) {
      ident = ID2Ident((int)arg->argv[2]);
    }
    if(!ident)
      ident = current;
    UserlabelSet(arg->argv[0], arg->argv[1],
                 'S' == arg->format[1]?LAB_STRING:0, 
                 (itemuserlabel **)&ident->label);
#endif
    break;
  case FPR_LEAVE:
    WriteServer("PART %s", channel);
    break;
  case FPR_MATCH:
    retcode = Match(arg->argv[0], arg->argv[1]);
    retpnt = &retcode;
    break;
  case FPR_OUTPUT:
    fputs(arg->argv[0], stderr);
    break;
  case FPR_RANDOM:
    retcode = (int)(Rnd()*(int)arg->argv[0]);
    retpnt = &retcode;
    break;
  case FPR_REGEX:
    retcode = PatternExist(arg->argv[0], arg->argv[1]);
    retpnt = &retcode;
    break;
  case FPR_RUNFILE:
    retcode=fplExecuteFile(key, arg->argv[0], NULL);
    retpnt=&retcode;
    break;
  case FPR_SAY:
    Say(arg->argv[0]);
    break;
  case FPR_SEND:
    Send(arg->argv[0], arg->argv[1]);
    break;
  case FPR_TIMERADD:
    retcode = fTimerAdd((int)arg->argv[0],
                        arg->argv[1]);
    retpnt = &retcode;
    break;
  case FPR_TIMERKILL:
    retcode = fTimerKill((int)arg->argv[0]);
    retpnt = &retcode;
    break;
  case FPR_TIME2SECS:
    retcode = ToSeconds((char *)arg->argv[0]);
    retpnt = &retcode;
    break;
  case FPR_USERINFO:
    {
      itemguest *g=FindNick((char *)arg->argv[0]);
      if(g) {
        if(!strcasecmp((char *)arg->argv[1], "level"))
          retcode = g->ident->level;
        else if(!strcasecmp((char *)arg->argv[1], "ircop"))
          retcode = g->flags.ircop?1:0;
        else if(!strcasecmp((char *)arg->argv[1], "voice"))
          retcode = g->flags.voice?1:0;
        else if(!strcasecmp((char *)arg->argv[1], "chanop"))
          retcode = g->flags.chanop?1:0;
        else
          retcode = -1;
      }
      else
        retcode = -1;
      retpnt = &retcode;
    }
    break;
  case FPR_BOTINFO:
    if (!strcasecmp((char *)arg->argv[0], "chanop")) {
      retcode = botop ? 1 : 0;
      retpnt = &retcode;
    }
    else if (!strcasecmp((char *)arg->argv[0], "nick"))
      fplSendTags(key, FPLSEND_STRING, nickname, FPLSEND_DONE);
    break;
  case FPR_MODE:
    Mode("%s", arg->argv[0]);
    break;
  }
  if(retpnt) {
    fplSendTags(key, FPLSEND_INT, retcode, FPLSEND_DONE);
  }
  return FPL_OK;
}


int fplrunner(char *prog, char *input)
{
  char fplprog[BIGONE];
  void *array[MAX_ARGS];
  char *empty="";
  int argc=0;
  char *origline=strdup(prog);
  if(!origline)
    return 0;
  prog = origline;
  while(prog) {
    prog = strchr(prog, '%');
    if(prog) {
      switch(*++prog) {
      case '%': /* just a % */
        break;
      default:
        /* make this an empty string */
        array[argc++]=empty;
        *prog = 's'; /* string */
        break;
      case 'i':
        array[argc++]=input;
        *prog='s';
        break;
      case 'n':
        array[argc++]="botnick";
        *prog='s';
        break;
      case 'u':
	if (current)
	  array[argc++]=current->nick;
	else
	  array[argc++]="unknown";
        *prog='s';
        break;
      case 'c':
        array[argc++]=channel;
        *prog='s';
        break;
      case 't':
        array[argc++]=(void *)time(NULL);
        *prog='d'; /* integer */
        break;
      }
      prog++;
    }
  }
  vsprintf(fplprog, origline, array);
  free(origline);
  
  fprintf(stderr, "%s\n", fplprog);
  {
    char *program1 = fplprog;
    fplExecuteScriptTags(key, &program1, 1, FPLTAG_DONE);
  }
  return 0;
}

int runfpl(runitem item, char *line, char which)
{
  itemfpl *f;
  bool match=FALSE;
  Cancel=FALSE;

  if(!fplentry[item][(int)which])
    /* no list on this item */
    return 0;

  /* first check condition with the line parameter */
  for(f=Succ(fplentry[item][(int)which]); !Cancel && f; f=Succ(f)) {
    if(f->regex && f->regex[0]) {
      if(PatternExist(line, f->regex)) {
        match=TRUE;
      }
    }
    else {
      match = TRUE; /* no regex equals match */
    }
    if(match) {
      fplrunner(f->prog, line);
      match=FALSE;
    }
  }
  
  return Cancel; /* cancelled state */
}

void FPLAddItem(char *line)
{
  char keyword[25];
  char towhat[1024];
  char *prog;
  char regex[512];
  int i;
  char post=0;
  if('+' == *line) {
    post=TRUE;
    line++;
  }
  if (2 <= sscanf(line, "%23[a-zA-Z0-9.] %*[=: ] %1022[^\n]",
                  keyword, towhat)) {
    prog=towhat;
    regex[0]=0;
    if('\"' == *prog) {
      prog++;
      sscanf(prog, "%510[^\"]", regex);
      prog += strlen(regex)+1; /* to avoid %n */
    }
    else {
      sscanf(prog, "%510s", regex);
      prog += strlen(regex); /* to avoid %n */
    }
    while(isspace(*prog))
      prog++;
    for(i=0; i<sizeof(fplcfg)/sizeof(fplcfg[0]); i++) {
      if(!strcasecmp(keyword, fplcfg[i].label)) {  /* match */
        fpladditem(fplcfg[i].item, post?FPLRUN_POST:FPLRUN_PRE, prog, regex);
      }
    }
  }
}

#if defined(AMIGA) && !defined(__GNUC__)
struct Library *FPLBase;
#endif

void fplCleanup(void)
{
  if(key) {
    fplFree(key); /* clean up fpl usage */
    fCmdCleanup(); /* clean away fpl-added commands */

#if defined(AMIGA) && !defined(__GNUC__)
    CloseLibrary(FPLBase);
#endif
  }
}

struct fffpl {
  char *name;
  fplfunction func;
  char retcode;
  char *param;
};

int initfpl(void)
{
  char line[MAXLINE];
  extern char fplconf[];
  FILE *in;
  int i;

  struct fffpl cmds[]= {
    {"Action",  FPR_ACTION,  'I', "S"}, /* /me in channel */
    {"Ban",     FPR_BAN,     'I', "S"},  /* nick, *nick or pattern */
    {"BanInfo", FPR_BANINFO, 'O', "So"},   /* info, <new value> */
    {"BotInfo", FPR_BOTINFO, 'O', "So"},   /* info, <new value> */
    {"Cancel",  FPR_CANCEL,  'I', "i"},   /* 1-cancel, 0-don't */
    {"ChanInfo", FPR_CHANINFO, 'I', "S"},  /* info */
    {"CmdAdd",  FPR_CMDADD,   'I', "SISSSS"},
    {"Do",      FPR_DO,      'I', "S"},
    {"GetUser", FPR_GETUSER, 'I', "Ss"}, /* nick, <flags> */
    {"Hook",    FPR_HOOK,    'I', "SSSs"}, /* name, regex, program, [pre/post] */
    {"Join",    FPR_JOIN,    'I', "ss"},  /* channel (or default channel if not
                                             specified), chankey */
    {"Kick",    FPR_KICK,    'I', "SS"}, /* nick, message */
    {"LabelDefine", FPR_LABDEFINE, 'I', "Sso"},
    {"LabelRead", FPR_LABREAD, 'O', "Si"},
    {"LabelSet", FPR_LABSET, 'I', "SOi"},
    {"Leave",   FPR_LEAVE,   'I', NULL}, /* just leave current channel */
    {"Match",   FPR_MATCH,   'I', "SS"},  /* string, wildcard */
    {"Output",  FPR_OUTPUT,  'I', "S"}, /* to stderr */
    {"Regex",   FPR_REGEX,   'I', "SS"},  /* string, regex */
    {"Rnd",     FPR_RANDOM,  'I', "I"},   /* max value */
    {"Runfile", FPR_RUNFILE, 'I', "S"}, /* file name */
    {"Say",     FPR_SAY,     'I', "S"}, /* string */
    {"Send",    FPR_SEND,    'I', "SS"}, /* nick, string */
    {"TimerAdd", FPR_TIMERADD,'I', "IS"}, /* time, program RETURNS timerid*/
    {"TimerKill", FPR_TIMERKILL,'I', "I"}, /* timerid RETURNS time left */
    {"TimeToSecs", FPR_TIME2SECS, 'I', "S"}, /* convert XX:XX:XX to seconds */
    {"Topic",   FPR_TOPIC,   'I', "S"},  /* topic string */
    {"Unban",   FPR_UNBAN,   'I', "S"},  /* banid, nick or pattern */
    {"UserInfo", FPR_USERINFO, 'O', "SSo"}, /* nick, info, [new value] */
    {"WarnAdd", FPR_WARNADD,  'I', "SSi"}, /* nick, decr, <flag> */
    {"WarnInfo", FPR_WARNINFO, 'O', "S"},  /* info */
    {"Mode", FPR_MODE, 'I', "S"}, /* modes */
  };

#if defined(AMIGA) && !defined(__GNUC__)
  FPLBase = OpenLibrary("fpl.library", 13);
  if(!FPLBase) {
    Logf(LOG, "Unable to open fpl.library!");
    Cleanup();
    /* This is also probably not a critical error, in fact Dancer */
    /* could very well continue w/o it.  Theoritically. */
    return 0;
  }
#endif

  key=fplInitTags(fplinterface,
		  FPLTAG_CACHEALLFILES, FPLCACHE_EXPORTS,
                  FPLTAG_REREAD_CHANGES, TRUE,
#if 0
		  FPLTAG_INTERVAL, (unsigned long)inter, /* interval func */
		  FPLTAG_USERDATA, (unsigned long)&count, /* user data */
		  FPLTAG_INTERNAL_DEALLOC, (unsigned long)MyFree,
		  FPLTAG_INTERNAL_ALLOC, (unsigned long)MyAlloc,
		  FPLTAG_MINSTACK, 7000,
                  FPLTAG_IDENTITY, argv[0], /* identify us! */
		  FPLTAG_DEBUG, TRUE,  /* run in debug mode! */
/*                  FPLTAG_AUTOCOMPILE, TRUE, */
#endif
		  FPLTAG_DONE);


  /*
   * We better add some functions to play with:
   */
  for(i=0; i< sizeof(cmds)/sizeof(cmds[0]); i++)
    fplAddFunction(key, cmds[i].name, cmds[i].func, cmds[i].retcode,
                   cmds[i].param, NULL);

  /*
   * Set up the FPL invoke lists:
   */
  in = fopen(fplconf, "r");
  if(in) {
    while(fgets(line, MAXLINE, in)) {
      FPLAddItem(line);
    }
    fclose(in);
  }
  fCmdInit(); /* init the list of FPL-added commands */
  fTimerInit(); /* init timed FPL actions */
  LabelInit(); /* init list of fpl added labels */

#if 0
  fplentry[RUN_INIT].line = "Runfile(\"dancer.fpl\");";
  fplentry[RUN_PUBLIC].line = "mytest(\"%c\", \"%i\"); ";
#endif
  runfpl(RUN_INIT, "", FPLRUN_PRE);
  return 0;
}

#endif
