#ifdef RCS
static char rcsid[]="$Id: function.c,v 1.20 1997/11/05 22:03:24 dast Exp $";
#endif
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 *  ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing autors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjrn.Stenberg@sth.frontec.se>
 *  - Andrew Gray <DarkDesigns@trader.com>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/function.c,v $
 * $Revision: 1.20 $
 * $Date: 1997/11/05 22:03:24 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: function.c,v $
 * Revision 1.20  1997/11/05 22:03:24  dast
 * updated!
 *
 * Revision 1.19  1997/04/28 16:40:17  dast
 * translations
 *
 * Revision 1.18  1997/01/05 21:13:57  dast
 * Improved Userdomain() to work with hostisp
 *
 * Revision 1.17  1996/08/30 11:29:13  dast
 * uses the 'now'
 *
 * Revision 1.16  1996/08/30 09:03:31  dast
 * Match() is now improved to better w
 * deal with multiple '*' in the wildcard.
 *
 * Revision 1.15  1996/08/21 11:17:31  dast
 * breese's random fixes ;)
 *
 * Revision 1.14  1996/08/07 11:18:44  dast
 * fcopy() used some ivisible error checks and crashed hard
 *
 * Revision 1.13  1996/08/05 13:34:13  dast
 * small change of Userdomain()
 *
 * Revision 1.12  1996/07/26 11:34:58  dast
 * strtok() fix
 *
 * Revision 1.11  1996/07/26 11:22:26  dast
 * Let's not make anything stupid. Fixed Userdomain() again!
 *
 * Revision 1.10  1996/07/25 13:21:25  dast
 * Fix in Userdomain() to prevent host patterns like @machine.topdomain get
 * '*' instead of machine names.
 *
 * Revision 1.9  1996/07/25 08:35:00  dast
 * fcopy() replaces all previous 'cp' uses... hm, good?
 *
 * Revision 1.8  1996/07/10 16:15:00  dast
 * Added the source header.
 *
 *
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <limits.h>

#include "dancer.h"
#include "regex.h"
#include "function.h"
#include "transfer.h"
#include "user.h"


/* RNDSIZE must be an integral number of 2 (and at least 8) */
#define RNDMAX ULONG_MAX
#define RNDSIZE 64
#define RNDMASK RNDSIZE-1

/* MAX_COPY_SIZE determines how big of a buffer to use in fcopy() */
#define MAX_COPY_BLOCK 1024


/* --- Global ----------------------------------------------------- */

extern time_t now;

extern char nickname[];
extern char nickstring[];

static ulong rnd1;
static ulong rnd2;
static ulong rndValues[RNDSIZE];


/* --- IsChannel -------------------------------------------------- */

inline bool IsChannel(char *name)
{
  return ( (*name=='#')||(*name=='&') );
}

/* --- IsServer --------------------------------------------------- */

inline bool IsServer(char *name)
{
  return (strchr(name, '.') ? TRUE : FALSE);
}

/* --- TimeAgo ---------------------------------------------------- */

char *TimeAgo(time_t when)
{
  int diff;
  static char tidsbuf[MIDBUFFER];
  int a, b;

  diff = now - when;
  diff = abs(diff);
  if (diff < SECINMIN)
    sprintf(tidsbuf, "%d %s", diff, (diff==1 ?
				     GetText(msg_second) :
				     GetText(msg_seconds)));
  else if (diff < SECINHOUR) {
    a = diff/SECINMIN;
    b = diff%SECINMIN;
    sprintf(tidsbuf, "%d %s %s %d %s",
            a, (a==1 ? GetText(msg_minute) : GetText(msg_minutes)),
	    GetText(msg_and),
	    b, (b==1 ? GetText(msg_second): GetText(msg_seconds) ));
  } else if (diff < SECINDAY) {
    a = diff/SECINHOUR;
    b = (diff%SECINHOUR)/SECINMIN;
    sprintf(tidsbuf, "%d %s %s %d %s",
            a, (a==1 ? GetText(msg_hour) : GetText(msg_hours)),
	    GetText(msg_and),
	    b, (b==1 ? GetText(msg_minute) : GetText(msg_minutes)));
  } else if (diff < SECINMONTH) {
    a = diff/SECINDAY;
    b = (diff%SECINDAY)/SECINHOUR;
    sprintf(tidsbuf, "%d %s %s %d %s",
            a, (a==1 ? GetText(msg_day) : GetText(msg_days)),
	    GetText(msg_and),
	    b, (b==1 ? GetText(msg_hour) : GetText(msg_hours)));
  } else {
    a = diff/SECINMONTH;
    b = (diff%SECINMONTH)/SECINDAY;
    sprintf(tidsbuf, "%d %s %s %d %s",
            a, (a==1 ? GetText(msg_month) : GetText(msg_months)),
	    GetText(msg_and),
	    b, (b==1 ? GetText(msg_day) : GetText(msg_days)));
  }
  return (tidsbuf);
}

/* --- SecToString ------------------------------------------------ */

char *SecsToString(int secs)
{
  static char buffer[25];
  int hour;
  int minute;
  hour = secs/3600;
  secs -= hour*3600;
  minute = secs/60;
  secs -= minute*60;
  sprintf(buffer, "%02d.%02d:%02d", hour, minute, secs);
  return buffer;
}

/* --- ToSeconds -------------------------------------------------- */

int ToSeconds(char *xs)
{
  char *ys;
  int secs = 0;

  do {
    secs *= 60;
    secs += strtol(xs, &ys, 10);
    xs = ys + 1;
  } while (*ys == ':');
  return (secs);
}

/* --- GetOption -------------------------------------------------- */

itemopt option = {NULL, NIL};

bool GetOption(char *line)
{
  if (line && (*line == '-')) {
    line++;
    option.copt = *line++;
    while (*line && !isspacechar(*line)) line++;
    while (*line && isspacechar(*line)) line++;
    option.newpos = line;
    return TRUE;
  }
  option.copt = NIL;
  option.newpos = line;
  return FALSE;
}

/* --- Boolean ---------------------------------------------------- */

inline char *OnOff(bool toggle)
{
  return (toggle? "on" : "off");
}

inline bool IsOn(char *str)
{
  return ( !strcasecmp(str, "ON") ? TRUE : FALSE );
}


/* --- Hash ------------------------------------------------------- */

inline unsigned int HashU(char *key)
{
  unsigned int k;

  for (k = 0; *key; key++)
    k = 31*k + toupper(*key);
  return (k % HASHSIZE);
}

inline unsigned int Hash(char *key)
{
  unsigned int k;

  for (k = 0; *key; key++)
    k = 31*k + *key;
  return (k % HASHSIZE);
}

/* --- HashSignature ---------------------------------------------- */

/* Used for fast text searching. To check if a certain  word could
 * occur in a static block of text, a hashed 2-signature of the
 * text must be pre-calculated. When searching for a word, calculate
 * it's signature and compare with the signature of the text.
 *
 *   if ( (textsignature & signature) == signature )
 *     // word _could_ be in text, check further
 *   else
 *     // word is definitely not in text
 *
 * To find possible match between two string where one contains
 * wildcard the check must be
 *
 *   if ( (patternsignature & signature) == patternsignature )
 */

ulong HashSignature(char *name)
{
  ulong sig = 0L;
  char a, b;
  bool bvalid = FALSE; /* Does b contain a valid char */

  b = (char)0;
  while ( (a=*name++) ) {
    /* Don't hash wildcards and bigrams */
    if (a^'*' && a^'?') {
      if (bvalid && a^b)
        sig |= 1 << (((int)a + (int)b) % ULONG_BIT);
      b = a;
      bvalid = TRUE;
    } else
      bvalid = FALSE;
  }
  return (sig);
}

/* --- _NextWord -------------------------------------------------- */

/* Macro NextWord defined in header */

char *_NextWord(char *line, char **rline)
{
  char *xs;

  if (line) {
    while ( isspacechar(*line) )
      line++;
    xs = strchr(line, ' ');
    if (xs)
      *xs++ = NIL;
    *rline = xs;
  }
  return (line);
}

/* --- PatternInit() ---------------------------------------------- */

/* Setup the translation table fo the pattern mach (case insensitive) */

/* How many characters in the character set.  */
#define CHAR_SET_SIZE 256

static char p_translate[CHAR_SET_SIZE];
void PatternInit(void)
{
  unsigned i;
  /* Map uppercase characters to corresponding lowercase ones.  */
  for (i = 0; i < CHAR_SET_SIZE; i++)
    p_translate[i] = isupper(i)? tolower (i): i;
}

/* --- PatternExist ----------------------------------------------- */

bool PatternExist(char *line, char *pattern)
{
  char const *error;
  int retcode;
  struct re_pattern_buffer patbuf;
  
  memset(&patbuf, 0, sizeof(struct re_pattern_buffer) );
#if 0
  patbuf.translate = p_translate; /* case insensitive table */
#endif
  error = re_compile_pattern(pattern, strlen(pattern), &patbuf);
  if (error)
    Debug("Pattern error: %s", error);

  retcode = re_search(&patbuf, line, strlen(line), 0, strlen(line), NULL);
  regfree( &patbuf);
  return (retcode>=0 ? TRUE : FALSE); /* return hit */
}

#if 0
inline bool SearchPattern(re_compile_pattern *p, char *line)
{
  return (re_search(p, line, strlen(line), 0, strlen(line), NULL) >= 0);
}

void *FreePattern(struct re_pattern_buffer *p)
{
  regfree(p);
  free(p);
}

struct re_pattern_buffer *PrecalcPattern(char *pattern)
{
  char const *errtxt;
  struct re_pattern_buffer *p;

  if ( p=(struct re_pattern_buffer *)calloc(1, sizeof(struct re_pattern_buffer)) ) {
    if ( errtxt=re_compile_pattern(pattern, strlen(pattern), p) ) {
      Debug("Pattern error: %s", errtxt);
      FreePattern(p);
      p = NULL;
    }
  }
  return (p);
}
#endif

/* --- Match ------------------------------------------------------ */

#if 0

bool Match(char *string, char *pattern)
{
  for (; '*'^*pattern; ++pattern, ++string) {
    if (!*string)
      return (!*pattern);
    if (toupper(*string)^toupper(*pattern) && '?'^*pattern)
      return FALSE;
  }
  /* two-line patch to prevent *too* much recursiveness: */
  while('*' == pattern[1])
    pattern++;
  do {
    if ( Match(string, pattern + 1) )
      return TRUE;
  } while (*string++);
  return FALSE;
}

#else

/*  Using a slightly modified version of the iterative match() function
 *  from ircd sources (irc2.10.1/common/match.c), which is twice or
 *  sometimes even multiple times faster than the recursive Match().
 *  Most of the blame goes to toupper, but the iterative version would
 *  still be faster than the recursive one, regardless of toupper.
 *  (Inverted the return values and some other minor changes)
 */

#define MAX_ITERATIONS 512
#define irc_tolower(c) (tolowertab[(u_char)(c)])

unsigned char tolowertab[] =
		{ 0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8, 0x9, 0xa,
		  0xb, 0xc, 0xd, 0xe, 0xf, 0x10, 0x11, 0x12, 0x13, 0x14,
		  0x15, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d,
		  0x1e, 0x1f,
		  ' ', '!', '"', '#', '$', '%', '&', 0x27, '(', ')',
		  '*', '+', ',', '-', '.', '/',
		  '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
		  ':', ';', '<', '=', '>', '?',
		  '@', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
		  'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's',
		  't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~',
		  '_',
		  '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
		  'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's',
		  't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~',
		  0x7f,
		  0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89,
		  0x8a, 0x8b, 0x8c, 0x8d, 0x8e, 0x8f,
		  0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99,
		  0x9a, 0x9b, 0x9c, 0x9d, 0x9e, 0x9f,
		  0xa0, 0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7, 0xa8, 0xa9,
		  0xaa, 0xab, 0xac, 0xad, 0xae, 0xaf,
		  0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6, 0xb7, 0xb8, 0xb9,
		  0xba, 0xbb, 0xbc, 0xbd, 0xbe, 0xbf,
		  0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9,
		  0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,
		  0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9,
		  0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf,
		  0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
		  0xea, 0xeb, 0xec, 0xed, 0xee, 0xef,
		  0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8, 0xf9,
		  0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff };

bool Match(char *string, char *pattern)
{
  register u_char *p = (u_char *)pattern, *s = (u_char *)string;
  char *pat = pattern, *str = string;
  int wild = 0, q = 0, calls = 0;

  while(1) {
#ifdef	MAX_ITERATIONS
    if (calls++ > MAX_ITERATIONS)
      break;
#endif

    if (*p == '*') {
      while(*p == '*')
        p++;
      wild = 1;
      pat = (char *)p;
      str = (char *)s;
    }

    if (!*p) {
      if (!*s)
        return TRUE;
      if (p > (u_char *)pattern)
        p--;
      for (; (p > (u_char *)pattern) && (*p == '?'); p--);
      if ((p > (u_char *)pattern) && (*p == '*') && (p[-1] != '\\'))
        return TRUE;
      if (!wild)
        return FALSE;
      p = (u_char *)pat;
      s = (u_char *)++str;
    }
    else if (!*s)
      return FALSE;

    if ((*p == '\\') && ((p[1] == '*') || (p[1] == '?'))) {
      p++;
      q = 1;
    }
    else
      q = 0;

    if ((irc_tolower(*p) != irc_tolower(*s)) && ((*p != '?') || q)) {
      if (!wild)
        return FALSE;
      p = (u_char *)pat;
      s = (u_char *)++str;
    }
    else {
      if (*p)
        p++;
      if (*s)
        s++;
    }
  }
  return FALSE;
}

#endif

/* --- Userdomain ------------------------------------------------- */

/*
 *  Transforms host name to a masked domain name.
 *
 *  This function allocates a string, which you must free()
 *  yourself. {a=Userhost(b); ...use it...; free(a);}
 *
 *  Machine names may start with a digit (if they've got a really
 *  stupid sysadm) but top level domains always start with an
 *  alphabetic char. Use top level domain to distinguish between
 *  IP names and IP numeric adresses.
 *
 *  Both '@' and at least one '.' must be present in 'host'.
 *
 *  Furthermore, some people use '@' in their (faked) user name,
 *  so search for the last '@'.
 *
 *  For example:
 *       "user@machine.host.domain" becomes "user@*.host.domain"
 *  and  "user@127.0.0.1"           becomes "user@127.0.0.*"
 *
 *  From 26th of July, 1996 also:
 *
 *       "user@host.domain"         becomes "user@*ost.domain"
 *
 * From 3rd of January, 1997 (v4.1.3) also:
 *
 * Check if the host is an ISP listed as hostisp: in .config and then make the
 * pattern like:
 *
 *       "user@machine.host.domain" becomes "*@machine.host.domain"
 */

char *Userdomain(char *host)
{
  char *domain, *m, *t;
  bool smallone;

  domain = strdup(host);
  if (domain) {
    m = strrchr(domain, '@') + 1; /* points to machine name */
    t = strrchr(m, '.') + 1;      /* points to top level domain name */

    /* now check for a @host.domain style name */
    smallone = (t == strchr(m, '.')+1) ? TRUE : FALSE;

    if ( isdigit(*t) ) {
      *t++ = '*';
      *t   = NIL;
    } else {
      if(HostISP(host)) {
	/* new host-style (4.1.3) - Bagder */
	m = domain;
	*m++ = '*';
	t    = strrchr(host, '@');  /* points to the last @ */
	strcpy(m, t);               /* copy the rest of the string */
      }
      else {
	*m++ = '*';
	if(smallone)
	  /* Remain happy with making the first letter a '*'! */
	  ;
	else {
          t  = strrchr(host, '@');   /* point out the right part */
	  t = strchr(t, '.');        /* points to lowest domain name */
	  strcpy(m, t);              /* copy the rest of the string */
	}
      }
    }
  }
  return (domain);
}

/* --- NewNick ---------------------------------------------------- */

void NewNick(void)
{
  static int num = 0;
  char c;
  int sep=0, bracket=FALSE;
  char *from = nickstring, *to = nickname;
  
  while ( (c = *from++) ) {
    switch (c) {
      case '[':
        bracket = TRUE;
        sep=0;
        break;
      case '|':
        sep++;
        break;
      case ']':
        bracket = FALSE;
        break;
      default:
        if (bracket == FALSE)
          *to++ = c;
        else if (sep == num)
          *to++ = c;
    }
  }
  *to = NIL;
  if (sep <= num++)
    num = 0;
}


/* --- Random ----------------------------------------------------- */

inline ulong Random(void)
{
  rnd1 = (rnd1 - 3) & RNDMASK;
  rnd2 = (rnd2 - 1) & RNDMASK;
  return (rndValues[rnd2] += rndValues[rnd1]);
}

/* --- InitRandom ------------------------------------------------- */

void InitRandom(int s)
{
  int i;

  for (i = 0; i < RNDSIZE; i++) {
    rndValues[i] = (ulong)s;
    /* --- randqd1() from Numerical Recipes --- */
    s = 0x0019660dL * s + 0x3c6ef35fL;
  }
  rnd1 = 0;
  rnd2 = RNDSIZE/2 - 3;

  /* --- Remove initial errors of bad seeding (warn-up) --- */
  for (i = 0; i < RNDSIZE; i++) Random();
}

/* --- Rnd -------------------------------------------------------- */

float Rnd(void)
{
  float a;

  a = (float)Random();
  a /= (float)RNDMAX;
  return (a);
}

/* ---------------------------------------------------------------- */

struct Top {
  char name[40];
  long value;
  long flags;
};

#define NUM_TOP 7

struct Top realtop[NUM_TOP];
struct Top *newtop[NUM_TOP];

int compar(struct Top **t1, struct Top **t2)
{
  return (*t2)->value - (*t1)->value;
}

void AddToTop(char *name, long value) 
{
  if(value>newtop[NUM_TOP-1]->value) {
    strcpy(newtop[NUM_TOP-1]->name, name);
    newtop[NUM_TOP-1]->value = value;
    qsort((void *)newtop, NUM_TOP, sizeof(struct Top *), (int (*)(const void *, const void *))compar);
  }
}

void InitTop(void)
{
  int n;
  memset(realtop, 0, sizeof(realtop)); /* reset all */
  for(n=0; n<NUM_TOP; n++) {
    newtop[n] = &realtop[n];
  }
}

char *PresentTop(void)
{
  int n;
  static char buffer[256];
  char *pnt=buffer;
  for(n=0; n<NUM_TOP && newtop[n]->name[0]; n++) {
    sprintf(pnt,
            "%s (%d) ",
            newtop[n]->name, (int)newtop[n]->value);
    pnt += strlen(pnt);
  }
  if(!n) {
    strcpy(buffer, GetText(msg_no_info_for_toplist));
  }
  return buffer;
}

/* ---------------------------------------------------------------- */

char *mystrtok(char *str, char *sep)
{
#ifdef HAVE_STRSEP
  static char *xs;
  if (str) xs = str;
  return ( strsep(&xs, sep) );
#else
  return ( strtok(str, sep) );
#endif
}

/* --- fcopy ------------------------------------------------------ */

void fcopy(char *src, char *dest)
{
  FILE *fsrc, *fdest;
  char buffer[MAX_COPY_BLOCK];
  size_t bytes;
  fsrc = fopen(src, "rb");
  if(fsrc) {
    fdest = fopen(dest, "wb");
    if(fdest) {
      /* copy in 1K chunks by default */
      while(MAX_COPY_BLOCK == (bytes = fread(buffer, 1, MAX_COPY_BLOCK, fsrc)))
        fwrite(buffer, MAX_COPY_BLOCK, 1, fdest);
      fwrite(buffer, bytes, 1, fdest);
      fclose(fdest);
    }
    fclose(fsrc);
  }
}
