/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 * ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing autors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjrn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/function.h,v $
 * $Revision: 1.10 $
 * $Date: 1997/08/25 17:45:36 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: function.h,v $
 * Revision 1.10  1997/08/25 17:45:36  dast
 * Only make the strtok proto appear here if defined
 *
 * Revision 1.9  1996/12/03 17:00:52  dast
 * new prototypes
 *
 * Revision 1.8  1996/08/21 11:17:31  dast
 * breese's random fixes ;)
 *
 * Revision 1.7  1996/07/26 11:34:58  dast
 * strtok() fix
 *
 * Revision 1.6  1996/07/10 16:15:00  dast
 * Added the source header.
 *
 *
 *****************************************************************************/

#ifndef __FUNCTION_H
#define __FUNCTION_H

#include "dancer.h"

typedef struct {  /* Options */
  char *newpos;
  char copt;
} itemopt;


inline bool IsChannel(char *);
inline bool IsServer(char *);
bool GetOption(char *);
char *Userdomain(char *);
void NewNick(void);
char *TimeAgo(time_t);
char *SecsToString(int);
int ToSeconds(char *);
inline unsigned int Hash(char *);
inline unsigned int HashU(char *);
ulong HashSignature(char *);
void PatternInit(void);
bool PatternExist(char *, char *);
bool Match(char *, char *);
inline char *OnOff(bool);
inline bool IsOn(char *);
char *_NextWord(char *, char **);
#define NextWord(x) _NextWord((x), &(x))

/* Initialize the pseudo-random number generator */
void InitRandom(int);
/* Returns a pseudo-random number between 0 and RNDMAX */
inline ulong Random(void);
/* Returns a pseudo-random number between 0.0 and 1.0 */
float Rnd(void);

void AddToTop(char *name, long value);
void InitTop(void);
char *PresentTop(void);

#ifdef strtok
/* let's not put the real strtok() proto here */
char *mystrtok(char *, char *);
#endif

#endif
