#ifdef RCS
static char rcsid[]="$Id: link.c,v 2.4 1998/02/14 11:34:00 dast Exp $";
#endif
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 * ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing autors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjrn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/link.c,v $
 * $Revision: 2.4 $
 * $Date: 1998/02/14 11:34:00 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: link.c,v $
 * Revision 2.4  1998/02/14 11:34:00  dast
 * enlarged buffers
 *
 * Revision 2.3  1997/11/05 22:03:24  dast
 * updated!
 *
 * Revision 2.2  1997/04/28 16:41:49  dast
 * Made it shut down nicer
 *
 * Revision 2.1  1997/01/27 17:06:47  dast
 * lots of new stuff by breese
 *
 *
 *****************************************************************************/

/*
 * - Exchange of userlist not implemented.
 * - Problems when linking more than two clusters of linkbots
 *   together (only one cluster gets to know about the other
 *   cluster.)
 */

/*
 * Define to test reliability. If defined it will skip acks
 * and send duplicates at random. Don't to this at home, kids.
 */
#undef UNRELIABLE

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>

#include "dancer.h"
#include "user.h"
#include "transfer.h"
#include "link.h"
#include "command.h"
#include "function.h"

#define TIMEREQUEST (-1)

extern time_t now;
extern int linkSocket;

extern struct sockaddr_in fromaddr;
extern itemlink *linkHead;
extern char nickname[];
extern ulong linkvalue;
extern long levels[];

time_t commontime = NULL; /* Reference zero time */


/* ----------------------------------------------------------------
 *
 *  Level 1 routines
 *
 * ---------------------------------------------------------------- */

/*
 * Various routines to provide reliable message passing. The rtt_XXX
 * routines are taken from chapter 8.4 of "Unix Network Programming"
 * by Stevens. Didn't bother to add the comments.
 */

#ifdef UNRELIABLE
int exp_backoff[] = {1, 1, 1, 1, 1};
#else
int exp_backoff[] = {1, 2, 4, 8, 16};
#endif
int whatever[] = {1, 1};

#define RTT_RXTMIN 2
#define RTT_RXTMAX 120
#define RTT_MAXNREXMT (sizeof(exp_backoff)/sizeof(exp_backoff[0]))

void rtt_init(itemlink *r)
{
  r->rtt_rtt = r->rtt_srtt = 0;
  r->rtt_rttdev = 1.5;
  r->rtt_nxtrto = 0;
}

inline void rtt_newpack(itemlink *r)
{
  r->rtt_nrexmt = 0;
}

/* Returns timeout value */
int rtt_start(itemlink *r)
{
  int rexmt;

  if (r->rtt_nrexmt > 0) {
    r->rtt_currto *= exp_backoff[r->rtt_nrexmt];
    return (r->rtt_currto);
  }
  gettimeofday(&r->time_start, NULL);
  if (r->rtt_nxtrto > 0) {
    r->rtt_currto = r->rtt_nxtrto;
    r->rtt_nxtrto = 0;
    return (r->rtt_currto);
  }
  rexmt = (int)(r->rtt_srtt + (2.0 * r->rtt_rttdev) + 0.5);
  if (rexmt < RTT_RXTMIN)
    rexmt = RTT_RXTMIN;
  else if (rexmt > RTT_RXTMAX)
    rexmt = RTT_RXTMAX;
  return (r->rtt_currto = rexmt);
}

void rtt_stop(itemlink *r)
{
  long diff;
  float err;

  if (r->rtt_nrexmt > 0)
    r->rtt_nxtrto = r->rtt_currto;
  else {
    r->rtt_nxtrto = 0;
    gettimeofday(&r->time_stop, NULL);
    diff = r->time_stop.tv_sec - r->time_start.tv_sec;
    if (r->time_stop.tv_usec < r->time_start.tv_usec)
      diff--;
    r->rtt_rtt = (float)diff;
    /* Use integer version instead */
    err = r->rtt_rtt - r->rtt_srtt;
    r->rtt_srtt += err/8;
    if (err < 0.0)
      err = -err;
    r->rtt_rttdev += (err - r->rtt_rttdev) / 4;
  }
}

int rtt_timeout(itemlink *r)
{
  rtt_stop(r);
  return (++r->rtt_nrexmt >= RTT_MAXNREXMT);
}

/*
 * msgid, type, msg, \n
 */

#if 0
int L1_recv(struct Socket *self, char *buf, int len, int flags)
{
  int size = sizeof(self->fromaddr);

  size = recvfrom(self->handle, buf, len, flags,
		  (struct sockaddr *)&(self->fromaddr), &size);
  buf[size] = NIL;
#ifdef DBUG
  fprintf(stderr, "L1_recv: %d (%d) << %s",
	  self->handle, ntohs(self->fromaddr.sin_port), buf);
#endif
  return size;
}

int L1_send(itemlink *self, char *msg, int len, int flags)
{
  sendto(self->handle, msg, len, flags,
	 (struct sockaddr *)&self->addr, sizeof(struct sockaddr_in));
#ifdef DBUG
  fprintf(stderr, "%d (%d) >> %s",
          self->handle, ntohs(self->addr.sin_port), rawmsg);
#endif
}
#endif

/* --- ReadLink --------------------------------------------------- */

int ReadLink(char *inbuf)
{
  int size = sizeof(fromaddr);

  size = recvfrom(linkSocket, inbuf, MAXLINE, 0,
                  (struct sockaddr *)&fromaddr, &size);
  inbuf[size] = NIL;
#ifdef DBUG
  fprintf(stderr, "%d (%d) << %s", linkSocket, ntohs(fromaddr.sin_port), inbuf);
#endif
  return size;
}

/* --- WriteLink -------------------------------------------------- */

#define UDPBUFFER 1024

void WriteLinkRaw(itemlink *r, char *rawmsg)
{
#ifdef DBUG
  fprintf(stderr, "%d (%d) >> %s",
          linkSocket, ntohs(r->addr.sin_port), rawmsg);
#endif
  sendto(linkSocket, rawmsg, strlen(rawmsg), 0,
	 (struct sockaddr *)&r->addr, sizeof(struct sockaddr_in));
}

void WriteLink(itemlink *r, int type, char *msg)
{
  unsigned char buffer[UDPBUFFER];

  sprintf(buffer, "%d %d %s\n", ++r->mymsgid, type, msg);
  WriteLinkRaw(r, buffer);
}

void WriteLinkf(itemlink *r, int type, char *fmt, ...)
{
  char buf[MAXLINE];
  va_list args;

  va_start(args, fmt);  
  vsprintf(buf, fmt, args);
  va_end(args);
  WriteLink(r, type, buf);
}

/* --- SendLink --------------------------------------------------- */

/* If queue is empty send directly, else queue it. Don't remove
 * from queue until ACK is received. The message on top of the
 * list is always the one being sent, the rest are stalled to
 * ensure casuality.
 */

void QueueLink(itemlink *r, int type, char *msg)
{
  itemmsg *p, *n;
  char buf[BIGGERBUFFER];

  sprintf(buf, "%d %lu %s\n", ++r->mymsgid, type, msg);

  for (n = &r->RemoteHead; n->next; n = n->next); /* Append to list */

  p = (itemmsg *)calloc(1, sizeof(struct Msgstruct));
  if (p) {
    n->next = p;
    p->msg  = strdup(buf);
    /* If first in queue ship it now */
    if (n == &r->RemoteHead) {
      rtt_newpack(r);
      WriteLinkRaw(r, buf);
#ifdef UNRELIABLE
      if (Rnd() < 0.2) /* Send duplicate */
        WriteLinkRaw(r, buf);
#endif
      r->expires = now + rtt_start(r);
    }
  }
}

void SendLink(itemlink *r, int type, char *fmt, ...)
{
  va_list args;
  char buf[BIGGERBUFFER];
  
  va_start(args, fmt);
  vsprintf(buf, fmt, args);
  va_end(args);
  QueueLink(r, type, buf);
}

void SendLinkAll(int type, char *fmt, ...)
{
  if(linkHead) {
    itemlink *r;
    va_list args;
    char buf[BIGGERBUFFER];
  
    va_start(args, fmt);
    vsprintf(buf, fmt, args);
    va_end(args);

    for (r=Succ(linkHead); r; r=Succ(r))
      if (!r->new)
	QueueLink(r, type, buf);
  }
}

void SendLinkBut(itemlink *rin, int type, char *fmt, ...)
{
  itemlink *r;
  va_list args;
  char buf[BIGGERBUFFER];
  
  va_start(args, fmt);
  vsprintf(buf, fmt, args);
  va_end(args);

  for (r=Succ(linkHead); r; r=Succ(r))
    if (r != rin && !r->new)
      QueueLink(r, type, buf);
}

/* --- CheckLinkQueue --------------------------------------------- */

/*
 * Whenever a message is sent it must wait for acknowledgement.
 * When messages are sent they are put in a queue. Each linked
 * bot has its own queue. When an ack is received the next message
 * from the queue is sent.
 */

void CheckLinkQueue(void)
{
  itemlink *r;
  itemmsg *n;

  /* Called each second */
  r = Succ(linkHead);
  while (r)
    {
      n = r->RemoteHead.next;
      if (n)
	{
	  if (r->expires <= now)
	    {
	      if (rtt_timeout(r))
		{
		  /* Link is dead, remove it */
		  r = RemoveLink(r);
		  continue; /* while */
		}
	      else
		{
		  /* Retransmit message */
		  WriteLinkRaw(r, n->msg);
		  r->expires = now + rtt_start(r);
		}
	    }
	}
      r = Succ(r);
    }
}

void FlushLinkQueue(itemlink *r)
{
  itemmsg *p;

  p = r->RemoteHead.next;
  while (p)
    p = FreeMessage(p);
  r->RemoteHead.next = NULL;
}

/* --- LinkDequeue ------------------------------------------------ */

bool LinkDequeue(itemlink *r, unsigned long msgid)
{
  itemmsg *n;
  unsigned long mid;
  int type;

  /* Remove from top of queue */
  if ( (n=r->RemoteHead.next) &&
       2 == sscanf(n->msg, "%d %lu", &mid, &type) )
    {
      /* Duplicates of previously acknowledged message may exist */
      if (mid == msgid)
	{
	  /* Wait to remove the rejected link until it acknowledges */
	  if (type == IBCP_REJECT)
	    {
	      RemoveLink(r);
	      return TRUE;
	    }
	  else if ( (n = r->RemoteHead.next = FreeMessage(n)) )
	    {
	      /* Ship the next */
	      rtt_newpack(r);
	      WriteLinkRaw(r, n->msg);
	      r->expires = now + rtt_start(r);
	    }
	}
    }
  return FALSE;
}


/* ----------------------------------------------------------------
 *
 *  Level 2 routines
 *
 * ---------------------------------------------------------------- */

/* --- LinkQuit --------------------------------------------------- */

void LinkQuit(void)
{
  /*
   * The QUIT message surpasses the queue. We don't care about
   * acknowledgement - if the recipient received it fine; if not
   * the connection will timeout eventually.
   */
  itemlink *r;

  if(!linkHead)
    return;

  for (r=Succ(linkHead); r; r=Succ(r)) {
    WriteLink(r, IBCP_QUIT, "Bored");
  }

  /* Equivalent to SendLinkAll(IBCP_QUIT, "Bored"); */
}

/* --- LinkHello -------------------------------------------------- */

itemlink *LinkHello(char *msg)
{
  int ver, bottype;
  ulong key;
  itemlink *r = NULL;
  char name[MINIBUFFER];

  if (4 == sscanf(msg, "%d %d %s %lu", &ver, &bottype, name, &key))
    {
      /*
       * We initiated the link. Now that we've got the info
       * of the other end we add it and reply with our info.
       */
      r = AddLink(name, NULL, ntohl(fromaddr.sin_addr.s_addr),
		  ntohs(fromaddr.sin_port));
      if (r)
	{
	  r->bottype = bottype;
	  r->protoversion = ver;
	  /* We asked to link so we assume that the other end is authenticated */
	  r->passed = TRUE;
	  SendLink(r, IBCP_HELLO_REPLY, "%d %d %s %lu",
		   IBCP_VERSION, IBCP_BOT_DANCER, nickname, key ^ linkvalue);
	}
    }
  return r;
}


/* --- LinkHelloReply --------------------------------------------- */

void LinkHelloReply(itemlink *r, char *msg)
{
  int ver, bottype;
  ulong key;
  char name[MINIBUFFER];

  if (4 == sscanf(msg, "%d %d %s %lu", &ver, &bottype, name, &key)) {

    if (r)
      {
	/*
	 * The other end initiated the link. We have already
	 * sent our info (in the HELLO message in ctcp.c) and
	 * now get the info of the initiater in return
	 */
	r->bottype = bottype;
	r->protoversion = ver;
	if (name)
	  r->name = strdup(name);

	if ((r->linkvalue ^ key) == r->tmpvalue)
	  {
	    r->passed = TRUE;
#if 0
	    SendLinkBut(r, IBCP_AUTH, "%ld %d %d %d %s",
			ntohl(fromaddr.sin_addr.s_addr), ntohs(fromaddr.sin_port),
			ver, bottype, name);
	    r->new = FALSE;
#endif
	    SendLink(r, IBCP_ACCEPT, "");

#if 0
	    /* Tell newcomer about everybody else in net */
	    for(rr=Succ(linkHead); rr; rr=Succ(rr))
	      {
		if (rr != r)
		  SendLink(r, IBCP_AUTH_LIST, "%ld %d %d %d %s",
			   ntohl(rr->addr.sin_addr.s_addr), ntohs(rr->addr.sin_port),
			   rr->protoversion, rr->bottype, rr->name);
	      }
	    SendLink(r, IBCP_AUTH_END, "1");
	    /* Logf(LINK, "Added %s from %s %d", r->name,
	       ntohl(r->addr.sin_addr.s_addr), ntons(r->addr.sin_port));
	       */
#endif
	  }
	else
	  {
	    r->passed = FALSE;
	    SendLink(r, IBCP_REJECT, "No authentication");
	    /* Link will be removed in LinkDequeue() */
	    /* Logf(LINK, "Rejected..."); */
	    return;
	  }
      }
  }
}


/* --- LinkAuth --------------------------------------------------- */

void LinkAuth(itemlink *r, char *msg)
{
  itemlink *rr;
  long addr;
  int port, ver, bottype;
  char name[MINIBUFFER];

  if (5 == sscanf(msg, "%ld %d %d %d %s", &addr, &port, &ver, &bottype, name))
    {
      rr = AddLink(name, NULL, addr, port);
      if (rr)
	{
	  rr->bottype = bottype;
	  rr->protoversion = ver;
	  rr->passed = TRUE;
	  rr->new = FALSE;  /* Add immediately */
	}
    }
}

void LinkAuthList(itemlink *r, char *msg)
{
  itemlink *rr;
  long addr;
  int port, ver, bottype;
  char name[MINIBUFFER];
/*   char naddr[sizeof "ffff:ffff:ffff:ffff:ffff:ffff:256.256.256.256"]; */

  if (5 == sscanf(msg, "%ld %d %d %d %s", &addr, &port, &ver, &bottype, name))
    {
      rr = AddLink(name, NULL, addr, port);
      if (rr)
	{
	  rr->bottype = bottype;
	  rr->protoversion = ver;
	  rr->passed = TRUE;
	  rr->new = TRUE;
	}
    }
}

void LinkAuthEnd(itemlink *r, char *msg)
{
  itemlink *rr, *xrr;

  if (*msg ^ '0') {
    /* Return our cluster */
    for(rr=Succ(linkHead); rr; rr=Succ(rr)) {
      if ( !rr->new && (rr != r) )
	SendLink(r, IBCP_AUTH_LIST, "%ld %d %d %d %s",
		 ntohl(rr->addr.sin_addr.s_addr), ntohs(rr->addr.sin_port),
		 rr->protoversion, rr->bottype, rr->name);
    }
    SendLink(r, IBCP_AUTH_END, "0");
  }

  /* Commit newly received links */
  for (rr=Succ(linkHead); rr; rr=Succ(rr)) {
    if ( rr->new ) {
      for (xrr=rr; xrr; xrr=Succ(xrr)) {
	if ( !xrr->new )
	  SendLink(xrr, IBCP_AUTH, "%ld %d %d %d %s",
		   ntohl(rr->addr.sin_addr.s_addr), ntohs(rr->addr.sin_port),
		   rr->protoversion, rr->bottype, rr->name);
      }
      rr->new = FALSE;
    }
  }
}

/* --- LinkAccept ------------------------------------------------- */

void LinkAccept(itemlink *r)
{
  SendLink(r, IBCP_SYNC, "%ld %ld", TIMEREQUEST, now);
}

/* --- LinkSync --------------------------------------------------- */

void LinkSync(itemlink *r, char *msg)
{
  long ct, then;

  if (2 == sscanf(msg, "%ld %ld", &ct, &then)) {

    if (ct == TIMEREQUEST) {
      /* It is a request for common time */
      SendLink(r, IBCP_SYNC, "%ld %ld", now - commontime, then);
    }
    else {
      /* T_common_ref = T_now - (T_remote + T_round-trip/2) */
      long cnow = now;
      commontime = cnow - ct - (cnow - then) / 2;
      SendLink(r, IBCP_USERS_REQUEST, "%lu", LatestUserUpdate());
    }
  }
}


/* --- LinkNickname ----------------------------------------------- */

void LinkNickname(itemlink *r, char *msg)
{
  if (r->name)
    free(r->name);
  r->name = strdup(msg);
}


/* --- LinkMulticast ---------------------------------------------- */

void LinkMulticast(itemlink *r, char *msg)
{
  char *text;

  text = strchr(msg, ' ');
  if (text)
    {
      /*
       * Multicasting from remote link is only forwarded
       * to local listening clients
       */
      MulticastLocalf(atoi(msg), "[%s]%s", r->name, text);
    }
}


/* --- LinkSendUsers ---------------------------------------------- */

#if 0
extern itemuser *userHead;

char *LevelType(int level)
{
  if (level < LEVELRECOG)
    return "UNKNOWN";
  else if (level < LEVELCHANOP)
    return "RECOGNIZED";
  else if (level < LEVELTRUST)
    return "CHANOP";
  else if (level < LEVELEXPERT)
    return "TRUSTED";
  else if (level < LEVELBOT)
    return "EXPERT";
  else if (level < LEVELOWNER)
    return "MAINTAINER";
  else
    return "OWNER";
}

void LinkSendUser(itemlink *r, itemuser *u)
{
  itemlist *t;
  char buf[BIGGERBUFFER];

  sprintf(buf, "%s", LevelType(u->level));
  if (u->flags.autoop)
    strcat(buf, ",AUTO");
  if (u->flags.banprotect)
    strcat(buf, ",PROTECT");
  /* u->flags.linkbot is local data and not shared */

  SendLink(r, IBCP_DATA_USER, "BEGIN: NICK:%s PASS:%s PRIV:%s CTIME:%ld MTIME:%ld",
           u->nick, u->passwd, buf, u->created - commontime, u->modified - commontime);
  SendLink(r, IBCP_DATA_USER, "EMAIL:\"%s\" COMMENT:\"%s\"",
           u->realname, u->comment);
  *buf = NIL;
  for (t = Succ(u->domainhead); t; t = Succ(t))
    sprintf(buf, "%s%s,",
            (strchr((char *)t->ptr, '!') == NULL) ? "*!" : "",
            (char *)t->ptr);
  SendLink(r, IBCP_DATA_USER, "HOST:%s END:", buf);
}

void LinkSendUserlist(itemlink *r)
{
  itemuser *u;

  for (u=Succ(userHead); u; u=Succ(u))
    LinkSendUser(r, u);
}

/* --- LinkUpdateUser --------------------------------------------- */

void LinkUpdateUser(itemlink *r, char *msg)
{
  static itemuser user;
  char buf[BIGGERBUFFER];
  char strtype[MINIBUFFER];
  char strargs[BIGBUFFER];
  int index = 0;

#ifdef HAVE_N_IN_SCANF
  sscanf(&msg[index], "%s %n", buf, &index);
#else
  sscanf(&msg[index], "%s", buf);
  index = strlen(buf);
#endif

  sscanf(buf, "[^:]*1[:][^\n]", strtype, strargs);

  if (!strcasecmp(strtype, "BEGIN"))
    memset(&user, NIL, sizeof(user));
  else if (!strcasecmp(strtype, "NICK"))
    user.nick = strdup(strargs);
  else if (!strcasecmp(strtype, "PASS"))
    user.passwd = strdup(strargs);
/* Remember that time is relative to commontime */
  else if (!strcasecmp(strtype, "END")) {
    /* Insert user entry */
#if 0
    AddUser(&user, buf);  /* <--- Must be UpdateUser() not AddUser() */
    sprintf(buf, "%s 0 %d %d 0", user.passwd, NULL, user.modified, user.created);
    AddNewData(&user, buf);
    AddDomain(&user, whatever);
#endif
    if (user.nick) free(user.nick);
    if (user.passwd) free(user.passwd);
  }
}
#endif

/* --- LinkUsers -------------------------------------------------- */

char *SetUserFlags(uFlags *);

extern itemuser *userHead;

void LinkUsersRequest(itemlink *r, char *msg)
{
  itemuser *u;
  itemlist *l;
  time_t t;

  if (1 == sscanf(msg, "%lu", &t) ) {
    printf("update since %lu\n", t);

    /* Ship all entries that are newer than 't' */
    for (u=Succ(userHead); u; u=Succ(u)) {
      if (u->modified > t - 400) {  /* !!! remove - 400 !!! */

        /* Should send the same data as WriteUsers() */
        SendLink(r, IBCP_USERS_LIST, "%s", WriteUserHead(u));
	for (l = Succ(u->domainhead); l; l=Succ(l))
	  SendLink(r, IBCP_USERS_LIST, "!%s\n", (char *)l->ptr);
      }
    }
    SendLink(r, IBCP_USERS_END, "");
  }
}

void LinkUsersUpdate(itemlink *r, char *msg)
{
  printf("Should do the update here\n");
}

void LinkUsersList(itemlink *r, char *msg)
{
  LinkUsersUpdate(r, msg);
  /* Forward to rest of local cluster */
  SendLinkBut(r, IBCP_USERS_UPDATE, msg);
}

void LinkUsersEnd(itemlink *r, char *msg)
{
/*  SendLink(r, IBCP_AUTH_REQUEST, "");*/
  printf("initiate AUTH... when installed\n");
}


/* --- LinkRemote ------------------------------------------------- */

void LinkRemoteCmd(itemlink *r, char *msg)
{
  char name[MINIBUFFER];
  char cmd[MIDBUFFER];
  char buf[BIGBUFFER];

  if (2 >= sscanf(msg, "%s %s %[^\n]", name, cmd, buf)) {
    printf("remote '%s %s' from %s", cmd, buf ? buf : "", name);
  }
}

extern bool chat;
extern itemclient *client;

void LinkRemoteAnswer(itemlink *r, char *msg)
{
  itemclient *t;
  bool c;
  char name[MINIBUFFER];
  char buf[BIGBUFFER];

  if (2 >= sscanf(msg, "%s %[^\n]", name, buf)) {
    printf("remote answer '%s' to %s", buf, name);
    c = chat;
    t = client;
    chat = (client=FindClientByNick(name)) ? TRUE : FALSE;
    Send(name, buf);
    chat = c;
    client = t;
  }
}


/* --- LinkParse -------------------------------------------------- */

#define IDBACKTRACK 1000u

bool IsDuplicate(unsigned long this, unsigned long last)
{
  /* This strange looking code works because we are dealing
   * with unsigned arithmetic. Hopefully the compiler doesn't
   * choose to optimize it away.
   */
  if (this <= last)
    return (this - IDBACKTRACK <= last - IDBACKTRACK);
  return FALSE;
}

void LinkParse(char *line)
{
  itemlink *r;
  char buf[BIGBUFFER];
  char out[BIGBUFFER];
  char *msg;
  int type, rc;
  unsigned long msgid;

  snapshot;

#if 1

  if (2 <= sscanf(line, "%d %d %[^\n]", &msgid, &type, buf))
    {
      msg = buf;
      r = FindLink(fromaddr.sin_addr.s_addr, fromaddr.sin_port);
      if (NULL == r)
	{
	  if (type == IBCP_HELLO)
	    {
	      /* We will only accept a HELLO from unknown destinations. */
	      /* And only if it contains data */
	      if (strlen(msg) > 0)
		{
		  r = LinkHello(msg);
		  if (r)
		    {
		      /* Acknowledge directly */
		      sprintf(out, "%d %d\n", msgid, IBCP_ACK);
		      WriteLinkRaw(r, out);
		      r->yourmsgid = msgid;
		    }
		}
	    }
	  if (NULL == r)
	    return;
	}

      /* r is always set at this point */

      if (IBCP_ACK == type)
	{
	  /* We got an acknowledgement. Dequeue message and send next */
	  LinkDequeue(r, msgid);
	  /* Don't acknowledge acknowledgements... bad karma */
	  return;
	}

      if (IsDuplicate(msgid, r->yourmsgid))
	/* Ignore duplicates */
	return;

      rtt_stop(r);

      if (strlen(msg) > 0)
	{ /* If zero it's only an ack */

#if 1
#ifdef UNRELIABLE
	  if (Rnd() > 0.2) /* Don't acknowledge */
#endif
	    sprintf(out, "%d %d\n", msgid, IBCP_ACK);
	  WriteLinkRaw(r, out); /* &fromaddr */
	  /* bool wantpiggy; ulong piggymsg; */
#endif

	  /*
	   * Check if from authenticated bot. There are two ways to become
	   * authenticated: either by authentication at connect-time, or
	   * through validation by another bot.
	   */

	  if (r->passed)
	    {
	      switch (type)
		{
		case IBCP_QUIT:  /* Link that decided to quit */
		  RemoveLink(r);
		  r = NULL;
		  break;
		case IBCP_ACCEPT:
		  LinkAccept(r);
		  break;
		case IBCP_REJECT:  /* I was rejected by r */
		  RemoveLink(r);
		  r = NULL;
		  break;
		case IBCP_SYNC:  /* Establish or request common time */
		  LinkSync(r, msg);
		  break;
		case IBCP_AUTH:
		  LinkAuth(r, msg);
		  break;
		case IBCP_AUTH_LIST:
		  /* Not broadcasted until AUTH_END is received */
		  LinkAuthList(r, msg);
		  break;
		case IBCP_AUTH_END:
		  LinkAuthEnd(r, msg);
		  break;

		  /* Handle userlist */
		case IBCP_USERS_REQUEST:
		  LinkUsersRequest(r, msg);
		  break;
		case IBCP_USERS_UPDATE:
		  LinkUsersUpdate(r, msg);
		  break;
		case IBCP_USERS_LIST:
		  LinkUsersList(r, msg);
		  break;
		case IBCP_USERS_END:
		  LinkUsersEnd(r, msg);
		  break;

		case IBCP_REMOTE_CMD:
		  LinkRemoteCmd(r, msg);
		  break;
		case IBCP_REMOTE_ANSWER:
		  LinkRemoteAnswer(r, msg);
		  break;

		case IBCP_NICKNAME:
		  LinkNickname(r, msg);
		  break;

		case IBCP_MULTICAST:
		  LinkMulticast(r, msg);
		  break;

		default:
		  break;
		}
	    }
	  else if (type == IBCP_HELLO_REPLY)
	    {
	      /*
	       * HELLO_REPLY is part of the authentication scheme and
	       * therefor we will only accept it if the link isn't
	       * authenticated yet.
	       */
	      LinkHelloReply(r, msg);
	    }
	  r->yourmsgid = msgid;
	}
      r->lasttime = now;
    }

#else

  unsigned long msgid;
  int type;

  /* Skip escape code if present */
  if (*line == IBCP_ESC) line++;

  msg = buf;
  if ( 2 <= sscanf(line, "%d %lu %[^\n]", &type, &msgid, msg) ) {

    r = FindLink(fromaddr.sin_addr.s_addr, fromaddr.sin_port);

    if (type == IBCP_ACK) {
      /* We got an acknowledgement. Dequeue message and send next */
      if (r)
        LinkDequeue(r, msgid);
      /* Don't acknowledge acknowledgements... bad karma */
      return;
    }

    /* Ignore duplicates */
    if (r && IsDuplicate(msgid, r->yourmsgid)) {
      printf("Ignored\n");
      return;
    }

#ifdef UNRELIABLE
    if (Rnd() > 0.2) /* Don't acknowledge */
#endif
      WriteLink(&fromaddr, IBCP_ACK, "");

    if (type == IBCP_HELLO) {
      LinkHello(r, msg);
      return;
    } else if (type == IBCP_HELLO_REPLY) {
      LinkHelloReply(r, msg);
      return;
    }

    if (r) {

      rtt_stop(r);

      /*
       * Check if from authenticated bot. There are two ways to become
       * authenticated: either by authentication at connect-time, or
       * through validation by another bot
       */

      /*if (r->passed)*/ {
        switch (type) {

        case IBCP_QUIT:  /* Link that decided to quit */
          RemoveLink(r);
          break;

        case IBCP_ACCEPT:
          LinkAccept(r);
          break;
        case IBCP_REJECT:  /* I was rejected by r */
          RemoveLink(r);
          break;

        case IBCP_AUTH:
          LinkAuth(r, msg);
          break;
        case IBCP_AUTH_LIST:
	  /* Not passed until AUTH_END is received */
          LinkAuthList(r, msg);
          break;
	case IBCP_AUTH_END:
	  LinkAuthEnd(r, msg);
	  break;

        case IBCP_SYNC:  /* Establish or request common time */
          LinkSync(r, msg);
          break;

	  /* Handle userlist */
        case IBCP_USERS_REQUEST:
          LinkUsersRequest(r, msg);
          break;
        case IBCP_USERS_UPDATE:
          LinkUsersUpdate(r, msg);
          break;
        case IBCP_USERS_LIST:
          LinkUsersList(r, msg);
          break;
        case IBCP_USERS_END:
          LinkUsersEnd(r, msg);
          break;

        case IBCP_REMOTE_CMD:
          LinkRemoteCmd(r, msg);
          break;
        case IBCP_REMOTE_ANSWER:
          LinkRemoteAnswer(r, msg);
          break;

        case IBCP_NICKNAME:
          LinkNickname(r, msg);
          break;

        case IBCP_MULTICAST:
          LinkMulticast(r, msg);
          break;

        default:
          break;
        }
      }
      r->yourmsgid = msgid;
      r->lasttime = now;
    }
  }

#endif
}
