#ifdef RCS
static char rcsid[]="$Id: list.c,v 1.5 1996/08/05 13:34:13 dast Exp $";
#endif
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 * ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing autors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjrn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/list.c,v $
 * $Revision: 1.5 $
 * $Date: 1996/08/05 13:34:13 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: list.c,v $
 * Revision 1.5  1996/08/05 13:34:13  dast
 * removed silly stuff
 *
 * Revision 1.4  1996/07/26 13:35:06  dast
 * AddTail() fix by Jean-Paul DZISIAK <jep@sevex.ceme.phys.ulg.ac.be>
 *
 * Revision 1.3  1996/07/10 16:15:00  dast
 * Added the source header.
 *
 *
 *****************************************************************************/

#include <stdlib.h>
#include "list.h"


/* --- NewEntry --------------------------------------------------- */

inline void *NewEntry(int size)
{
  return ( calloc(1, size) );
}

/* --- DeleteEntry ------------------------------------------------ */

void *DeleteEntry(void *list, void *entry, void (*cleaner)(void *))
{
  header *r;

  if ( list && entry ) {
    r = Remove(list, entry);
    if (*cleaner)
      (*cleaner)(entry);
    free(entry);
    return r;
  }
  return NULL;
}

/* --- AddTail ---------------------------------------------------- */

void AddTail(void *list, void *entry)
{
  header *p, *pp;

  if ( (pp=(header *)list) && (p=(header *)entry) ) {
    p->succ = NULL;
    p->pred = pp->pred;
    ((header *)(p->pred))->succ = pp->pred = p;
  }
}
 

/* --- AddHead ---------------------------------------------------- */

void AddHead(void *list, void *entry)
{
  header *p, *pp;

  if ( (pp=(header *)list) && (p=(header *)entry) ) {
    if (p->succ = pp->succ)
      ((header *)(pp->succ))->pred = p;
    pp->succ = p;
    p->pred = pp;
  }
}

/* --- Remove ----------------------------------------------------- */

void *Remove(void *list, void *entry)
{
  header *p, *pp;

  if ( (pp=(header *)list) && (p=(header *)entry) ) {
    if ( ((header *)p->pred)->succ=p->succ ) {
      ((header *)p->succ)->pred = p->pred;
      return p->succ;
    } else  /* Last entry? */
      pp->pred = p->pred;
  }
  return NULL;
}

/* --- CreateList ------------------------------------------------- */

void *CreateList(int size)
{
  header *p;

  if ( p=NewEntry(size) )
    p->pred = p;
  return p;
}

/* --- FlushList -------------------------------------------------- */

void FlushList(void *v, void (*cleaner)(void *))
{
  header *p, *t, *pp;

  if ( pp=(header *)v ) {
    p = pp->succ;
    while (p) {
      t = p->succ;
      if (*cleaner)
        (*cleaner)(p);
      free(p);
      p = t;
    }
    pp->succ = NULL;
    pp->pred = pp;
  }
}

/* --- DestroyList ------------------------------------------------ */

void DestroyList(void **v, void (*cleaner)(void *))
{
  if (*v) {
    FlushList(*v, cleaner);
    free(*v);
    *v = NULL;
  }
}

/* --- EmptyList -------------------------------------------------- */

inline int EmptyList(void *head)
{
  return (!head || ((header *)head)->pred == (header *)head);
}

/* --- FreeList --------------------------------------------------- */

void FreeList(void *v)
{
  itemlist *p;

  p = (itemlist *)v;
  if (p->ptr) free(p->ptr);
}
