/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 * ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing autors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjrn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/list.h,v $
 * $Revision: 1.6 $
 * $Date: 1996/12/03 17:01:10 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: list.h,v $
 * Revision 1.6  1996/12/03 17:01:10  dast
 * new prototypes
 *
 * Revision 1.5  1996/08/30 11:29:13  dast
 * removed old header
 *
 * Revision 1.4  1996/07/23 08:48:47  dast
 * Amiga port fix
 *
 * Revision 1.3  1996/07/10 16:15:00  dast
 * Added the source header.
 *
 *
 *****************************************************************************/

#ifndef __LIST_H
#define __LIST_H

#undef NULL
#define NULL 0

#if !defined(__GNUC__) && !defined(__SASC)
#define inline
#endif
#if defined(__SASC)
#define inline __inline
#endif

typedef struct Header {
  void *succ;
  void *pred;
} header;

typedef struct Liststruct {
  struct Header h;
  void *ptr;
} itemlist;

#define Succ(x) ((x)->h.succ)
/*#define Pred(x) ((x) == (x)->h.pred ? NULL : (x)->h.pred)*/
#define Pred(x) ((x)->h.pred)

inline void *NewEntry(int size);
void *DeleteEntry(void *list, void *entry, void (*cleaner)(void *)); /* returns succ */

void AddHead(void *list, void *entry);
void AddTail(void *list, void *entry);
#define RemHead(x) (Remove((x),(x).h->succ))
#define RemTail(x) (Remove((x),(x).h->pred))
void *Remove(void *list, void *entry); /* returns succ */

/* Move y from x to head/tail of z */
#define MoveHead(x,y,z) {\
  Remove(x,y);\
  AddHead(z,y);}
#define MoveTail(x,y,z) {\
  Remove(x,y);\
  AddTail(z,y);}

/* Create sentinel for new list */
void *CreateList(int size);
/* Remove an entire list including sentinel */
void DestroyList(void **list, void (*cleaner)(void *));
/* Remove all entries except the sentinel */
void FlushList(void *list, void (*cleaner)(void *));
/* Returns FALSE if entries in list apart from sentinel */
inline int EmptyList(void *list);

/* Aux func for itemlist */
void FreeList(void *);

#endif
