#ifdef RCS
static char rcsid[]="$Id: netstuff.c,v 2.14 1998/05/16 20:46:31 dast Exp $";
#endif
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 *  ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing authors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjorn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/netstuff.c,v $
 * $Revision: 2.14 $
 * $Date: 1998/05/16 20:46:31 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: netstuff.c,v $
 * Revision 2.14  1998/05/16 20:46:31  dast
 * added 'myhost' support to .config
 *
 * Revision 2.13  1998/03/23 18:32:21  dast
 * multi home support adjusted (again)
 *
 * Revision 2.12  1998/02/14 11:34:30  dast
 * revised multi IP support
 *
 * Revision 2.11  1998/01/29 15:28:11  dast
 * breese's multihost fix
 *
 * Revision 2.10  1998/01/27 22:02:06  dast
 * Tero's bugfixes
 *
 * Revision 2.9  1997/11/25 16:57:12  dast
 * corrected some weird YP usage
 *
 * Revision 2.8  1997/11/24 23:35:33  dast
 * breese's patch applied
 *
 * Revision 2.7  1997/11/05 22:03:24  dast
 * updated!
 *
 * Revision 2.6  1997/08/25 17:50:03  dast
 * fileget stuff
 *
 * Revision 2.5  1997/08/25 15:01:53  dast
 * Initial (<= 4.7beta6) FILEGET stuff implemented
 *
 * Revision 2.4  1997/07/15 07:46:21  dast
 * Tiny change to enable amiga compiling without error
 *
 * Revision 2.3  1997/04/28 16:42:23  dast
 * Added a patch for systems lacking getdtablesize()!
 *
 * Revision 2.2  1997/02/10 19:38:49  dast
 * #ifdefed some linkbot stuff
 *
 * Revision 2.1  1997/01/27 17:11:42  dast
 * botlink stuff added
 *
 * Revision 1.27  1996/11/27 20:42:58  dast
 * breese added a comment
 *
 * Revision 1.26  1996/11/27 20:35:04  dast
 * gr8ron's amiga patch
 *
 * Revision 1.25  1996/11/17 14:00:38  dast
 * breese re-fixed the problem ;)
 *
 * Revision 1.24  1996/11/17 10:00:13  dast
 * breese fixed the DCC/Linux problem
 *
 * Revision 1.23  1996/11/04 19:17:54  dast
 * breese fix
 *
 * Revision 1.22  1996/09/23 18:12:35  dast
 * removed that thing again
 *
 * Revision 1.21  1996/09/18 09:25:36  dast
 * Fixed ntohl() in the own IP number get
 *****************************************************************************/

/*
 * Lowlevel socket handling.
 * (Primarily based on IPC primer 4.2)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/param.h>
#if defined(AMIGA) && !defined(__GNUC__)
# include <sys/errno.h>
# include <sys/ioctl.h>
#else
# include <fcntl.h>
# ifdef HAVE_YP_MASTER
#  include <rpcsvc/ypclnt.h>
# endif
#endif
#if defined(__amigaos__) && !defined(__GNUC__)
# include <sys/fcntl.h>
# include <sys/utsname.h>
#endif

#include "dancer.h"
#include "function.h"
#include "user.h"
#include "server.h"
#include "transfer.h"
#include "netstuff.h"
#include "link.h"

#ifndef INADDR_NONE
#define INADDR_NONE -1
#endif

/* --- Global ----------------------------------------------------- */

extern bool restart;
extern int serverSocket;
extern itemclient *clientHead;
extern time_t lastevent;
extern itemexec *execHead;
extern bool cleanup, chat;
extern char nameserver[];
extern itemident *current;

extern char dancer_myhost[];

fd_set rdset;
fd_set wrset;
fd_set global_readset;
fd_set global_writeset;
itemclient *client = NULL;

#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 64
#endif

time_t now = 0;
int linkSocket = -1;
struct sockaddr_in linkaddr;
struct sockaddr_in fromaddr;
ulong myipaddrnum = 0;
char myhost[MIDBUFFER];


/* --- GetHost ---------------------------------------------------- */
#ifdef 4_8_3beta
struct hostent *GetHost(char *hostname)
{
  struct hostent *h = NULL;
  ulong in;

  if ( (in=inet_addr(hostname)) != INADDR_NONE ) {
    if ( (h=gethostbyaddr((char *)&in, sizeof(in), AF_INET)) == NULL )
      Debug("gethostbyaddr(2) failed for %s (%s)",
            hostname, strerror(errno));
  } else if ( (h=gethostbyname(hostname)) == NULL ) {
    Debug("gethostbyname(2) failed for %s (%s)",
          hostname, strerror(errno));
  }
  return (h);
}
#else
struct hostent *GetHost(char *hostname)
{
  struct hostent *h = NULL;
  ulong in;
  static struct hostent he;
  static char name[MAXHOSTNAMELEN];
  static char *addrlist[2];
  static struct in_addr addrentry;

  if ( (in=inet_addr(hostname)) != INADDR_NONE ) {
#if 0
    if ( (h=gethostbyaddr((char *)&in, sizeof(in), AF_INET)) == NULL )
      Debug("gethostbyaddr(2) failed for %s (%s)",
            hostname, strerror(errno));
#else
    addrentry.s_addr = in;
    addrlist[0] = (char *)&addrentry;
    addrlist[1] = NULL;
    he.h_name = strncpy(name, MakeIP(ntohl(in)), MAXHOSTNAMELEN);
    he.h_addrtype = AF_INET;
    he.h_length = sizeof(struct in_addr);
    he.h_addr_list = addrlist;
    h = &he;
#endif
  } else if ( (h=gethostbyname(hostname)) == NULL ) {
    Debug("gethostbyname(2) failed for %s (%s)",
          hostname, strerror(errno));
  }
  return (h);
}
#endif

/* --- MakeIP ----------------------------------------------------- */

char *MakeIP(ulong num)
{
#ifdef HAVE_INET_NTOA
  struct in_addr in;

  in.s_addr = htonl(num);
  return (inet_ntoa(in));
#else
  static char addr[MIDBUFFER];
  unsigned char *paddr;

  num = htonl(num);  /* htonl() added to avoid endian probs */
  paddr = (unsigned char *)&num;
  sprintf(addr, "%u.%u.%u.%u", paddr[0], paddr[1], paddr[2], paddr[3]);
  return (addr);
#endif
}

/* --- CloseConnection -------------------------------------------- */

void CloseConnection(int sock)
{
  if (sock >= 0) {
    FD_CLR(sock, &rdset);
    FD_CLR(sock, &wrset);
    close(sock);
  }
}

/* --- SetSockOpt ------------------------------------------------- */

void SetSockOpt(int sock)
{
  struct linger l;

  setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, 0, 0);
  setsockopt(sock, SOL_SOCKET, SO_KEEPALIVE, 0, 0);
  l.l_onoff = l.l_linger = 0;
  setsockopt(sock, SOL_SOCKET, SO_LINGER, (char *)&l, (int)sizeof(l));
}

/* --- Connect ---------------------------------------------------- */

void Blocking(int sock)
{
#if !defined(AMIGA) || defined(__GNUC__)
  int flags;

  flags = fcntl(sock, F_GETFL, 0);
#ifdef NBLOCK_BSD
  fcntl(sock, F_SETFL, flags&(~FNDELAY));
#else
  fcntl(sock, F_SETFL, flags&(~O_NONBLOCK));
#endif
#else
  IoctlSocket(sock, FIONBIO, 1L);
#endif
}

void NonBlocking(int sock)
{
#if !defined(AMIGA) || defined(__GNUC__)
  int flags;

  flags = fcntl(sock, F_GETFL, 0);
#ifdef NBLOCK_BSD
  fcntl(sock, F_SETFL, flags|FNDELAY);
#else
  fcntl(sock, F_SETFL, flags|O_NONBLOCK);
#endif
#else
  IoctlSocket(sock, FIONBIO, 0L);
#endif
}

void Connected(itemclient *k)
{
  k->status = CL_CONNECTED;
  SetSockOpt(k->socket);
  FD_CLR(k->socket, &wrset);
  FD_SET(k->socket, &rdset);
  Blocking(k->socket);
  Logf(LOGCLIENT, "Connection accepted at socket %d", k->socket);
}

int Connect(int s, void *psa)
{
  struct sockaddr_in sa;

  memset(&sa, NIL, sizeof(sa));
  sa.sin_family = ((struct sockaddr_in *)psa)->sin_family;

  /* Bind to INADDR_ANY to allow connections to any local interface */
  sa.sin_addr.s_addr = (myipaddrnum == 0) ? htonl(INADDR_ANY) :
    htonl(myipaddrnum);

  sa.sin_port = htons(0);
  bind(s, (struct sockaddr *)&sa, sizeof(sa));
  return ( connect(s, (struct sockaddr *)psa, sizeof(struct sockaddr_in)) );
}

/* Non-blocking connect */

bool ConnectNB(itemclient *k)
{
  int flags;

  FD_SET(k->socket, &wrset);
  errno = 0;

  NonBlocking(k->socket);
  if ( Connect(k->socket, &(k->addr)) >= 0 ) {
    Connected(k);
    return TRUE;
  } else {
    k->status = CL_CONNECTING;
    return (errno == EINPROGRESS || errno == EAGAIN || errno == EWOULDBLOCK);
  }
}

itemclient *ConnectMe(itemclient *k)
{
  /* Re-issue the connect() to get the error */
  /* Better to use getsockopt(SOL_ERROR) ? */
  if ( Connect(k->socket, &(k->addr)) == -1) {
    if (errno != EISCONN) {
      ReplyCtcpf(k->ident->nick, "ERRMSG Unable to establish connection (%s)", strerror(errno));
      Logf(LOGCLIENT, "Connection failed for %s on socket %d (%s)", k->ident->nick, k->socket, strerror(errno));
      return (RemoveClient(k));
    }
  }
  Connected(k);
  return k;
}

/* --- OpenConnection --------------------------------------------- */

int OpenServerConnection(char *hostname, int port)
{
  return ( OpenConnection(hostname, port) );
}

itemclient *OpenClientConnection(char *from, char *uhost, itemuser *user,
				 char *hostname, int port)
{
  struct hostent *hp=NULL;
  itemclient *k;

  if ( hp=GetHost(hostname) ) {

    if (k=AddClient(from, uhost, user, -1)) {
      memcpy((char *)&(k->addr.sin_addr), hp->h_addr, hp->h_length);
      k->addr.sin_family = hp->h_addrtype;
      k->addr.sin_port = htons((unsigned short)port);
      if ( (k->socket=socket(hp->h_addrtype, SOCK_STREAM, 0)) != -1 ) {
	if ( ConnectNB(k) ) {
          k->linksort = OUT_CHAT; /* mark this as chat */
	  return k;
        }
      }
      RemoveClient(k);
    }
  }
  return NULL;
}

int OpenConnection(char *hostname, int port)
{
  struct hostent *hp=NULL;
  struct sockaddr_in sa;
  struct linger l;
  int s;

  if ( hp=GetHost(hostname) ) {

    memset((char *)&sa, NIL, sizeof(sa));
    memcpy((char *)&sa.sin_addr, hp->h_addr, hp->h_length);
    sa.sin_family = hp->h_addrtype;
    sa.sin_port = htons((unsigned short)port);

    if ( (s=socket(hp->h_addrtype, SOCK_STREAM, 0)) != -1 ) {
      if ( Connect(s, &sa) >= 0) {
	SetSockOpt(s);
	FD_SET(s, &rdset);
	return s;
      } else {
	CloseConnection(s);
	Debug("connect(2) failed on socket %d (%s)",
	      s, strerror(errno));
	return -1;
      }
    } else
      Debug("socket(2) failed for %s (%s)",
            hostname, strerror(errno));
  }
  return -1;
}

/* --- OpenListener ----------------------------------------------- */

itemclient *OpenListener(char *from, char *uhost, itemuser *user)
{
  struct sockaddr_in sa;
  struct hostent *h;
  itemclient *k;
  int size;

  if ( h=GetHost(myhost) ) {

    if (k=AddClient(from, uhost, user, -1)) {
      k->status = CL_LISTENING;

      if ( (k->socket=socket(AF_INET, SOCK_STREAM, 0)) >= 0 ) {
        memset((char *)&sa, NIL, sizeof(sa));
        memcpy((char *)&sa.sin_addr, h->h_addr, h->h_length);
        sa.sin_family = AF_INET;
        sa.sin_addr.s_addr = INADDR_ANY;
        sa.sin_port = 0;
	size = sizeof(sa);
        if ( bind(k->socket, (struct sockaddr *)&sa, size) >= 0 ) {
          if ( listen(k->socket, 1) >= 0 ) {
            FD_SET(k->socket, &rdset);
            /* Re-using sa */
	    size = sizeof(&(k->addr));
            getsockname(k->socket, (struct sockaddr *) &(k->addr), &size);
            return k;
          } else
            Debug("listen(2) failed on socket %d (%s)", k->socket, strerror(errno));
        } else
          Debug("bind(2) failed on socket %d (%s)", k->socket, strerror(errno));
      } else
        Debug("socket(2) failed (%s)", strerror(errno));
      RemoveClient(k);
    }
  }
  return NULL;
}

/* -------------------------------------------------------------- */

int OpenLink(void)
{
  int s, size;

  if ( (s=socket(AF_INET, SOCK_DGRAM, NULL)) >= 0 ) {
    size = sizeof(linkaddr);
    memset((char *)&linkaddr, NIL, size);
    linkaddr.sin_family = AF_INET;
    linkaddr.sin_addr.s_addr = htonl(INADDR_ANY);
    linkaddr.sin_port = htons(0);
    if ( bind(s, (struct sockaddr *)&linkaddr, size) >= 0 ) {
      FD_SET(s, &rdset);
      getsockname(s, (struct sockaddr *)&linkaddr, &size);
      return s;
    }
  }
  return -1;
}

/* --- Outgoing ------------------------------------------------- */

void Outgoing(char *from, char linksort, char *opts)
{
  itemclient *k;
  char buffer[BIGBUFFER];
  char buffer2[BIGBUFFER];

  if (!from)
    from = current->nick;
  if (OUT_LINK == linksort) {
    SendCtcpf(from, "DCC LINK UDP %lu %u",
	      myipaddrnum, htons(linkaddr.sin_port));
  } else {
    if(OUT_CHAT == linksort) {
      if ( k=OpenListener(from, current->host, current->user) ) {
        SendCtcpf(from, "DCC CHAT chat %lu %u",
                  myipaddrnum, htons(k->addr.sin_port));
        k->linksort = linksort;
      } else
        ReplyCtcp(from, "ERRMSG Unable to establish connection");
    }
#ifdef BAGDER
    else if(OUT_SEND == linksort) {
      int file;
      char *ptr;
      bool uselocal=TRUE;
      while('/' == opts[0])
        opts++;
      sprintf(buffer, "%s/%s", DCC_FILEPATH, opts);
      sprintf(buffer2, "%s/%s", DCC_FILECACHE, opts);
      /*      strcpy(buffer2, buffer); */
      ptr = buffer2+strlen(DCC_FILECACHE)+1;
      while(*ptr) {
        if('/' == *ptr)
          *ptr='_';
        ptr++;
      }
      /* Things done here:
         1) Check if the file is in the cache, and use that if it is
         2) - fetch the file from the primary site and write it in the
              cache dir, start DCCing as soon as the file grows
              (timout the wait in X seconds, 20<X<60 seconds)
              and continue until the fetch signals DONE (even if some
              reads may not give new data due to slow ftp fetch)
            - when the ftp is done (the Exec() job is complete), the
              client should get noted
            - file existance and size should be checked, 0 bytes means
              failed ftp => abort DCC (retry next ftp site when multiple
              ones are supported)
              */

      /* First out, check for the file in the cache */
      file = open(buffer2, O_RDONLY);
      if(file<0) {
        /* not in the cache, we need to get it from the ftp site */
        int socket; /* to read the file from */
        
        /* Get the file from the FTP server, we lock this synchronously at
           least for a start, all the way until we start downloading the
           file, which will be done as a receiving socket as on additional
           socket client */
        if(!ftpget(site, buffer, &socket, &size)) {
          /* we got a file size and a socket back, use them both */
          itemclient *k=AddClient(from, NULL, NULL, socket);
          if(k) {
            file = open(temporary, O_RDONLY);
          }
        }
      }
      if(0<=file) {
        /* add this download to the cache */
        CacheAdd(buffer2);
      }

      if(file>0) {
        char *filebuffer = malloc(CLF_FILEBUFFER);
        
        if ( buffer &&
             (k=OpenListener(from, current->host, current->user)) ) {
          char *filepart;

          k->file = file;
          k->linksort = linksort;
          k->lasttime = time(NULL);
          k->filebuffer = filebuffer;
          if(uselocal)
            /* if this is a local file, it is considered complete already */
            k->fileflags |= CLF_FILECOMPLETE;

          filepart = strrchr(buffer, '/');
          if(filepart)
            filepart++;
          else
            filepart=buffer;

          /* That silly AmIRC client requires a file length parameter! */
          SendCtcpf(from, "DCC SEND %s %lu %u -1 ", filepart,
                    myipaddrnum, htons(k->addr.sin_port));
          fprintf(stderr, "DCC SEND %s %lu %u -1\n", filepart,
                  myipaddrnum, htons(k->addr.sin_port));
        }
        else
          ReplyCtcp(from, "ERRMSG Unable to establish connection");
      }
      else {
        ReplyCtcp(from, "ERRMSG Unable to get the specified file");
      }
    }
#endif
  }
}

/* --- Incomming ------------------------------------------------ */

itemclient *Incomming(itemclient *k)
{
  int s, size = sizeof(struct sockaddr_in);

  /* Notez-bien: accept() may block */
  if ( s=accept(k->socket, (struct sockaddr *) &(k->addr), &size) ) {
    CloseConnection(k->socket);
    FD_SET(s, &rdset);
    if(OUT_SEND == k->linksort) {
      FD_SET(s, &wrset);
      fprintf(stderr, "File sending initiated, here it should come...\n");
    }
    k->socket = s;
    k->status = CL_CONNECTED;
    Logf(LOGCLIENT, "Connection accepted at socket %d", k->socket);
  } else {
    Debug("accept(2) failed on socket %d", k->socket);
    return (RemoveClient(k));
  }
  return (Succ(k));
}


/* --- Alive ------------------------------------------------------ */

/* From Titan */

bool Alive(int s)
{
  struct sockaddr name;
  int namelen;
  
  namelen = sizeof(name);
  if ( getpeername(s, &name, &namelen) < 0 ) {
    if (errno == ENOTCONN) {
      errno=0;
      return FALSE;
    }
  }
  return TRUE;
}

/* --- ReadSocket ------------------------------------------------- */

int ReadSocket(int sock, char *buf)
{
  char c;
  int i = 0;

  do {
    if ( read(sock, &c, 1) < 1 ) return 0;
    if ( i < MAXLINE ) buf[i++] = c;
  } while (c != '\n');
  buf[i] = NIL;
#ifdef DBUG
  fprintf(stderr, "%d < %s", sock, buf);
#endif
  return i;
}

static int ReadFileSendSocket(int sock, char *buf)
{
  char c;
  int i = 0;

  do {
    if ( read(sock, &c, 1) < 1 )
      return 0;
    buf[i++] = c;
  } while (i < 4); /* this *IS* always 4-bytes as "defined" in the crappy
                      DCC SEND standard */
  return i;
}

static int WriteFileSendSocket(itemclient *k)
{
  int n=0;
  if(k->filesent == k->fileacked)
    n = read(k->file, k->filebuffer, CLF_FILEBUFFER);
  else
    return 1; /* don't terminate now */

  if(n>0) {
    int err = write(k->socket, k->filebuffer, n);
    k->filesent += n;
    fprintf(stderr, "write() returned %d - sent %d bytes\n", err, k->filesent);
  }
  return n;
}


/* --- WriteSocket ------------------------------------------------ */

inline void WriteSocket(int sock, char *msg)
{
  /*  strcat(msg, "\n");*/ /* Append a newline */
#ifdef DBUG
  fprintf(stderr, "%d > %s\n", sock, msg);
#endif
  write(sock, msg, strlen(msg));
  write(sock, "\n", 1);
}

void WriteSocketf(int sock, char *fmt, ...)
{
  char buf[MAXLINE];
  va_list args;

  va_start(args, fmt);  
  vsprintf(buf, fmt, args);
  va_end(args);
  WriteSocket(sock, buf);
}

/* --- WriteNick -------------------------------------------------- */

inline void WriteNick(char *nick, char *msg)
{
  WriteSocketf(serverSocket, "NOTICE %s :%s", nick, msg);
}

/* --- WriteServer ------------------------------------------------ */

void WriteServer(char *fmt, ...)
{
  static char buf[MAXLINE];
  va_list args;

  va_start(args, fmt);
  vsprintf(buf, fmt, args);
  va_end(args);
  WriteSocket(serverSocket, buf);
}

/* --- HandleSockets ---------------------------------------------- */

void HandleSockets(fd_set *readset, fd_set *writeset)
{
  itemclient *p, *k;
  itemexec *px, *pxx;
  char buf[MAXLINE];
  int i=0;

  /* --- Server message */

  if ( FD_ISSET(serverSocket, readset) ) {
    if (ReadSocket(serverSocket, buf) > 0)
      ParseServer(buf);
    else { /* Error or EOF from server */
      Debug("EOF from server (%s)", strerror(errno));
      DisconnectServ("EOF from server (%s)", strerror(errno));
      restart = cleanup = TRUE;
    }
  }

#ifdef BREESE
  /* --- Link bots */

  if ( FD_ISSET(linkSocket, readset) )
    if ( ReadLink(buf) > 0 )
      LinkParse(buf);
#endif
  /* --- Dcc chat client */

  p = Succ(clientHead);
  while (p) {
    if (FD_ISSET(p->socket, readset)) {
      if (p->status == CL_LISTENING) {
        /*
         * If we got something on a listen connection
         * go ahead and accept it.
         */
        p = Incomming(p);
        continue; /* while */
      } else {
        /*
         * Message on a normal client connection
         */
        int s;
        client = p;

        if(OUT_SEND == p->linksort) {
          /* This is a file sending socket, we might/should receive ACKs on
             this. */
          unsigned int ack;
          unsigned int networkack;
          s = ReadFileSendSocket(p->socket, (char *)&networkack);
          ack = ntohl(networkack);
          p->fileacked = ack; /* this many bytes acknowledged from the peer */
          fprintf(stderr, "=> GOT ACK %d\n", ack);
        }
        else
          s = ReadSocket(p->socket, buf);

        switch ( s ) {
        case -1:  /* Read error on client */
          Debug("Error on client (%s)", strerror(errno));
          break;
        case 0:  /* EOF from client */
          p = RemoveClient(p);
          continue; /* while */
        default:
          if(OUT_CHAT == p->linksort)
            DccCommand(buf);
          /*          else
                      fprintf(stderr, "got file data\n"); */
          for (k=Succ(clientHead); k && (k != p); k=Succ(k))
            ;
          if ( !k ) {
            p = Succ(clientHead);
            for (; i ; i--)
              p = Succ(p);
	    continue;
	  }
          break;
        } /* switch */
      }
    }
    /*
     * Write signal is only received when a non-blocking
     * connection is established.
     */
    if ( FD_ISSET(p->socket, writeset) ) {
      if (p->status == CL_CONNECTING) {
        p = ConnectMe(p);
        continue; /* while */
      }
      else if (OUT_SEND == p->linksort) {
        /* fprintf(stderr, "sending file\n"); */
        if(0>=WriteFileSendSocket(p) &&
           (p->fileflags & CLF_FILECOMPLETE)) {
          /* we couldn't read and the file is considered complete */
          fprintf(stderr, "sending file done, %d bytes written!\n",
                  p->filesent);
          p = RemoveClient(p);
          continue;
        }
      }
    }
    p = Succ(p);
    i++;
  } /* while */

  /* --- Shell command */

  px = execHead->next;
  while (px) {
    if ( FD_ISSET(px->socket, readset) ) {
      px = GotExec(px);
      continue; /* while */
    }
    px = px->next;
  }

  lastevent = time(NULL);
}

#ifndef HAVE_GETDTABLESIZE

/* This is typically done for HPUX systems */

#include <sys/resource.h>

#ifndef FD_SETSIZE
#define FD_SETSIZE 64
#endif

int getdtablesize(void)
{
  struct rlimit rlp;
  if(!getrlimit(RLIMIT_NOFILE, &rlp)) {
    return rlp.rlim_cur;
  }
  else
    return FD_SETSIZE; /* failed */
}
#endif


/* --- EventLoop -------------------------------------------------- */

static struct timeval stamp;

void EventLoop()
{
  struct timeval curtime, dt;
  long diff;
  int fdsize;
  fd_set rtmpset, wtmpset;

  gettimeofday(&stamp, NULL);

  while (!cleanup) {

    client = NULL;
    chat = FALSE;

    /* Calculate the timeout value */
    gettimeofday(&curtime, NULL);
    if (curtime.tv_usec > stamp.tv_usec)
      curtime.tv_usec += MILLION;
    diff = RTIMER - (MILLION * (curtime.tv_sec - stamp.tv_sec)) - (curtime.tv_usec - stamp.tv_usec);

    if (diff > 0) {
      dt.tv_sec  = diff / MILLION;
      dt.tv_usec = diff % MILLION;

      rtmpset = rdset;
      wtmpset = wrset;
      errno = 0;

      /*
       * We are not expecting any out-of-band messages,
       * so the exceptfds argument is set to NULL
       */
      fdsize = getdtablesize();
      if (fdsize > FD_SETSIZE) fdsize = FD_SETSIZE;

      switch ( select(fdsize, &rtmpset, &wtmpset, NULL, &dt) ) {

      case -1: /* Ignore errors and interrupts */
	if (errno == EINTR)
	  continue;
        Debug("select(2) failed (%s)", strerror(errno));
        cleanup = TRUE;
        restart = FALSE;
        break;

      case 0:  /* select(2) timeout */
        gettimeofday(&stamp, NULL);
	now = stamp.tv_sec;
        TimeEvents();
        break;

      default: /* Data on socket */
	now = time(NULL);
        HandleSockets(&rtmpset, &wtmpset);
        break;
      }

    } else { /* Timeout overdue, activate immediately */
      gettimeofday(&stamp, NULL);
      now = stamp.tv_sec;
      TimeEvents();
    }
  }
}

/* --- InitNet ---------------------------------------------------- */

void InitNet()
{
  char *ns;
  struct hostent *h;
  char dm[80];

  /*
   * Getting the actual name@host has proved troublesome on many
   * machines, this ugly solution was added quickly to get Darxide
   * up and running quickly, and therefore this "feature" remains
   * undocumented until we have sorted out how to deal with it.
   */
  char *problemsolver = getenv("DANCER_MYHOST");

  /* Added 1998-05-11 by Bagder, if the environment variable isn't set,
     try the config value if set */
  if(!problemsolver)
    if(dancer_myhost[0])
      problemsolver = dancer_myhost;

  if (problemsolver) {
    strcpy(myhost, problemsolver);
    myipaddrnum = (ulong)(ntohl(inet_addr(myhost)));
    if(!myipaddrnum) {
      Logf(LOGDEBUG, "Failed to inet_addr() the host '%s'", myhost);
    }
  }
  else {
  /*
   * If no host was set in the environment (can also happen if
   * started from cron) we'll try to get it ourselves. Changes
   * are that we only get 'host' and not 'host.domain'.
   */
#if defined(__amigaos__) && !defined(__GNUC__)
    struct utsname utstmp; /* added 970620 to 4.6.4 to make it compile on
                              amiga by Bagder */
    uname(&utstmp);
    strcpy(myhost, utstmp.nodename);
#else
    gethostname(myhost, MAXHOSTNAMELEN);
#endif
  }

  if ( (myipaddrnum == 0) && (h=GetHost(myhost)) ) {
    /*
     * The IP# is needed for outgoing dcc chats
     */
    myipaddrnum = (ulong)(ntohl(((struct in_addr *)h->h_addr)->s_addr));

    /*
     * If our previous attempt to get the domain name along with
     * the host name failed, let's try to find the domain now.
     */
    if (strchr(myhost, '.') == NULL) {
      /*
       * First we try an inverse DNS lookup
       */
      ns = MakeIP(myipaddrnum);
      h = GetHost(ns);
      if (strchr(h->h_name, '.')) {
        strcpy(myhost, h->h_name);
      } else {
        /*
         * Then we examine the aliases
         */
        int i;
        for (i=0; h->h_aliases[i]; i++)
          if (strchr(h->h_aliases[i], '.')) {
            strcpy(myhost, h->h_aliases[i]);
            break; /* for */
          }
#ifdef HAVE_GETDOMAINNAME
        if (strchr(myhost, '.') == NULL) {
          /*
           * One last desperate attempt. The name received from
           * getdomainname() isn't necessarily the full domain name.
           */
          getdomainname(dm, 80);
          if (*dm && strchr(dm, '.')) {
            strcat(myhost, ".");
            strcat(myhost, dm);
          }
          else {
            /*
             * the machine does not know and we have to ask the nameserver
             */
#if 0
            fprintf(stderr,
                    "We can't get our own hostmask!\n"
                    "Use 'setenv DANCER_MYHOST <full hostname>' and restart.");
            exit(5);
#endif
          }
        }
#endif
      }
    }
  }

#if defined(HAVE_YP_GET_DEFAULT_DOMAIN) && (HAVE_YP_MASTER)
  if (!*nameserver) {
    char *my_defaultdomain;
    char *my_nameserver;
    if (!yp_get_default_domain(&my_defaultdomain)) {
      if (!yp_master(my_defaultdomain, "hosts.byname", &my_nameserver))
        strcpy(nameserver, my_nameserver);
    }
  }
#endif

  FD_ZERO(&rdset);
  FD_ZERO(&wrset);

#ifdef BREESE
  memset((char *)&fromaddr, NIL, sizeof(fromaddr));
  fromaddr.sin_family = AF_INET;
  linkSocket = OpenLink();
#endif
}

/* --- CleanupNet ------------------------------------------------- */

void CleanupNet()
{  
  CloseConnection(linkSocket);
  CloseConnection(serverSocket);
}
