/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 * ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing autors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjrn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/netstuff.h,v $
 * $Revision: 1.10 $
 * $Date: 1997/11/05 22:03:24 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: netstuff.h,v $
 * Revision 1.10  1997/11/05 22:03:24  dast
 * updated!
 *
 * Revision 1.9  1997/08/25 17:50:03  dast
 * fileget stuff
 *
 * Revision 1.8  1997/01/27 17:15:13  dast
 * new link protos
 *
 * Revision 1.7  1996/12/03 17:01:36  dast
 * new prototypes
 *
 * Revision 1.6  1996/08/21 11:17:31  dast
 * breese's update
 *
 * Revision 1.5  1996/08/05 13:34:13  dast
 * breese's major fix package ;)
 *
 * Revision 1.4  1996/07/26 11:34:58  dast
 * changed OpenClientConnection()
 *
 * Revision 1.3  1996/07/10 16:15:00  dast
 * Added the source header.
 *
 *
 *****************************************************************************/

#ifndef __NETSTUFF_H
#define __NETSTUFF_H

#include "dancer.h"
#include "user.h"
#include <netinet/in.h>

void InitNet(void);
void CleanupNet(void);
int OpenConnection(char *, int);
int OpenServerConnection(char *, int);
itemclient *OpenClientConnection(char *, char *, itemuser *, char *, int);
void CloseConnection(int);
bool Alive(int);
void EventLoop(void);
inline void WriteNick(char *, char *);
void WriteServer(char *, ...);
inline void WriteSocket(int, char *);
void WriteSocketf(int, char *, ...);
char *MakeIP(ulong);
void Outgoing(char *, char, char *);

#define OUT_LINK 1
#define OUT_CHAT 2
#define OUT_SEND 3

/* *NO* trailing slash on the dir names below! */

/* add this to the left of all names you're getting */
#define DCC_FILEPATH "/pub"

/* this is the directory for the local cached files */
#define DCC_FILECACHE "./tmp"

/* this is the primary ftp site to download from */
#define DCC_PRIMARY_FTP "lisa.sth.frontec.se"
#endif
