#ifndef __NEWS_H
#define __NEWS_H
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 *  ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing authors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjorn.Stenberg@sth.frontec.se>
 *  - Andrew Gray <DarkDesigns@trader.com>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer/
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/news.h,v $
 * $Revision: 1.1 $
 * $Date: 1997/05/28 06:23:21 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: news.h,v $
 * Revision 1.1  1997/05/28 06:23:21  dast
 * Initial revision
 *
 *****************************************************************************/

#define NEWS_URGENT (1<<0)

typedef struct NewsStruct {
  struct Header h;
  long id;          /* unique ID */
  time_t time;      /* time of add */
  long level;       /* level required to get this */
  char *author;     /* who added this */
  long flags;       /* flags as defined below */
  long expire;      /* number of days this is allowed to live */
  char *match;      /* account match */
  char *news;       /* the actual news */
} itemnews;

void NewsSave(void);
bool NewsAddItem(char *author,
                 long level,
                 long id,
                 time_t time,
                 long flags,
                 long expire,
                 char *match,
                 char *news);
void NewsInit(void);
void NewsCleanup(void);
long NewsID(void);
void NewsReport(itemident *);
void NewsList(char *, long);

#endif
