#ifdef RCS
static char rcsid[]="$Id: parse.c,v 1.10 1998/05/28 14:35:43 dast Exp dast $";
#endif
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 * ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing autors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjrn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/parse.c,v $
 * $Revision: 1.10 $
 * $Date: 1998/05/28 14:35:43 $
 * $Author: dast $
 * $State: Exp $
 * $Locker: dast $
 *
 * ---------------------------------------------------------------------------
 * $Log: parse.c,v $
 * Revision 1.10  1998/05/28 14:35:43  dast
 * Ray Akey <rakey@cnetbbs.net> removed the post increment in the tolower()
 * macro
 *
 * Revision 1.9  1998/03/25 17:29:51  dast
 * Fixed the RESTOFLINE space separator bug
 *
 * Revision 1.8  1998/02/14 11:34:50  dast
 * amiga adjusted
 * added better boundary checks
 *
 * Revision 1.7  1996/07/23 08:48:47  dast
 * Amiga port fix
 *
 * Revision 1.6  1996/07/23 07:55:19  dast
 * new ifdefs
 *
 * Revision 1.5  1996/07/10 16:15:00  dast
 * Added the source header.
 *
 *
 *****************************************************************************/
/************************************************************************
 * Thoughts and theories...

 Hi!
 
 Here are some of my confused and mixed first plans and thougts around
 first the aliases we've been discussing before, but then also a little
 about how the future "extensions" of the bot could look like. Overkill
 for a bot? naah... ;)
 
alias COMMAND REPLACEMENT - sets an alias

REPLACEMENT can be any sequence of
 - plain text like in

 	alias commandlist cmdslist

 - arguments from the entered sequence, specified with $<number> when making
   the alias, like in:
   
	alias fastban ban $1 10

   Writing it like $2- means all arguments from the 2nd to the end of the
   line, like in

   	alias msg do privmsg $1 : $2-

   Writing it like $2? means number two if there is any number 2! Can also
   be used together with - like in:

        alias kick DO kick $channel $1 :$2?-

 - generic 'variables' and inline information, specified with $<name> for
   the info you'd like added at the place, like in:

	alias topic do topic $channel :$1-
        
 - $-letters for inclusion in the aliased command must be written with two
   of them in a row, like in:
   
	alias dollars say please send me some $$ now!!!

 - built-in functionality for random picks, like:
 
 	alias killme $( ban $nick $| say no way, you're my friend $)
	
   or more sofisticated:
   
   	alias saysome $( kick $nick $| $(say hi $| say no $) $)

   lots of alternatives:
   
   	alias tryme $(ban $nick $| say one $| say two $| say three $)

 - alias-controlled "new command" separator ($;), like in:
 
 	alias killme say my pleasure! $; ban $nick

	
 Variables/info that might be interesting to offer:
  
  $channel - Channel name of the bot
  $nick    - Nickname of the user
  $bot     - Nickname of the bot
  $time    - Bot time

  $year
  $date
  

 We should here consider adding $-variables like:
 * outputed text of a command (the slightly unix inspired) $'command'
 * more "low level" variables
 
 
 In an even more advanced level, I suggest full FPL support to enable
 (at least) the bot maintainer to fix things like
 
	alias -fpl mykick mykick(\" $1 \");

 which builds an FPL program line that is run, the mykick() in the above
 example line has of course already been defined in a file like:
 
 	export void mykick(char *nick)
        {
          if(Joined(nick))
            Printf("%s: BOO!!", nick);
          else
            Printf("%s: you missed him! ;(", _nick); // built-in variable
        }

#
# Advanced setup file for new commands/context control for Dancer.
#
# Syntax of this file is: 'FLAGS STRING(S) [ACTION]'
#
# FLAGS:
# C   - straight command alias (used as normal commands)
# P   - publically available   (for commands)
# D   - DCC chat required      (for commands)
# *   - password required      (for commands)
# !0-9 - (in a sequence like !50 or !25) level required to trigger
# +0-9 - highest command level allowed to trigger (below level to trigger)
# S   - string match (anyware on the line)
# E   - regex match (anyware on the line)
# F   - string match (first on the line)
# =   - the rest of the line is treated as a help-text for the command/
#       alias written on the previous line
# &   - the rest of the line is treated as a syntax-description for the
#       command/alias
#
# STRING(S)
# one or more strings according to the flags/actions wanted.
# white spaces can only be used if the string is placed within quotes as
# in "white space". Several strings are written like one,two,three.
#
# ACTION
# A complete Dancer command line. With $-style replacements as documented
# elsewhere.
#
C!20 topic do topic $channel :$1-
= Change topic on the currrent channel.
& <topic>
C!50 kick  do kick $channel: $1 $2?-
= Kick the specified user from the channel. Optionally with a given kick message.
& <user> [message]
F!0  brb   say Hurry back $user!
F!0  bbl   say I'll be waiting for you, $user!

  
*************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#if defined(AMIGA) && !defined(__GNUC__)
#include <sys/types.h>
#endif

struct Alias {
  struct Alias *next; /* in a "linked case" */
  long amount;        /* number of links in a "linked case" */
  long reqargs; /* required amount of argument required for the alias to run */
  long args;    /* args in the data list */
  long *flags;
  void **data;
  long entries; /* number of array entries malloced */
};

#include "parse.h"
#include "transfer.h"

#ifndef TEST
#include "dancer.h"
#include "list.h"
#include "function.h"
#include "user.h" /* needed for command.h */
#include "command.h"

typedef struct FuncStruct {
  struct Header h;
  char *name;    /* name of the new func-alias */
  struct Alias *alias;
  long lowlevel; /* lowest required status */
  long hilevel;  /* highest required status */
  int percent;   /* likeliness 0 - 100 % */
  long flags;    /* mode stuff */
  char *help;    /* possible help text */
  char *syntax;  /* possible syntax description */
} itemfunc;

extern char *errfrom;
extern char funcfile[];

itemfunc *funcHead;

#endif

#define MAX_ARGS 16 /* allocation steps */

#define ARG_TYPEMASK 0x0f

#define ARG_RESTOFLINE 0x10 /* from this parameter to the rest of line */
#define ARG_IFPOSSIBLE 0x20 /* if this parameter was specified */

typedef enum {
   ARG_NONE,
   ARG_PAR,	 /* parameter from the line when alias command is invoked */
   ARG_VAR,	 /* program variable */
   ARG_WORD,	 /* straight word */
   ARG_PICKLIST, /* a list with a selection of different picks */
   ARG_ENDOFCMD, /* push away the left as one separate command, another one
                    follows! ;) */
   
   /* there following to are no real args, but just here to make sure they
      don't have the same number as the actual args have */
   ADD_ARGC,
   ADD_MAXARG
} aliasArguments;

static char *argv[MAX_ARGS];

int splittoargs(char *args)
{
  int argc = 1;
  do {
    while(isspace(*args))
      ++args;
    if(!*args)
      break;
    if('\"' != *args) {
      argv[argc] = args;
      while(isgraph(*args))
        ++args;
    }
    else {
      argv[argc] = ++args;
      while(*args && ('\"' != *args)) {
        ++args;
      }
      if(!*args)
	return -1;
    }
    ++argc;
    if(*args) {
      *args=0; /* zero terminate */
      ++args;
    }
  } while(*args && argc<MAX_ARGS);
  return argc;
}

char *putalias(int argc, struct Alias *alias, char *pnt, int size)
{
  int a;
  char *original=pnt;
  if(argc < alias->reqargs) {
    return "illegal use of alias";
  }
  for(a=0; a<alias->args; a++) {
    if(pnt-original>size)
      return "too big alias";

    switch(alias->flags[a]&ARG_TYPEMASK) {
    case ARG_PAR:
      if(alias->flags[a]&ARG_IFPOSSIBLE) {
        if(argc <= (int)alias->data[a])
          /* it wasn't possible */
          break;
      }
      sprintf(pnt, "%s", argv[(int)alias->data[a]]);
      pnt += strlen(pnt);
      if(alias->flags[a]&ARG_RESTOFLINE) {
        int n=(int)alias->data[a]+1;
        while(n<argc) {
          sprintf(pnt, " %s", argv[n]);
          pnt += strlen(pnt);
          ++n;
        }
      }
      break;
    case ARG_WORD:
      sprintf(pnt, "%s", alias->data[a]);
      pnt += strlen(pnt);
      break;
    case ARG_ENDOFCMD:
      sprintf(pnt, "\n");
      pnt += strlen(pnt);
      break;
    case ARG_PICKLIST:
      {
        struct Alias *al = alias->data[a];
        char *e;
        int rnd;
        if(al->amount) {
          rnd = (int)(Rnd()*(al->amount+1));
          while(rnd-- && al) {
            al = al->next;
          }
        }
        /* sprintf(pnt, "%d %d(", alias->amount, al->amount);
        pnt += strlen(pnt); */
        if(e = putalias(argc, al, pnt, size-(pnt-original))) {
          return e;
        }
        pnt += strlen(pnt);
      }
      break;
    case ARG_VAR:
      {
        char *str = VarInfo((lineVariables)alias->data[a]);
        if(str) {
          sprintf(pnt, str);
          pnt += strlen(pnt);
        }
        else
          return "unknown variable";
        break;
      }
    }
  }
  return NULL;
}

char *AddArg(struct Alias *newone,
	     void *data,
             aliasArguments args,
	     int argc)
{
   switch(args) {
     case ADD_ARGC:
       newone->args=(long)data;
       return NULL;
     case ADD_MAXARG:
       newone->reqargs=(long)data;
       return NULL;
     case ARG_WORD:
       data = strdup(data);
       if(!data)
	  return "out of memory";
       break;
   }
   if(!newone->entries) {
     newone->data = (void **)malloc(MAX_ARGS * sizeof(void *));
     newone->flags = (long *)malloc(MAX_ARGS * sizeof(long));
     newone->entries = MAX_ARGS;
   }
   else if(argc>=newone->entries) {
     newone->entries += MAX_ARGS;
     newone->data = (void **)realloc(newone->data, newone->entries * sizeof(void *));
     newone->flags = (long *)realloc(newone->flags, newone->entries * sizeof(long));
   }
   if(!newone->flags || !newone->data)
     return "out of memory";
   newone->data[argc-1] = data;
   newone->flags[argc-1] = args;
   return NULL; /* OK */
}

char *getalias(struct Alias **alias, char **string)
{
   char old[32];
   char *pnt;
   char *nextpnt;
   int argc=0;
   int argnum;
   int argmax=-1; /* number of requied arguments */
   char buffer[256];
   char *bufpnt;
   struct Alias *newone;
   char *e;
   
   newone = malloc(sizeof(struct Alias));
   if(!newone)
      return "out of memory";
   memset(newone, 0, sizeof(struct Alias));
   pnt = *string;
   while(nextpnt=strchr(pnt, '$')) {
     bufpnt = buffer;
     if(pnt != nextpnt) {
       argc++;
       while(pnt<nextpnt) {
	 *bufpnt++ = *pnt;
         pnt++;
       }
       if(nextpnt[1]=='$') {
	 *bufpnt++ = '$';
         pnt = nextpnt+2;
	 *bufpnt = 0;
	 if(e = AddArg(newone, buffer, ARG_WORD, argc))
	   return e;
         continue;
       }
       *bufpnt = 0;
       if(e = AddArg(newone, buffer, ARG_WORD, argc))
	 return e;
     }
     argc++;
     ++nextpnt;
     if(isdigit(*nextpnt)) {
       aliasArguments arg=0;
       argnum = strtol(nextpnt, &pnt, 0);
       if('?' == *pnt) {
         ++pnt;
         arg |= ARG_IFPOSSIBLE;
       }
       else {
         if(argnum>argmax)
           argmax=argnum;
       }
       if('-' == *pnt) {
	 arg |= ARG_RESTOFLINE;
	 ++pnt;
       }
       if(e = AddArg(newone, (void *)argnum, arg|ARG_PAR, argc))
	 return e;
     }
     else if(*nextpnt == '(') {
       /* Random-pick list coming up, gee, big fun */
       struct Alias *alter;
       struct Alias *prev;
       struct Alias *first;
       
       char n;
       ++nextpnt;
       if(e = getalias(&alter, &nextpnt)) /* get this pick in 'alter' */
         return e;
       first = prev = alter;
       n = *nextpnt++;
       while (n != ')') {
	 if(n != '|')
           return "illegal random-pick sequence";
         if(e = getalias(&alter, &nextpnt)) /* get this pick in 'alter' */
           return e;
         prev->next=alter;
	 prev=alter;
	 first->amount++;
	 n = *nextpnt++;
       }
       if(e = AddArg(newone, first, ARG_PICKLIST, argc))
	 return e;
       pnt = nextpnt;
     }
     else if(*nextpnt == '|' ||
             *nextpnt == ')' ) {
       if(e = AddArg(newone, (void *)argc, ADD_ARGC, argc))
         return e;
       if(e = AddArg(newone, (void *)argmax, ADD_MAXARG, argc))
         return e;
       *alias = newone;
       *string = nextpnt;
       return NULL;	
     }
     else if(*nextpnt == '$') {
       if(e = AddArg(newone, "$", ARG_WORD, argc))
         return e;
       pnt = ++nextpnt;
     }
     else if(*nextpnt == ';') {
       if(e = AddArg(newone, NULL, ARG_ENDOFCMD, argc))
         return e;
       pnt = ++nextpnt;
       while(*pnt && isspace(*pnt))
	 pnt++;
     }
     else {
       lineVariables var;
       /* variable name coming up! */
       if(!sscanf(nextpnt, "%31[a-zA-Z0-9]", old))
	 return "unknown variable";
       if(!strcasecmp("channel", old)) {
	  var = VAR_CHANNEL;
       }
       else if(!strcasecmp("nick", old)) {
	  var = VAR_NICKNAME;
       }
       else if(!strcasecmp("bot", old)) {
	  var = VAR_BOTNAME;
       }
       else
	 return "unknown variable";
       if(e = AddArg(newone, (void *)var, ARG_VAR, argc))
	 return e;
       pnt = nextpnt + strlen(old);
     }
   }
   nextpnt = strchr(pnt, '\0');
   if(pnt != nextpnt) {
     argc++;
     bufpnt = buffer;
     while(pnt<nextpnt) {
       *bufpnt++ = *pnt;
       pnt++;
     }
     *bufpnt = 0;
     if(e = AddArg(newone, buffer, ARG_WORD, argc))
       return e;
   }
   if(e = AddArg(newone, (void *)argc, ADD_ARGC, 0))
     return e;
   if(e = AddArg(newone, (void *)argmax, ADD_MAXARG, 0))
     return e;
   *alias = newone;
   return NULL;
}

#ifdef TEST
int main()
{
  struct Alias *alias1;
  char buffer[1024];
  int a;
  char *e;
  char *pnt=buffer;

  while (1) {
    printf("Enter alias:\n");
    gets(buffer);
    if(e = getalias(&alias1, &pnt)) {
       puts(e);
       continue;
    }

    printf("Enter command line:\n");
    gets(buffer);
    a = splittoargs(buffer);
    if(a<0) {
       puts("failed splitting");
       continue;
    }
    printf("%d parts alias:\n", alias1->args);
    if(e = putalias(a, alias1, buffer, 1024))
       puts(e);
    puts(buffer);
    printf("\n");
  }  
}
#else

char *FuncRun(char *from,  /* from who it came */
              char *cmd,   /* actual command name */
              char *line,  /* parameters */
              long status, /* status of the user using this */
              long mode,   /* flags about this */
              char oktorun) /* no level checks */
{
  int result=-1;
  itemfunc *f;
  char *e;
  static char buffer[1024];

  for (f=Succ(funcHead); f; f=Succ(f)) {
    if(!strcasecmp(cmd, f->name) &&
       (oktorun || (status>=f->lowlevel)) ) {
      /*
       * We should also check for a number of other requirements to be
       * fulfilled before doing this:
       */
      if(result < 0) {
        result = splittoargs(line);
        if(result<0) {
          Send(errfrom, GetText(msg_internal_error));
          return FALSE;
        }
        argv[0] = cmd; /* first entry! */
      }

      if(e = putalias(result, f->alias, buffer, 1024)) {
        Send(errfrom, e);
        return NULL;
      }
#if 0
      puts(buffer); /* this ought to be run as a standard command line */
#endif
      return buffer;
    }
  }
  return NULL;
}

char *FuncMatch(char *from,  /* from who it came */
                char *line,  /* text line */
                long status, /* status of the user using this */
                long mode    /* flags about this */
                )
{
  int result=-1;
  itemfunc *f;
  char *e;
  static char buffer[1024];

  for (f=Succ(funcHead); f; f=Succ(f)) {
    if(f->flags&FUNC_MATCH) {
      if( (status < f->lowlevel) ||
         (status > f->hilevel) )
        /* not within our level */
        continue;
      if(f->flags&FUNC_REGEX) {
        if(!PatternExist(line, f->name))
          continue;
      }
      else {
        /* FUNC_STRINGFIRST */
        if(strncasecmp(line, f->name, strlen(f->name)))
          continue;
      }
      if(f->percent<100) {
        /* not to be done always */
        int rnd = (int)(Rnd()*100);
#if 0
        printf("got %d, only below %d allowed\n",
               rnd, f->percent);
#endif   
        if(rnd > f->percent)
          continue;
      }
      /*
       * We should also check for a number of other requirements to be
       * fulfilled before doing this:
       */
      if(result < 0) {
        result = splittoargs(line);
        if(result<0) {
          Send(errfrom, GetText(msg_internal_error));
          return FALSE;
        }
        argv[0] = f->name; /* first entry! */
      }

      if(e = putalias(result, f->alias, buffer, 1024)) {
        Send(errfrom, e);
        return NULL;
      }
#if 0
      puts(buffer); /* this ought to be run as a standard command line */
#endif
      return buffer;
    }
  }
  return NULL;
}


void FuncLoad()
{
  FILE *file;
  char buffer[2048];
  char name[256];
  char flags[128];
  int endpos;
  int startpos;

  itemfunc *prevfunc;
  
  file = fopen(funcfile, "r");
  if(file) {
    while(fgets(buffer, 2047, file)) {
      if(buffer[0] == '#')
        continue;
      endpos = 0;
/*#ifdef HAVE_N_IN_SCANF*/
      if(1 <= sscanf(buffer, "%127s%*[ :;,!>]%n%*[^\n]%n",
                     flags, &startpos, &endpos)) {
/*#endif*/
        char *fpt=flags;
        long flags=0;
        long lo = 0;
        long hi = 255;
        int percent = 100;
        int newpos=0;
        char *help=NULL;
        char *syntax=NULL;
        char ch;

        if(endpos)
          buffer[endpos]=0;
        /* fixed June 17th 1998 by Bagder */
        while(ch = *fpt++) {
          switch(toupper(ch)) {
          case 'C':
            flags |= FUNC_REGULAR;
            break;
          case 'P':
            flags |= FUNC_PUBLIC;
            break;
          case 'D':
            flags |= FUNC_DCC;
            break;
          case '*':
            flags |= FUNC_PWD;
            break;
          case '!':
            flags |= FUNC_LOWLEVEL;
            lo = strtol(fpt, &fpt, 0);
            fpt--;
            break;
          case '+':
            flags |= FUNC_HILEVEL;
            hi = strtol(fpt, &fpt, 0);
            fpt--;
            break;
          case '%':
            percent = strtol(fpt, &fpt, 0);
            fpt--;
            break;
          case 'E':
            flags |= FUNC_REGEX;
            break;
          case 'F':
            flags |= FUNC_STRINGFIRST;
            break;
          case '=':
            /* this line is a help text */
            flags = FUNC_HASHELP;
            prevfunc->help = strdup(&buffer[startpos]);
            break;
          case '&':
            /* this line is a syntax description */
            flags = FUNC_HASSYNTAX;
            prevfunc->syntax = strdup(&buffer[startpos]);
            break;
          }
        }
        if(flags & (FUNC_HASSYNTAX|FUNC_HASHELP))
          continue;
        if('\"' == buffer[startpos])
#ifdef HAVE_N_IN_SCANF
          sscanf(&buffer[startpos+1], "%[^\"]\" %n", name, &newpos);
        else
          sscanf(&buffer[startpos], "%[^ :;,!>] %n", name, &newpos);
        startpos += newpos;
#else
          sscanf(&buffer[startpos+1], "%[^\"]\"", name);
        else
          sscanf(&buffer[startpos], "%[^ :;,!>]", name);
        startpos += strlen(name);
#endif
        {
          char *line = &buffer[startpos];
          itemfunc *f;
          char *e;
          struct Alias *a;
          if(e = getalias(&a, &line)) {
            Logf(LOGINIT, "Func alias error '%s'\nLINE: %s", e, line);
            break;
          }
          if( f=(itemfunc *)NewEntry(sizeof(itemfunc)) ) {
            AddTail(funcHead, f);
            f->alias = a;
            f->name = strdup(name);
            f->flags = flags;
            f->lowlevel = lo;
            f->hilevel = hi;
            f->percent = percent;
            f->help = help;
            f->syntax = syntax;

            prevfunc = f;
          }
          else
            break;
        }
      }
    }
    fclose(file);
  }
}

void FuncInit()
{
  funcHead = CreateList(sizeof(itemfunc));
  FuncLoad();
}

void FreeAlias(struct Alias *al)
{
  int i;
  while(al) {
    for(i=0; i<al->args; i++) {
      if(al->flags[i]==ARG_WORD)
        free(al->data[i]);
    }
    free(al->flags);
    free(al->data);
    al = al->next;
  }
}

void FreeFunc(void *v)
{
  itemfunc *f = (itemfunc *)v;
  FreeAlias(f->alias);
  free(f->name);
  if(f->help)
    free(f->help);
  if(f->syntax)
    free(f->syntax);

  /* clean the whole alias */

  free(f->alias);
}

void FuncCleanup(void)
{
  DestroyList((void **)&funcHead, FreeFunc);
}

#endif
