/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 *  ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing authors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjorn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/seen.h,v $
 * $Revision: 1.5 $
 * $Date: 1996/12/06 15:56:31 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: seen.h,v $
 * Revision 1.5  1996/12/06 15:56:31  dast
 * added nick-timestamp
 *
 * Revision 1.4  1996/12/03 17:12:51  dast
 * changed a proto
 *
 * Revision 1.3  1996/08/30 11:29:13  dast
 * removed the old header and obsolete include
 *
 * Revision 1.2  1996/07/10 16:15:00  dast
 * Added the source header.
 *
 *
 *****************************************************************************/

#ifndef __SEEN_H
#define __SEEN_H

#include "dancer.h"
#include "user.h"

typedef struct Auxstruct {
  struct Auxstruct *link;   /* all nick belonging to the same nick */
  struct Auxstruct *next;   /* for hash table */
  struct Seenstruct *root;
  char *nick;
  long count;
  time_t departure; /* 4.0beta3 entry */
} itemaux;

typedef struct Seenstruct {
  struct Seenstruct *link;   /* single-list of all users */
  struct Seenstruct *next;   /* next chained collided hash entry */
  struct Auxstruct *first;   /* head of single list of all nick for this user */
  char *usite;               /* This is the key */
  char *host;                /* This is only used for wildcards */
  ulong signature;
  time_t departure;
  int type;
  char *by;
  char *msg;
} itemseen;


enum seentypes {
  SEENLEAVE = 1, SEENQUIT,     SEENKICK,
  SEENLEFT,      SEENQUITED,   SEENKICKED,
  SEENERROR,     SEENCHANGE
};


bool SeenInit(void);
void SeenCleanup(void);
void SeenSave(void);
void SeenNick(char *, char *, char);
void SeenHost(char *, char *);
void SeenInsert(itemguest *, int, char *, char *);
void SeenInsertAll(int, char *, char *);
itemaux *SeenMostNick(char *);
itemaux *SeenRecentNick(char *);

#endif
