#ifndef __SERVFUNC_H
#define __SERVFUNC_H
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 *  ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing authors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjorn.Stenberg@sth.frontec.se>
 *  - Andrew Gray <DarkDesigns@trader.com>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/servfunc.h,v $
 * $Revision: 1.4 $
 * $Date: 1996/12/12 19:00:10 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: servfunc.h,v $
 * Revision 1.4  1996/12/12 19:00:10  dast
 * new proto
 *
 * Revision 1.3  1996/12/03 17:13:24  dast
 * new protos, new defines
 *
 * Revision 1.2  1996/08/05 12:06:19  dast
 * major update
 *
 * Revision 1.1  1996/08/04 19:05:05  dast
 * Initial revision
 *
 *
 ****************************************************************************/

#include "list.h"

struct ServerSub {
  char *name;        /* complete name of the server */
  long port;         /* which port to use */
  char *passwd;      /* password */
  time_t connect;    /* last/current connect time */
  time_t disconnect; /* latest disconnect time */
  long average;      /* average time connected */
  long numconnects;  /* number of connects, possibly including this */
  char *message;     /* previous exit line from the server */
  char *adder;       /* who added this server */
  long flags;        /* various, see defines below */
  time_t addtime;    /* when it was added */
  int id;            /* unique ID (don't save) */
};

#define SERV_DISABLED (1<<0) /* i.e for servers temporarily out of order
				NOTE: servers that are added in the .config
				file can't be deleted but always get
				disabled if deletion is attempted */
#define SERV_INCONFIG (1<<1) /* server is defined in the .config file    */
#define SERV_ENABLED  (1<<2) /* server should get enabled. This flag should
				not get stored, it should just be used as a
				flag to StatServ() */
typedef struct Server {
  struct Header h;
  struct ServerSub s;
} itemserv;

void ServCleanup(void);
int InitServ(void);
int ManAddServ(char *name, long port, char *passwd, char *who, long flags);
int ManDelServ(char *from, char *line);
void ListServ(char *from, char *line);
void StatServ(char *from, int options, char *server, long port);
int SaveServ(void);
void ConnectServ(itemserv *serv);
void DisconnectServ(char *fmt, ...);
itemserv *FindServ(char *, long);
itemserv *NextServ(void);

#endif
