#ifdef RCS
static char rcsid[]="$Id: setup.c,v 4.4 1998/05/16 20:48:56 dast Exp $";
#endif
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 *  ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing authors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjorn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/setup.c,v $
 * $Revision: 4.4 $
 * $Date: 1998/05/16 20:48:56 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: setup.c,v $
 * Revision 4.4  1998/05/16 20:48:56  dast
 * added staticnick and myhost
 *
 * Revision 4.3  1997/08/25 17:55:05  dast
 * dontsiteban and limit items
 *
 * Revision 4.2  1997/07/15 07:49:29  dast
 * Started working on MYINFO stuff. Far from completed. All is ifdef'ed still
 *
 * Revision 4.1  1997/05/28 06:24:30  dast
 * Colour code kick control
 * newsexpire
 *
 * Revision 3.4  1997/05/20 17:55:48  dast
 * extended the comment for 'language'
 *
 * Revision 3.3  1997/05/12 16:26:50  dast
 * made the lists get written properly in MakeConfig()
 * added warnmonths
 * added flood.fakename and FLOOD.FAKENAME
 *
 * Revision 3.2  1997/04/29 16:19:51  dast
 * reordered the .config items a bit
 * added banuserkicks
 * renamed the default language variable
 *
 * Revision 3.1  1997/04/28 16:46:10  dast
 * Included comments for each item
 * Made .set get saved with comments
 * Made the 'dancer config' print the config to stdout
 * Added 'nonhostisp', 'defaultpasswd', 'language' and more
 * Removed compatibility with a bunch of really old .config items.
 *
 * Revision 2.8  1997/02/10 19:41:11  dast
 * added STRICTOP
 *
 * Revision 2.7  1997/01/07 16:22:22  dast
 * added hostisp and FLOODJOINS
 *
 * Revision 2.6  1996/12/16 18:23:42  dast
 * removed the save-flag on a bunch of SETs
 *
 * Revision 2.5  1996/12/09 18:26:53  dast
 * new level stuff
 *
 * Revision 2.4  1996/12/06 17:21:38  dast
 * changed the SET output slightly
 *
 * Revision 2.3  1996/12/06 15:58:00  dast
 * sorted the items and groups
 * added AUTOUNBAN and BOTBANTIME
 * made the new group BAN
 * made BANTIME and BOTBANTIME require 200
 *
 * Revision 2.2  1996/12/03 17:54:36  dast
 * improved the switch() case after the SET line parse
 *
 * Revision 2.1  1996/12/03 17:13:55  dast
 * The entire new SET system
 *****************************************************************************/

#include <string.h>
#include <stdlib.h>

#include <stddef.h> /* does this work in all unixes? the offsetof() */

#include "config.h"
#include "list.h"
#include "dancer.h"
#include "function.h"
#include "setup.h"
#include "user.h"
#include "command.h"
#include "language.h"
#include "files.h"

extern int logdays;
extern ulong activelog;

int numretry;
int netburp;  /* Period after netsplit where FLOOD is off */
int defbantime; /* Default value if time is omitted in BAN */
int seenmonths; /* Max number of months to keep entries in seen file */
int tellmonths; /* Max number of months to keep entries in tell file */
int warnmonths; /* Max number of months to keep entries in tell file */
ulong linkvalue; /* "Public" key for linkbot */

bool seenbackup;    /* timestamped backups of seen file */
bool lockmode;      /* lock channel mode */
bool lockkey;       /* lock channel key  */
bool locklimit;     /* lock channel limit  */
bool avalance;      /* kick ctcp bombers */
bool floodmode;     /* prevent user floods */
bool welcome;       /* welcome new users */
bool netsplitmode;  /* deop and unban server ops/bans */
bool deopprotect;   /* bankick massive deoppers */
bool uppercheck;    /* check users for uppercase violations! */
bool nickflood;     /* kick on nick floods */
bool talkative;     /* start in talkative mode */
bool xdccmode;      /* kick xdcc senders */
bool saymode;       /* allow say/me commands */
bool warnmode;      /* check people with the warnlist */
bool repeatmode;    /* kick repeaters */
bool multimode;     /* kick multiple users */
bool ctcpmode;      /* CTCP flood checks */
bool reportban;     /* report SET and BANs in public */
bool invitable;     /* Respond to /invite or not */
bool autojoin;      /* Rejoin on kick */
bool autoop;        /* Auto-Op feature */
bool dispcomment;   /* Display Comments */
bool masterflood;
bool kickbans;      /* kick banned users if they still join */
bool beepcheck;     /* kick/warn beepers */
bool colourcheck;   /* kick/warn colourcode violators */
bool helpsyntax;    /* automatically show syntax info after help */
bool execprotect;   /* Enable/disable execution of shell scripts */
bool identprotect;  /* Enable/disable the IDENT command */
bool autounban;     /* automatically unban the weakest ban when 18 bans are
		       set in the channel */
bool strictopmode;  /* Deop unrecognized users if they get opped by someone
                       less than LEVEL_BOT.
                       [FASCISM ALERT] Use with care! */
bool banuserkicks;  /* Enable/disable non-bot users' kicks from causing the
		       bot to ban for multiple kicks. If DISABLED, the bot
		       will only ban if its own kicks are too frequent to
		       be acceptable. If ENABLED, all users' kicks are counted
		       and taken into consideration! */
bool fakenamemode;  /* Kick people joining with a faked host/domain name.  The
                       bot won't ban them since it may not be able to select a
                       ban pattern on user with '* in their patterns.  */
bool banprotect;    /* Enable/disable banprotection (main switch) */
bool mute;          /* Disable most other noise not controlled by say,
                       talkative, welcome and reportban settings */
bool opprotect;     /* Op chanop-users if they get deoped by someone
                       less than LEVEL_CHANOP. Will first deop the deoper.
                       [FASCISM ALERT] Use with care! */

char nameserver[256] = "";
char userfile[256] = "";
char passfile[256] = "";
char commentfile[256] = "";
char logfile[256] = "";
char setfile[256] = SETFILE;
char expfile[256] = "";
char expaddfile[256] = "";
char seenfile[256] = "";
char tellfile[256] = "";
char banfile[256] = "";
char warnfile[256] = "";
char bugfile[256] = BUGFILE;
char funcfile[256] = FUNCFILE;
char servfile[256] = "";
char fplconf[256] = "";
char newsfile[256] = "";
static char language[128];

/* Use strdup() instead of static (fixed) arrays ? */
char channel[200] = "";
char realname[256] = "";
char nickstring[128] = "";
char nickname[NICKLEN+1] = "";
char staticnick[NICKLEN+1] = "";
char cmodes[16] = "";
char chanmodes[16] = "";
char ckey[32] = "";
char chankey[32] = "";

long climit; /* the +l limit, 0 disables */

char ctcpversion[256] = "";
char ctcpuserinfo[256] = "";
char rulesmsg[512] = "";
char findfilename[256] = "";
char cmdvrfy[256] = "";
char cmdhost[256] = "";
char cmdfinger[256] = "";
char cmdspell[256] = "";
char askforops[256] = "";
char opaction[256] = "";
char exchangecmd[256] = "";
char defaultpasswd[256] = "";
#ifdef NICKSERV
char nickpasswd[256] = "";
#endif

char dancer_myhost[256] = "";

int opactionlen;
int pubbantime;
int oplevel;

long newsexpire;

extern int floodrate, floodtime, floodrepeatrate, floodrepeattime;
extern int floodbeeps, floodjoins;

extern char *errfrom;  /* this is like stderr, only for nicks */
extern itemident *current;
extern long levels[];

itemlist *serverHead = NULL;

/* A list of ISP-patterns that should use the host-style bans */
itemlist *hostispHead = NULL;
/* A list of ISP-patterns that DOES not use the host-style bans
   (even if it matched a hostisp entry in the first run) */
itemlist *nonhostispHead = NULL;

/* A list of ISP-patterns that shouldn't get sitebanned by the bot */
itemlist *dontsitebanHead = NULL;

/* ---------------------------------------------------------------- */

struct Config cfg[] =
{
  {"server",      &serverHead, "bot.server.org",   CFG_LIST,   FALSE,
   "# A comma seperated list of servers, of the format\n"
   "#   server[:port[:password]]\n"},

  {"channel",     channel,     "#bot",             CFG_STRING, FALSE,
   "# Which channel to join at startup\n"},

  {"nick",        nickstring,  "bot",              CFG_STRING, FALSE,
   "# Nickmask. See dancer.html for further info.\n"},

#ifdef NICKSERV
  {"nickpass",    nickpasswd,  "password",         CFG_STRING, FALSE,
   "# Password for identifying with NickServ (ie. DALnet services).\n"},
#endif

  {"staticnick",  staticnick,  "danc",             CFG_STRING, FALSE,
   "# A static 4-letter-nick that the bot will always recognize as itself\n"
   "# regardless of its current nickname.\n"},

  {"name",        realname,    "An IRC bot",       CFG_STRING, FALSE,
   "# Realname. Shows up on i.e /whois output\n"},

  {"cmode",       cmodes,      "",         CFG_STRING, TRUE,
   "# Cmode determines which channel modes the bot should try\n"
   "# to keep if lockmode is on.\n"},

  {"ckey",        ckey,        "",         CFG_STRING, TRUE,
   "# Ckey is the channel key\n"},

  {"climit",      &climit,      (void*)0,         CFG_INTEGER, TRUE,
   "# Climit is the channel +l limit, 0 disables\n"},

  {"ctcpversion", ctcpversion, CTCPVERSION, CFG_STRING, FALSE,
   "# Ctcpversion enables you to choose a different reply to ctcp\n"
   "# version requests. Per default it will reply with the name and\n"
   "# version of the bot.\n"},

  {"ctcpuserinfo", ctcpuserinfo, "No info", CFG_STRING, FALSE,
   "# Ctcpuserinfo determines the reply of the ctcp userinfo request.\n"},

  {"rulesmsg",    rulesmsg,    "No rules", CFG_STRING, FALSE,
   "# Rulesmsg is the text that the RULES command prints.\n"},

  {"userfile",    userfile,    USERFILE,           CFG_STRING, FALSE,
   "# This file contains all registered users\n"},

  {"logfile",     logfile,     LOGFILE,            CFG_STRING, FALSE,
   "# This is the prefix to use for the log files\n"},

  {"setfile",     setfile,     SETFILE,            CFG_STRING, FALSE,
   "# Setfile contains all saved settings. It overrides the config stored\n"
   "# in the .config file\n"},

  {"explainfile", expfile,     EXPFILE,            CFG_STRING, FALSE,
   "# Explainfile contains all standard explainations. Explainations that\n"
   "# are added force this file to get re-written.\n"},

  {"seenfile",    seenfile,    SEENFILE,           CFG_STRING, FALSE,
   "# Seenfile contains all the info on who has visited the channel\n"},

  {"servfile",       servfile,      SERVFILE,   CFG_STRING, FALSE,
   "# Servfile is the name of the file used for the server list.\n"},

  {"fplfile",        fplconf,       FPLFILE,    CFG_STRING, FALSE,
   "# fplfile is the name of the fpl-config file\n"},

  {"funcfile",  funcfile,      FUNCFILE, CFG_STRING, FALSE,
   "# Funcfile is the name of the file which is read for the 'funcs'/\n"
   "# aliases Dancer supports.\n"},

  {"banfile",     banfile,     BANFILE, CFG_STRING, FALSE,
   "# File name to store ban information in.\n"},

  {"warnfile",    warnfile,    WARNFILE, CFG_STRING, FALSE,
   "# File name to store warning information in.\n"},

  {"bugfile",     bugfile,     BUGFILE,    CFG_STRING, FALSE,
   "# File name to store bug reports in.\n"},

  {"tellfile",    tellfile,    TELLFILE,   CFG_STRING, FALSE,
   "# Tellfile is the file where all TELL messages are stored\n"},

  {"newsfile",    newsfile,    NEWSFILE,   CFG_STRING, FALSE,
   "# File name to store news items in (for the NEWS* commands).\n"},

  {"findfilename", findfilename, "",       CFG_STRING, FALSE,
   "# Findfilename is the name of the index file which is used by\n"
   "# the FIND command\n"},

  {"cmdvrfy",     cmdvrfy,     "",         CFG_STRING, FALSE,
   "# Cmdvrfy is the name (preferably including the full path) of the\n"
   "# 'vrfy' command\n"},

  {"cmdhost",     cmdhost,     "",         CFG_STRING, FALSE,
   "# Cmdhost is the name (preferably including the full path) of the\n"
   "# 'host' command\n"},

  {"cmdfinger",   cmdfinger,   "/usr/ucb/finger", CFG_STRING, FALSE,
   "# Cmdfinger is the name (preferably including the full path) of the\n"
   "# 'finger' command\n"},

  {"seenbackup",  &seenbackup, BTRUE,      CFG_SWITCH, FALSE,
   "# If seenbackup is turned on (see below) a timestamped backup of the\n"
   "# seenfile will be made each time the bot is started. This is done to\n"
   "# prevent loosing all connected data due to an error. Delete the older\n"
   "# backups manually from time to time.\n"},

  {"numretry",    &numretry,   (void *)8,  CFG_INTEGER, FALSE,
   "# Number of retries to connect to the same server before giving up\n"},

  {"nameserver",  nameserver,  "",         CFG_STRING, FALSE,
   "# Nameserver is the name of your local nameserver. This is\n"
   "# needed for the HOST command. If none is supplied, it will\n"
   "# try to get the yp master, and if that fails it will try\n"
   "# to do without.\n"},

  {"opaction",    opaction,    "",         CFG_STRING, FALSE,
   "# Opaction is a kind of passive auto-op. It ops a user/bot if\n"
   "# the level is exactly LEVELBOT and it makes an action starting\n"
   "# with the content of opaction. If no opaction is supplied this\n"
   "# passive auto-op is disabled.\n"},

  {"netburp",     &netburp,    (void *)NETBURPTIME, CFG_INTEGER, FALSE,
   "# Netburp is the period (in seconds) after a netjoin where FLOOD\n"
   "# is off, to prevent kicking people because of an sudden exchange\n"
   "# of data between the servers (which usually is called a netburp.)\n"},

  {"seenmonths",  &seenmonths, (void *)6,  CFG_INTEGER, FALSE,
   "# Maximum number of months to keep old entries in the seenfile.\n"},

  {"tellmonths",  &tellmonths, (void *)2,  CFG_INTEGER, FALSE,
   "# Maximum number of months to keep old entries in tellfile.\n"},

  {"warnmonths",  &warnmonths, (void *)3,  CFG_INTEGER, FALSE,
   "# Maximum number of months to keep old entries in warnlist.\n"},

  {"askforops",   askforops,   "",         CFG_STRING, FALSE,
   "# Askforops is an action that the bot does when entering the\n"
   "# channel, to make people aware that it would like to get opped.\n"},

  {"storedays",   &logdays,    (void *)7,  CFG_INTEGER, FALSE,
   "# The number of logfiles to keep, and therefore which\n"
   "# logfiles to remove automatically!\n"},

  /* this *is* saved but differently (thus the FALSE): */
  {"chgcmdlev", ChgCommandLevel,   NULL, CFG_FUNCTION, FALSE,
   "# Change the level requirement for single command by entering\n"
   "# them here. Use the format <command> <level>. One entry per\n"
   "# line and chgcmdlev:-label.\n"},

  {"activelog", &activelog,     (void *)-1,  CFG_INTEGER, TRUE,
   "# Numerical representation of what information that should be\n"
   "# included in the logfile.\n"},

  {"flood.bomb",    &avalance,   BTRUE,      CFG_SWITCH, TRUE,
   "# Kick CTCP bombers\n"},

  {"flood.nick",    &nickflood,  BTRUE,      CFG_SWITCH, TRUE,
   "# Kick nick flooders\n"},

  {"flood.flood",   &floodmode,  BTRUE,      CFG_SWITCH, TRUE,
   "# Prevent public floods\n"},

  {"flood.upper",   &uppercheck, BTRUE,      CFG_SWITCH, TRUE,
   "# Check for uppercase violations\n"},

  {"flood.xdcc",    &xdccmode,   BTRUE,      CFG_SWITCH, TRUE,
   "# Kick xdcc announcers\n"},

  {"flood.repeat",  &repeatmode, BTRUE,      CFG_SWITCH, TRUE,
   "# Prevent repeaters\n"},

  {"flood.multi",   &multimode,  BTRUE,      CFG_SWITCH, TRUE,
   "# Prevent user to join from the same account multiple times\n"},

  {"flood.ctcp",    &ctcpmode,   BTRUE,      CFG_SWITCH, TRUE,
   "# Prevent CTCP floods\n"},

  {"flood.beep",    &beepcheck,  BTRUE,      CFG_SWITCH, TRUE,
   "# Kick beepers.\n"},

  {"flood.colour",    &colourcheck,  BTRUE,      CFG_SWITCH, TRUE,
   "# Kick colourcode (ab)users.\n"},

  {"flood.fakename",  &fakenamemode, BTRUE,  CFG_SWITCH, TRUE,
   "# Kick guests joining with faked host/domain names.\n"},

  {"thres.floodrate", &floodrate,  (void *)3, CFG_INTEGER, TRUE,
   "# Prevent more than FLOODRATE messages in FLOODTIME seconds\n"},

  {"thres.floodtime", &floodtime,  (void *)1, CFG_INTEGER, TRUE,
   "# see FLOODRATE\n"},

  {"thres.repeatrate", &floodrepeatrate, (void *)3, CFG_INTEGER, TRUE,
   "# Prevent more than FLOODRATE messages in FLOODTIME seconds\n"},

  {"thres.repeattime", &floodrepeattime, (void *)20, CFG_INTEGER, TRUE,
   "# see FLOODREPEATRATE\n"},

  {"thres.floodbeeps", &floodbeeps, (void *)2, CFG_INTEGER, TRUE,
   "# Maximum number of public beeps allowed\n"},

  {"thres.floodjoins", &floodjoins, (void *)3, CFG_INTEGER, TRUE,
   "# Number of joins accepted from the same hostpattern\n"},

  {"verbose.talk",    &talkative,  BTRUE,      CFG_SWITCH, TRUE,
   "# Talkative mode\n"},

  {"verbose.welcome", &welcome,    BTRUE,      CFG_SWITCH, TRUE,
   "# Welcome new users\n"},

  {"verbose.say",     &saymode,    BTRUE,      CFG_SWITCH, TRUE,
   "# Enable/disable the SAY and ME commands\n"},

  {"verbose.warn",    &warnmode,   BTRUE,      CFG_SWITCH, TRUE,
   "# Report about people on the warnlist\n"},

  {"verbose.comment",   &dispcomment, BFALSE,  CFG_SWITCH, TRUE,
   "# Enable user-comments on join\n"},

  {"verbose.mute",   &mute,         BFALSE,     CFG_SWITCH, TRUE,
   "# Enable/disable mute mode\n"},

  {"misc.mode",      &lockmode,     BTRUE,      CFG_SWITCH, TRUE,
   "# Lock the channel mode\n"},

  {"misc.key",       &lockkey,      BTRUE,      CFG_SWITCH, TRUE,
   "# Lock the channel key\n"},

  {"misc.limit",     &locklimit,    BTRUE,      CFG_SWITCH, TRUE,
   "# Lock the channel limit\n"},

  {"misc.netsplit",  &netsplitmode, BTRUE,      CFG_SWITCH, TRUE,
   "# Deop and unban server ops/bans\n"},

  {"misc.deop",      &deopprotect,  BTRUE,      CFG_SWITCH, TRUE,
   "# Check for massive deoppers\n"},

  {"misc.invitable", &invitable,    BTRUE,      CFG_SWITCH, TRUE,
   "# Join a channel if being /invite'd (by a high-level user)\n"},

  {"misc.autojoin",  &autojoin,     BTRUE,      CFG_SWITCH, TRUE,
   "# Join channel automatically if being kicked\n"},

  {"misc.autoop",    &autoop,       BFALSE,     CFG_SWITCH, TRUE,
   "# Enable auto-ops\n"},

  {"misc.strictop",    &strictopmode,    BFALSE,     CFG_SWITCH, TRUE,
   "# With this enabled, non-recognized users will not be allowed to get\n"
   "# chanop status by people without very high status. LEVELOP can\n"
   "# be used to define the level of the allowed ops\n"},

/* --- 4.3.6 --- */
  {"misc.helpsyntax",     &helpsyntax,   BTRUE,      CFG_SWITCH, TRUE,
   "# Make the syntax information get displayed when HELP is used\n"},

/* - post 4.0beta2 */
  {"misc.autounban", &autounban,    BFALSE,     CFG_SWITCH, FALSE, NULL},

  {"linkvalue",      &linkvalue,    (void *)0,  CFG_INTEGER, FALSE, NULL},

  {"spellcmd",       cmdspell,  "./script/speller.sh", CFG_STRING, FALSE,
   "# Full path to the spell command/script\n"},

  {"level.anybody",    &levels[0],  (void *)  0, CFG_INTEGER, TRUE,
   "# Which numerical value to use for ANYBODY\n"},

  {"level.recognized", &levels[1],  (void *) 10, CFG_INTEGER, TRUE,
   "# Which numerical value to use for RECOGNIZED\n"},

  {"level.chanop",     &levels[2],  (void *) 20, CFG_INTEGER, TRUE,
   "# Which numerical value to use for CHANOP\n"},

  {"level.trusted",    &levels[3],  (void *) 50, CFG_INTEGER, TRUE,
   "# Which numerical value to use for TRUSTED\n"},

  {"level.expert",     &levels[4],  (void *)100, CFG_INTEGER, TRUE,
  "# Which numerical value to use for EXPERT\n"},

  {"level.maintainer", &levels[5],  (void *)200, CFG_INTEGER, TRUE,
   "# Which numerical value to use for MAINTAINER\n"},

  {"level.owner",      &levels[6],  (void *)242, CFG_INTEGER, TRUE,
   "# Which numerical value to use for OWNER\n"},

  {"exchangecmd",      exchangecmd, "",          CFG_STRING,  FALSE,
   "# Specify the full path to the program that should be used for currency\n"
   "# translations plus arguments.\n"
   "# If you're using the supplied 'curr.sh' script for currency translation,\n"
   "# the setup below should be used. If you write your own or use a third\n"
   "# party script, set it up accordingly.\n"
   "# (exchangecmd = /my/program/for/currency /full/path/to/rates/file)\n"},

  {"hostisp",          &hostispHead, "*.demon.co.uk", CFG_LIST, FALSE,
   "# Specify a comma separated list of ISP patterns that should only use\n"
   "# host-patterns and never allow sitebans (see also 'nonhostisp')\n"},

  {"nonhostisp",     &nonhostispHead, "*dismayl.demon.co.uk", CFG_LIST, FALSE,
   "# A comma separated list of patterns that should *not* be treated as a\n"
   "# 'hostisp' even if it matched one of them\n"},

  /* --- 4.3.3 --- */
  {"ban.autounban",  &autounban,    BFALSE,     CFG_SWITCH, TRUE,
   "# Automatically unbans the least important ban when the channel\n"
   "# reaches 18 bans in the list\n"},

  {"ban.bantime",    &pubbantime,   (void *)0,  CFG_INTEGER, TRUE,
   "# Default ban time (in seconds) for public bans in the channel\n"},

  {"ban.botbantime", &defbantime,   (void *)0,  CFG_INTEGER, TRUE,
   "# Default time (in seconds) of a bot ban without time specified\n"},

  {"ban.kickban",    &kickbans,     BTRUE,      CFG_SWITCH, TRUE,
   "# Kick banned users if they join (split or lagged servers)\n"},

  {"ban.reportban",  &reportban,    BFALSE,     CFG_SWITCH, TRUE,
   "# Report about bans in public\n"},

/* --- 4.4.b1 --- */
  {"ban.banuserkicks",   &banuserkicks,   BTRUE,      CFG_SWITCH, TRUE,
   "# Count user kicks when deciding whether to ban because of too\n"
   "# many kicks within a certain time.\n"},

/* --- 4.3.5 --- */
  {"language",       language,      "English",  CFG_STRING,  TRUE,
   "# Set primary language for the bot to use.\n"
   "# ('dansk', 'deutsch', 'english', 'espaol', 'franais', 'nederlands',\n"
   "# 'norsk', 'svenska' and 'suomi' are supported when this is written)\n"},

/* --- 4.3.6 --- */
  {"owner.identprotect",   &identprotect, BTRUE,      CFG_SWITCH, TRUE,
   "# Prevent users from being able to use the IDENT command\n"},

  {"owner.execprotect",    &execprotect,  BTRUE,      CFG_SWITCH, TRUE,
   "# Prevents shell executions by the bot\n"},

  /* --- 4.4.b1 --- */
  {"defaultpasswd",      defaultpasswd, DEFPASSWDTXT, CFG_STRING, FALSE,
   "# Default password set to all new users.\n"},

  /* --- 4.6beta --- */
  {"newsexpire",  &newsexpire, (void *)90, CFG_INTEGER, FALSE,
   "# Default number of days of a news item to live\n"},

  /* --- 4.7beta3 --- */
  {"dontsiteban",  &dontsitebanHead, " ", CFG_LIST, FALSE,
   "# Specify a comma separated list of ISP patterns that should never\n"
   "# ever get sitebanned by the bot (see also 'hostisp' / 'nonhostisp')\n"},

  {"myhost",      dancer_myhost, "",   CFG_STRING,   FALSE,
   "# The IP number of the host that runs this bot. It should be a valid\n"
   "# IP from one of your machine's network interfaces or this is likely\n"
   "# to severly confuse this program. DON'T set this if you don't know\n"
   "# exactly what you are doing and why.\n"},

  /* --- 4.13.2 --- */
  {"ban.banprotect",   &banprotect,   BTRUE,  CFG_SWITCH, TRUE,
   "# Enable banprotection\n"},

  {"owner.oplevel",    &oplevel,      (void *)0, CFG_INTEGER, TRUE,
   "# Users with level lower than OPLEVEL are not allowed to get OPs in\n"
   "# the channel. Setting oplevel to 0 sets it off. See also strictop\n"},

  {"misc.opprotect",   &opprotect,    BFALSE, CFG_SWITCH, TRUE,
   "# Protect channel operators. With this enabled, non-chanop users will\n"
   "# not be allowed to deop chan-op users. The bot will deop the deoper\n"
   "# and op the chan-op users\n"},
};

/* ---------------------------------------------------------------- */

void MakeConfig(void)
{
  int i;
  itemlist *l;
  fprintf(stdout,
	  "#################################################################\n"
	  "# This is an autogenerated config file done by " VERSIONMSG "\n"
	  "#\n"
	  "# You _must_ set the three entries server, channel, and nick.\n"
	  "# (remove preceeding '#' letters to make the labels \"take effect\")\n"
	  );
  for (i=0; i<sizeof(cfg)/sizeof(cfg[0]); i++) {
    if(cfg[i].verbose) {
      fputs("\n", stdout);
      fputs(cfg[i].verbose, stdout);
      switch(cfg[i].flags) {
      case CFG_STRING:
	if(cfg[i].changed)
	  /* they differ, show the actual contents */
	  fprintf(stdout, "%s = %s\n", cfg[i].label, cfg[i].value);
	else
	  /* show the default value, but commented */
	  fprintf(stdout, "#%s = %s\n", cfg[i].label, cfg[i].def);
	break;
      case CFG_LIST:
	if(cfg[i].changed) {
	  int n=0;
	  fprintf(stdout, "%s = ", cfg[i].label);
	  for(l = (itemlist *)Succ(*(itemlist **)cfg[i].value);
	      l;
	      l = Succ(l)) {
	    fprintf(stdout, "%s%s", n?",":"",
		    l->ptr);
	    n++;
	  }
	  fprintf(stdout, "\n");
	}
	else {
	  /* show the default value, but commented */
	  fprintf(stdout, "#%s = %s\n", cfg[i].label, cfg[i].def);
	}
	break;
      case CFG_INTEGER:
	if(cfg[i].changed)
	  /* they differ, show the actual contents */
	  fprintf(stdout, "%s = %d\n", cfg[i].label, *(long *)(cfg[i].value));
	else
	  /* show the default value, but commented */
	  fprintf(stdout, "#%s = %d\n", cfg[i].label, cfg[i].def);
	break;
      case CFG_SWITCH:
	if(cfg[i].changed)
	  /* they differ, show the actual contents */
	  fprintf(stdout, "%s = %s\n",
		  cfg[i].label, *(long *)(cfg[i].value)?"On":"Off");
	else
	  fprintf(stdout, "#%s = %s\n", cfg[i].label, cfg[i].def?"On":"Off");
	break;
      default:
	break;
      }
    }
  }
}
/* ---------------------------------------------------------------- */

itemlist *BuildList(char *string)
{
  itemlist *head, *p;
  int index, i = 0;
  char buf[MIDBUFFER];

  if ( head=(itemlist *)CreateList(sizeof(itemlist)) ) {
#ifdef HAVE_N_IN_SCANF
    while (1 == sscanf(&string[i], "%[^,\n] %n", buf, &index)) {
      i += index;
      /* And now for some man page studying:

         Execution of a %n directive does not increment the
         assignment  count  returned  at  the completion of
         execution of the function.
         */
#else
    while (1 == sscanf(&string[i], "%[^,\n]", buf)) {
      i += strlen(buf);
#endif
      if (string[i] == ',') i++;
      if ( p=(itemlist *)NewEntry(sizeof(itemlist)) ) {
	AddTail(head, p);
        p->ptr = (void *)strdup(buf);
      } else
        break;
    }
  }
  return (head);
}

/* ---------------------------------------------------------------- */

static bool inited = FALSE;

void PreConfig()
{
  int i;

  for (i=0; i<sizeof(cfg)/sizeof(cfg[0]); i++) {
    cfg[i].changed = FALSE;
    switch(cfg[i].flags) {
    case CFG_STRING:
      strcpy(cfg[i].value, cfg[i].def);
      break;
    case CFG_SWITCH:
    case CFG_INTEGER:
      *(int *)cfg[i].value = (int)cfg[i].def;
      break;
    case CFG_FUNCTION:
      break;
    default:
      break;
    }
  }
  inited = TRUE;
}

void PostConfig()
{
  int i;

  for (i=0; i<sizeof(cfg)/sizeof(cfg[0]); i++) {
    if (cfg[i].flags == CFG_LIST) {
      if (!*(itemlist **)cfg[i].value || !(Succ(*(itemlist **)cfg[i].value)))
        *((itemlist **)cfg[i].value) = BuildList(cfg[i].def);
    }
  }
  defaultlang = LanguageNum(language);
}

void AddItem(char *line)
{
  char keyword[25];
  char towhat[BIGBUFFER];
  int i;

  if (2 <= sscanf(line, "%23[a-zA-Z0-9.] %*[=: ] %500[^\n]",
                  keyword, towhat)) {

    for(i=0; i<sizeof(cfg)/sizeof(cfg[0]); i++) {

      if(!strcasecmp(keyword, cfg[i].label)) {  /* match */

        switch(cfg[i].flags) {
        case CFG_STRING:
          strcpy(cfg[i].value, towhat);
          break;
        case CFG_SWITCH:
          if(atoi(towhat) ||
             !strcasecmp("ON", towhat) ||
             !strcasecmp("YES", towhat))
            *(int *)cfg[i].value = (int)TRUE;
          else
            *(int *)cfg[i].value = (int)FALSE;
          break;
        case CFG_INTEGER:
          *(int *)cfg[i].value = atoi(towhat);
          break;
        case CFG_LIST:
          *((itemlist **)cfg[i].value) = BuildList(towhat);
          break;
	case CFG_FUNCTION:
	  (*(void (*)(char *, char*))cfg[i].value)(cfg[i].def, towhat);
	  break;
        default:
          break;
        }
	cfg[i].changed = TRUE;
        return;
      }
    }
  }
}

int ConfigInit()
{
  FILE *f;
  char line[MAXLINE];

  PreConfig();

  if ( f = fopen(CONFIGFILE, "r") ) {
  
    while ( fgets(line, MAXLINE, f) )
      if ( (line[0] != '#') && (line[0] != '\n') )
        AddItem(line);

    fclose(f);

  } else return FALSE;

  if ( f = fopen(setfile, "r") ) {
  
    while ( fgets(line, MAXLINE, f) )
      if ( (line[0] != '#') && (line[0] != '\n') )
        AddItem(line);

    fclose(f);

  }

  PostConfig();
  /*DefaultConfig();*/

  if (*expfile)
    sprintf(expaddfile, "%s.add", expfile);
  strcpy(chanmodes, cmodes);
  strcpy(chankey, ckey);
  opactionlen = strlen(opaction);

  InitSets();

  return TRUE;
}

/* --- SaveSettings ----------------------------------------------- */

void SaveSettings()
{
  FILE *f;
  int i;
  char tempfile[256];
  extern struct Command cmds[];

  if(!*setfile)
    return;
  sprintf(tempfile, "%s~", setfile);

  if (f=fopen(setfile, "w")) {
    for (i=0; i<sizeof(cfg)/sizeof(cfg[0]); i++) {
      if (cfg[i].setting) {
	if(cfg[i].verbose) {
	  /* write comment */
	  fputs("\n", f);
	  fputs(cfg[i].verbose, f);
	}
	switch (cfg[i].flags) {
	case CFG_SWITCH:
	  fprintf(f, "%s = %s\n", cfg[i].label, OnOff(*(bool *)cfg[i].value));
	  break;
	case CFG_INTEGER:
	  fprintf(f, "%s = %d\n", cfg[i].label, *(int *)cfg[i].value);
	  break;
	case CFG_STRING:
	  fprintf(f, "%s = %s\n", cfg[i].label, cfg[i].value);
	  break;
	default:
	  break;
	}
      }
    }
    /* save new command levels */
    

    fprintf(f, "\n# Here follows a list of commands with their new levels:\n");

    for (i=0; cmds[i].name; i++) {
      if(cmds[i].flags&CMD_CHANGED) {
	/* save this new level */
	if(0>fprintf(f, "chgcmdlev: %s %d\n", cmds[i].name, cmds[i].level))
	  break;
      }
    }
    fclose(f);
  }
  
}

void ConfigCleanup()
{
  if(!inited)
    return;

  SaveSettings();

  /* Flush server list */
  if (serverHead)
    DestroyList((void **)&serverHead, FreeList);
}

/******************************************************************************
 * The following piece of source is the new SET functions.
 *****************************************************************************/

static struct SetItem thres[]={
    {"FLOODBEEPS", 0, SET_NUM, &floodbeeps, 0, msg_helpset_floodbeeps},
    {"FLOODJOINS", 0, SET_NUM, &floodjoins, 0, msg_helpset_floodjoins},
    {"FLOODRATE", 0, SET_NUM, &floodrate, 0, msg_helpset_floodrate},
    {"FLOODREPEATRATE", 0, SET_NUM, &floodrepeatrate, 0, msg_helpset_floodrepeatrate},
    {"FLOODREPEATTIME", 0, SET_NUM, &floodrepeattime, 0, msg_helpset_floodrepeattime},
    {"FLOODTIME", 0, SET_NUM, &floodtime, 0, msg_helpset_floodtime},
    {NULL, 0, 0, (long *)NULL, 0, 0} /* end series with a NULL-entry */
};

static struct SetItem flood[]={
    {"BEEP", 0, SET_ONOFF, &beepcheck, 0, msg_helpset_beep},
    {"BOMB", 0, SET_ONOFF, &avalance, 0, msg_helpset_bomb},
    {"COLOUR", 0, SET_ONOFF, &colourcheck, 0, msg_helpset_colour},
    {"CTCP", 0, SET_ONOFF, &ctcpmode, 0, msg_helpset_ctcp},
    {"FLOOD", 0, SET_ONOFF, &floodmode, 0, msg_helpset_flood},
    {"MULTI", 0, SET_ONOFF, &multimode, 0, msg_helpset_multi},
    {"NICK", 0, SET_ONOFF, &nickflood, 0, msg_helpset_nick},
    {"REPEAT", 0, SET_ONOFF, &repeatmode, 0, msg_helpset_repeat},
    {"UPPER", 0, SET_ONOFF, &uppercheck, 0, msg_helpset_upper},
    {"XDCC", 0, SET_ONOFF, &xdccmode, 0, msg_helpset_xdcc},
    {"FAKENAME", 0, SET_ONOFF, &fakenamemode, 0, msg_helpset_fakename},
    {NULL, 0, 0, NULL, 0, 0} /* end series with a NULL-entry */
};

static struct SetItem verbose[]={
    {"COMMENT", 0, SET_ONOFF, &dispcomment, 0, msg_helpset_comment},
    {"MUTE",    0, SET_ONOFF, &mute, 0, msg_helpset_mute},
    {"SAY",     0, SET_ONOFF, &saymode, 0, msg_helpset_say},
    {"TALK",    0, SET_ONOFF, &talkative, 0, msg_helpset_talk},
    {"WARN",    0, SET_ONOFF, &warnmode, 0, msg_helpset_warn},
    {"WELCOME", 0, SET_ONOFF, &welcome, 0, msg_helpset_welcome},
    {NULL, 0, 0, NULL, 0, 0} /* end series with a NULL-entry */
};

#define SPECIAL_CMODE    1
#define SPECIAL_CKEY     2
#define SPECIAL_LANGUAGE 3

static struct SetItem misc[]={
    {"AUTOJOIN",0, SET_ONOFF, &autojoin, 0, msg_helpset_autojoin},
    {"AUTOOP",  0, SET_ONOFF, &autoop, 0, msg_helpset_autoop},
    {"CKEY",    0, SET_SPEC, NULL, SPECIAL_CKEY,  msg_helpset_ckey},
    {"CMODE",   0, SET_SPEC, NULL, SPECIAL_CMODE, msg_helpset_cmode},
    {"CLIMIT",  0, SET_NUM,   &climit, 0, msg_helpset_climit},
    {"DEOP",    0, SET_ONOFF, &deopprotect, 0, msg_helpset_deop},
    {"HELPSYNTAX",0,SET_ONOFF,&helpsyntax, 0, msg_helpset_helpsyntax},
    {"INVITE",  0, SET_ONOFF, &invitable, 0, msg_helpset_invite},
    {"KEY",     0, SET_ONOFF, &lockkey, 0, msg_helpset_key},
    {"LIMIT",   0, SET_ONOFF, &locklimit, 0, msg_helpset_limit},
    {"MODE",    0, SET_ONOFF, &lockmode, 0, msg_helpset_mode},
    {"NETSPLIT",0, SET_ONOFF, &netsplitmode, 0, msg_helpset_netsplit},
    {"OPPROTECT", LEVEL_BOT, SET_ONOFF, &opprotect, 0, msg_helpset_opprotect},
    {"STRICTOP",LEVEL_BOT, SET_ONOFF, &strictopmode, 0, msg_helpset_strictop},
    {NULL, 0, 0, NULL, 0, 0} /* end series with a NULL-entry */
};

static struct SetItem ban[]={
    {"AUTOUNBAN",0, SET_ONOFF, &autounban, 0, msg_helpset_autounban},
    {"BANPROTECT", 0, SET_ONOFF, &banprotect, 0, msg_helpset_banprotect},
    {"BANUSERKICKS", 0, SET_ONOFF, &banuserkicks, 0, msg_helpset_banuserkicks},
    {"BANTIME", LEVEL_BOT, SET_TIME,  &pubbantime, 0, msg_helpset_bantime},
    {"BOTBANTIME", LEVEL_BOT, SET_TIME,  &defbantime, 0, msg_helpset_botbantime},
    {"KICKBAN", 0, SET_ONOFF, &kickbans, 0, msg_helpset_kickban},
    {"REPORTBAN", 0, SET_ONOFF, &reportban, 0, msg_helpset_reportban},
    {NULL, 0, 0, NULL, 0, 0} /* end series with a NULL-entry */
};

static struct SetItem owner[]={
    {"EXECPROTECT",0,SET_ONOFF, &execprotect, 0, msg_helpset_execprotect},
    {"IDENTPROTECT",0,SET_ONOFF, &identprotect, 0, msg_helpset_identprotect},
    {"LANGUAGE", 0, SET_SPEC, NULL, SPECIAL_LANGUAGE, msg_helpset_language},
    {"OPLEVEL", 0, SET_NUM, &oplevel, 0, msg_helpset_oplevel},
    {NULL, 0, 0, NULL, 0, 0} /* end series with a NULL-entry */
};

static struct SetGroup sets[]={
    {"BAN",        0, ban,   msg_setgroup_ban},
    {"FLOOD",      0, flood, msg_setgroup_flood},
    {"MISC",       0, misc,  msg_setgroup_misc},
    {"THRESHOLDS", 0, thres, msg_setgroup_thres},
    {"VERBOSE",    0, verbose, msg_setgroup_verbose},
    {"OWNER",      LEVEL_OWNER, owner, msg_setgroup_owner},
};

/*
 * ShowSetItem()
 *
 * Fills in a MINIBUFFER sized buffer, showin the contents of the
 * specified item.
 *
 * Returns TRUE if it wasn't written.
 */
static int
ShowSetItem(struct SetItem *item, char *set)
{
  char *setp;
  char level[32];

  if(item->level > current->level)
    /* don't show non-accessible items */
    return TRUE;

  if(item->level) {
    sprintf(level, " [%d]", item->level);
  }
  
  sprintf(set, "%s%s = ",
	  item->name,
	  item->level?level:"");
  setp = &set[strlen(set)];

  switch(item->flags) {
  case SET_ONOFF:
    sprintf(setp, "%s", OnOff(*(long *)item->value));
    break;
  case SET_NUM:
    sprintf(setp, "%d", *(long *)item->value);
    break;
  case SET_TIME:
    sprintf(setp, "%s", SecsToString(*(long *)item->value));
    break;
  case SET_SPEC:
    switch(item->ID) {
    case SPECIAL_CMODE:
      sprintf(setp, "%s", cmodes);
      break;
    case SPECIAL_CKEY:
      sprintf(setp, "%s", ckey);
      break;
    case SPECIAL_LANGUAGE:
      sprintf(setp, "%s", language);
      break;
    }
    break;
  }
  return FALSE;
}

/*
 * ShowSetGroup()
 *
 * Shows the SETs of the specified group. All items in the group will get
 * displayed (even if some might have higher access levels) if the person
 * has the access.
 *
 * Output format:
 *
 * "Group OWNER [242]: EXECPROTECT = on, OTHERFLAG = off"
 *
 */
static int ShowSetGroup(char *from, struct SetGroup *grp)
{
  char buffer[MIDBUFFER];
  char set[MINIBUFFER];
  char level[MINIBUFFER];
  char *bufp=buffer;
  char *setp;
  int len=0;
  int setlen;
  int i;
  int count=0;
  struct SetItem *item = grp->group;

  if(grp->level > current->level)
    /* attempted access violation */
    return TRUE;

  if(grp->level) {
    sprintf(level, " [%d]", grp->level);
  }
  sprintf(buffer, "<%s%s>: ", grp->name, grp->level?level:"");
  len = strlen(buffer);
  bufp += len;
  for(i=0; item[i].name; i++) {

    if(ShowSetItem(&item[i], set))
      continue;

    setlen = strlen(set);
    if(len+setlen >= (MIDBUFFER-3)) {
      Send(from, buffer);
      bufp=buffer;
      len=0;
      count=0;
    }
    sprintf(bufp, "%s%s",
	    count?", ":"",
	    set);
    count++;
    len += strlen(bufp);
    bufp += strlen(bufp);
    
  }
  Send(from, buffer);
  return FALSE;
}

int static
FindItemInGroup(struct SetGroup *grp, char *label, struct SetItem **item)
{
  struct SetItem *group = grp->group;
  struct SetItem *hit=NULL;
  int i;
  int amount=0;
  for(i=0; group[i].name; i++) {
#if 0
    if(group[i].level > current->level)
      /*
       * Don't even bother to try labels we aren't allowed
       * to access.
       */
      continue;
#endif
    if(!strncasecmp(group[i].name, label, strlen(label))) {
      *item = &group[i];
      amount++;
    }
  }
  return amount;
}

/*
 * GimmeGroup()
 *
 * Returns the group number which matches the 'group' parameter.
 * Set 'error' to TRUE to get error reports, FALSE will make it
 * return -1 silently.
 */
static struct SetGroup *GimmeGroup(char *from, char *group, bool error)
{
  int grpnum=-1;
  int i;
  int amount=0;
  for(i=0; i<sizeof(sets)/sizeof(sets[0]);i++) {
#if 0
    if(sets[i].level>current->level)
      /*
       * Don't even bother to search for a group that we aren't allowed
       * to access.
       */
      continue;
#endif
    if(!strncasecmp(sets[i].name, group, strlen(group))) {
      amount++;
      grpnum = i;
    }
  }
  if(!amount) {
    if(error)
      Sendf(errfrom, GetText(msg_group_doesnt_exist), group);
    return NULL;
  }
  else if(2 <= amount) {
    if(error)
      Sendf(errfrom, GetText(msg_matches_several_groups), group);
    return NULL;
  }
  return &sets[grpnum];
}


/*
 * GimmeItem()
 *
 * Returns the label which matches the 'label' parameter.
 * Set 'error' to TRUE to get error reports, FALSE will make it
 * return -1 silently.
 * The 'retgrp' will get a pointer to the group in which the label was
 * found.
 */
struct SetItem *
GimmeItem(char *from, char *group, char *label, bool error,
	  struct SetGroup **retgrp)

{
  struct SetItem *hit;
  struct SetGroup *grp;
  int amount = 0;
  int i;
  if(group[0]) {
    grp = GimmeGroup(from, group, TRUE);
    if(!grp)
      return NULL;
    amount = FindItemInGroup(grp, label, &hit);
  }
  else {
    int now;
    for(i=0; i<sizeof(sets)/sizeof(sets[0]);i++) {
      now = FindItemInGroup(&sets[i], label, &hit);
      amount += now;
      if(now)
	grp = &sets[i];
    }
  }
  if(!amount) {
    if(error)
      Sendf(errfrom, GetText(msg_item_doesnt_exist),
	    label, group[0] ? GetText(msg_in_that_group) : "");
    return NULL;
  }
  else if(2 <= amount) {
    if(error)
      Sendf(errfrom, GetText(msg_matches_several_items), label);
    return NULL;
  }
  
  *retgrp = grp;
  return hit;
}

/*
 * HelpSet()
 *
 * Display help text and information about the specified token (group or
 * item).
 */
int
HelpSet(char *from, char *token)
{
  struct SetItem *hit;
  struct SetGroup *grp;
  char set[MINIBUFFER];
  int nodisp;

  /* first, try an item with this name */
  hit = GimmeItem(from, "", token, FALSE, &grp);
  if(hit) {
    nodisp = ShowSetItem(hit, set);
    Sendf(from, "%s %s: %s (%s)", GetText(msg_set),
	  hit->name, GetText(hit->help), nodisp?GetText(msg_no_access):set);
  }
  else {
    /* now, try a group names like this */
    grp = GimmeGroup(from, token, FALSE);
    if(grp) {
      Sendf(from, "%s %s: %s.", GetText(msg_group), grp->name, GetText(grp->help));
    }
    else {
      Send(from, GetText(msg_cant_find_set_keyword));
      return TRUE;
    }
  }
  return FALSE;
}

/*
 * ShowSetAll()
 *
 * Show all items in all groups.
 */
void
ShowSetAll(char *from)
{
  int i;
  for(i=0; i<sizeof(sets)/sizeof(sets[0]);i++) {
    ShowSetGroup(from, &sets[i]);
  }
}
/*
 * SetSet()
 * 
 * Called straight from command.c and the CmdSet(). Parse the input and
 * perform every action in here.
 */

int
SetSet(char *from, char *line)
{
  char group[32] = "";
  char label[32];
  char value[32];
  char dot[32];
  struct SetItem *hit;
  struct SetGroup *grp;
  int i;
  int amount=0;

  i = sscanf(line, "%31[^ .\n]%31[. ]%31s %31s", group, dot, label, value);

  /*  printf("%d - %s %s %s %s\n", i, group, dot, label, value); */

  switch(i) {
  case -1: /* this is what they call EOF, returned "If the input ends before
              the first matching failure or conversion" */
  case 0:
    ShowSetAll(from);
    return FALSE;

  case 1:
    /* one parameter, show the SETs for the specified group */
    grp = GimmeGroup(from, group, FALSE);
    if(!grp) {
      /* hm, well try to show the group that item belongs to then */
      hit = GimmeItem(from, "", group, FALSE, &grp);
      if(!hit) {
	Send(errfrom, GetText(msg_i_dont_understand));
	return TRUE;
      }
    }
    ShowSetGroup(from, grp);
    return FALSE;

  case 2:
  case 3:
    if(2==i || strchr(dot, '.')) {
      /* this just be an attempt to specify a group name, but we don'
	 have a value. */
      grp = GimmeGroup(from, group, TRUE);
      if(grp)
	ShowSetGroup(from, grp);
      else
	return TRUE;
      return FALSE;
    }
    strcpy(value, label);
    strcpy(label, group);
    group[0]=0; /* no group specified */
  }

  hit = GimmeItem(from, group, label, TRUE, &grp);
  if(!hit)
    return TRUE;

  /*
   * Access control could be done at lower layers. Using it this way,
   * everything but actually changing the SET will be available to
   * anyone (i.e help and display current status).
   */
  if(grp->level > current->level ||
     hit->level > current->level) {
    Send(errfrom, GetText(msg_dont_touch_this));
    return TRUE;
  }

  switch(hit->flags) {
  case SET_SPEC:
    switch(hit->ID) {
    case SPECIAL_CMODE:
      CmdCmode(from, value);
      break;
    case SPECIAL_CKEY:
      CmdCkey(from, value);
      break;
    case SPECIAL_LANGUAGE:
      defaultlang = LanguageNum(value);
      strcpy(language, LanguageLocal(defaultlang));
      break;
    }
    break;
  case SET_ONOFF:
    *(long *)hit->value = IsOn(value);
    break;
  case SET_NUM:
    *(long *)hit->value = atoi(value);
    if (!strcmp(hit->name, "OPLEVEL")) {
      if (oplevel > current->level)
        oplevel = current->level;
    }
    break;
  case SET_TIME:
    *(long *)hit->value = ToSeconds(value);
    break;
  }
  SaveSettings();
  ShowSetGroup(from, grp);
  return FALSE;
}

void InitSets()
{
  int i;
  struct SetItem *item;
  for(i=0; i<sizeof(sets)/sizeof(sets[0]);i++) {
    if(sets[i].level)
      sets[i].level = levels[ sets[i].level ];
    for(item = sets[i].group;item->name; item++) {
      if(item->level)
	item->level = levels[ item->level ];
    }
  }
}


/*** New LEVEL stuff ***/

/*
 * Easy-to-change array
 */

long levels[]={0, 10, 20, 50, 100, 200, 242, 999999};

#if 0
/******************************************************************************
New stuff 970618 to better deal with the users' own info, flags and status.

This is 4.7+ stuff

 __  __       _        __       
|  \/  |_   _(_)_ __  / _| ___  
| |\/| | | | | | '_ \| |_ / _ \ 
| |  | | |_| | | | | |  _| (_) |
|_|  |_|\__, |_|_| |_|_|  \___/ 
        |___/                   
*****************************************************************************/


#define MYINFO_USER  0x80
#define MYINFO_GUEST 0x40

typedef enum {
  MYINFO_LANGUAGE=1,
  MYINFO_REPORT,
  MYINFO_SPY,
  MYINFO_DEBUG,
} myspecial;

/* debug-defines to make it compile */
#define msg_myinfo_comment NULL
#define msg_myinfo_email NULL
#define msg_myinfo_language NULL
#define msg_myinfo_report NULL
#define msg_myinfo_spy NULL
#define msg_myinfo_debug NULL
#define msg_myinfo_info NULL
#define msg_myinfo_flags NULL

static struct SetItem myinfoinfo[]={
  {"EMAIL",
   0,
   SET_STRING,
   (void *)offsetof(itemuser, realname),
   MYINFO_USER,
   msg_myinfo_email},
  /* replaces SETEMAIL */

  {"COMMENT", 0, SET_STRING, (void *)offsetof(itemuser, comment), MYINFO_USER,
   msg_myinfo_comment},
  /* replaces COMMENT */

  {"LANGUAGE", 0, SET_STRING,(void *)offsetof(itemuser, language) ,
   MYINFO_USER | MYINFO_LANGUAGE, msg_myinfo_language},
  /* replaces LANGUAGE */
};
static struct SetItem myinfoflags[]={
  {"REPORT", LEVEL_CHANOP, SET_ONOFF, NULL, MYINFO_REPORT, msg_myinfo_report},
  /* replaces REPORTADD and REPORTDEL */

  {"SPY", LEVEL_BOT, SET_ONOFF, NULL, MYINFO_SPY, msg_myinfo_spy},
  /* replaces SPYADD and SPYDEL */
  
  {"DEBUG", LEVEL_BOT, SET_ONOFF, NULL, MYINFO_DEBUG, msg_myinfo_debug},
  /* replaces DEBUGADD and DEBUGDEL */
};  

static struct SetGroup myinfo[]={
  {"INFO",       LEVEL_RECOG, myinfoinfo,  msg_myinfo_info},
  {"FLAGS",      0, myinfoflags, msg_myinfo_flags},
};

#endif
