/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 * ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing autors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjrn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/setup.h,v $
 * $Revision: 3.2 $
 * $Date: 1997/07/15 07:50:25 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: setup.h,v $
 * Revision 3.2  1997/07/15 07:50:25  dast
 * changed the __CONFIG_H define to __SETUP_H
 * added the SET_STRING define
 *
 * Revision 3.1  1997/04/28 16:54:55  dast
 * new help-field
 *
 * Revision 2.2  1996/12/09 18:27:08  dast
 * new proto
 *
 * Revision 2.1  1996/12/03 17:14:12  dast
 * the new SET system's defines and protos
 *
 * Revision 1.1  1996/07/23 07:14:32  dast
 * Initial revision
 *
 * Revision 1.3  1996/07/10 16:15:00  dast
 * Added the source header.
 *
 *
 *****************************************************************************/
#ifndef __SETUP_H
#define __SETUP_H

struct Config {
  char *label;
  void *value;   /* pointer to the real storage */
  void *def;     /* default value */
  char flags;    /* specifies the kind of config setting, see defines below */
  char setting;  /* value will be saved in setfile */
  char *verbose; /* detailed description of the label */
  bool changed;  /* read from .config or .set file */
};

#define CFG_INTEGER 0 /* 0 - 2G */
#define CFG_SWITCH  1 /* TRUE / FALSE */
#define CFG_STRING  2 /* regular string, pointing to a static string area */
#define CFG_LIST    3 /* comma seperated list, uses itemlist */
#define CFG_FUNCTION 4 /* function */

#define BTRUE (void *)1
#define BFALSE (void *)0

int ConfigInit(void);
void ConfigCleanup(void);

/******************************************************************************
 * The following piece of source is the new SET functions.
 *****************************************************************************/

struct SetItem {
  char *name;
  long level;   /* if non-zero, different level required to access than for
		   rest of group */
  long flags;   /* see below */
  void *value;  /* pointer to the variable holding the info */
  long ID;      /* for special ones */
  char **help; /* for localized strings, describe item */
};

#define SET_ONOFF 1 /* just a toggle switch */
#define SET_NUM   2 /* integer */
#define SET_TIME  3 /* contains a time integer */
#define SET_SPEC  4 /* treat special */
#define SET_STRING 5 /* new in 4.7 */

struct SetGroup {
  char *name; /* name of group */
  long level; /* level required to access (if different than 'SET') */
  struct SetItem *group;
  char **help; /* description of the group */
};
int SetSet(char *from, char *line);
int HelpSet(char *from, char *token);
void ShowSetAll(char *from);
void InitSets(void);
void MakeConfig(void);

#endif
