/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 * ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing autors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjrn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/tell.h,v $
 * $Revision: 1.4 $
 * $Date: 1997/04/28 16:56:07 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: tell.h,v $
 * Revision 1.4  1997/04/28 16:56:07  dast
 * new proto
 *
 * Revision 1.3  1996/08/30 11:29:13  dast
 * new telllist struct
 *
 * Revision 1.2  1996/07/10 16:15:00  dast
 * Added the source header.
 *
 *
 *****************************************************************************/

#ifndef __TELL_H
#define __TELL_H

#include "dancer.h"
#include "user.h"
#include "list.h"

typedef struct Tellstruct {
  struct Header h;
  int id;
  char *sender;    /* a!b@c.d */
  char *receiver;  /* b@c.d */
  char *rcvdomain; /* b@*.d */
  time_t when;
  char *message;
} itemtell;


void TellInit(void);
void TellCleanup(void);
void TellMe(char *, char *, bool);
void TellAdd(char *, char *, char *, char *);
void TellDel(char *, char *, char *);
void TellList(char *, char *);
void TellNotify(itemguest *);
void TellSave(void);

#endif
