#ifdef RCS
static char rcsid[]="$Id: transfer.c,v 2.5 1998/02/14 11:37:10 dast Exp dast $";
#endif
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 *  ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing authors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjorn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/transfer.c,v $
 * $Revision: 2.5 $
 * $Date: 1998/02/14 11:37:10 $
 * $Author: dast $
 * $State: Exp $
 * $Locker: dast $
 *
 * ---------------------------------------------------------------------------
 * $Log: transfer.c,v $
 * Revision 2.5  1998/02/14 11:37:10  dast
 * enlarged buffers
 *
 * Revision 2.4  1998/01/29 15:28:52  dast
 * beautified the snoop output for commands without parameters
 *
 * Revision 2.3  1998/01/26 17:21:45  dast
 * first-day-of-the-year fix for the log function
 *
 * Revision 2.2  1997/11/05 22:03:24  dast
 * updated!
 *
 * Revision 2.1  1997/08/25 18:06:53  dast
 * fileget stuff
 *
 * Revision 1.33  1997/04/28 16:49:30  dast
 * new stuff
 *
 * Revision 1.32  1997/01/27 17:15:51  dast
 * new multicast stuff
 *
 * Revision 1.31  1997/01/11 20:41:30  dast
 * fixed the date in the header of new logs
 *
 * Revision 1.30  1997/01/07 18:21:05  dast
 * better logfile naming
 * added info on top of new logfiles
 *
 * Revision 1.29  1997/01/07 16:36:50  dast
 * removed a LOG item
 * echo-prevention in the CHAT mode
 *
 * Revision 1.28  1996/12/09 18:27:22  dast
 * enhanced the log header slightly
 *
 * Revision 1.27  1996/12/06 15:58:56  dast
 * made a call to KickFromQueue() instead of keeping the code in here
 *
 * Revision 1.26  1996/12/03 17:14:58  dast
 * just a debug thing
 *
 * Revision 1.25  1996/11/27 20:43:44  dast
 * execprotect was added by breese
 *
 * Revision 1.24  1996/11/21 18:30:05  dast
 * Fixed the serious security leak in Execute() when ` was used.
 *
 * Revision 1.23  1996/09/03 15:26:10  dast
 * Uses AddKick() properly
 *
 * Revision 1.22  1996/08/30 11:29:13  dast
 * uses 'now'
 *
 * Revision 1.21  1996/08/26 07:13:36  dast
 * Added breese's fix for the message queue
 *
 * Revision 1.20  1996/08/21 11:17:31  dast
 * breese's update
 *
 * Revision 1.19  1996/08/06 10:54:58  dast
 * AlertMode timeout support
 *
 * Revision 1.18  1996/08/05 13:34:13  dast
 * breese's major update fix
 *
 * Revision 1.17  1996/08/05 12:07:25  dast
 * Added DisconnectServ() usage
 *
 * Revision 1.16  1996/07/26 11:34:58  dast
 * snapshot stuff
 * CTCP stuff
 *
 * Revision 1.15  1996/07/12 13:01:28  dast
 * the case of the forgotten breaks-within-a-switch-statement was solved and
 * therefore we could yet again use the FIND command =)
 *
 * Revision 1.14  1996/07/10 16:15:00  dast
 * Added the source header.
 *
 *
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "dancer.h"
#include "function.h"
#include "user.h"
#include "transfer.h"
#include "netstuff.h"
#include "seen.h"
#include "servfunc.h"
#include "link.h"
#include "flood.h"
#include "bans.h"
#include "command.h" /* for the FindCommand() */
#include "ctcp.h"

extern time_t now;

extern bool chat;
extern bool connected;
extern bool cleanup;
extern bool restart;
extern bool execprotect;
extern itemclient *client;
extern itemclient *clientHead;
extern itemguest *guestHead;
extern int lastpost;
extern char nickname[];
extern char channel[];
extern fd_set rdset;
extern char logfile[];
extern FILE *flog;
extern itemident *current;

extern int botop; /* are we chanop? */

static void QueueKick(itemguest *, char *);

struct Execstruct ExecHead = {
  NULL, NULL, NULL, -1, NULL
};

struct Msgstruct MsgHead = {
  NULL, NULL, NULL
};

itemexec *execHead = &ExecHead;
itemmsg *msgHead = &MsgHead;

int kickQ=0; /* number of kicks in the queue */


/* --- SendNick --------------------------------------------------- */

/* Send directly to nick */

inline void SendNick(char *nick, char *msg)
{
  itemmsg *p, *n;

  for (n = msgHead; n->next; n = n->next); /* Append to list */

  p = (itemmsg *)calloc(1, sizeof(struct Msgstruct));
  if (p) {
    n->next = p;
    p->nick = strdup(nick);
    p->msg  = strdup(msg);
  }
}

void SendNickf(char *nick, char *fmt, ...)
{
  char buf[BIGGERBUFFER];
  va_list args;

  va_start(args, fmt);
  vsprintf(buf, fmt, args);
  va_end(args);
  SendNick(nick, buf);
}

/* --- Send ------------------------------------------------------- */

/* Send to client if possible, else to nick */

void Send(char *nick, char *msg)
{
  if (msg) {
#ifdef STDIODEBUG
    fprintf(stderr, "%s\n", msg);
    return;
#endif
    if (chat)
      if (client->status == CL_CONNECTED)
	/* Ship immediately to current client */
	WriteSocket(client->socket, msg);
      else
	SendNick(client->ident->nick, msg);
    else if(nick)
      /* This is only /msg, don't flood */
      SendNick(nick, msg);
  }
}

void Sendf(char *nick, char *fmt, ...)
{
  char buf[BIGGERBUFFER];
  va_list args;

  if (fmt) {
    va_start(args, fmt);
    vsprintf(buf, fmt, args);
    va_end(args);
    Send(nick, buf);
  }
}

/* --- SendCtcp --------------------------------------------------- */

void ReplyCtcp(char *nick, char *msg)
{
  char buf[BIGGERBUFFER];

  CtcpQuote(msg, buf);
  WriteServer("NOTICE %s :\001%s\001", nick, buf);
}

void ReplyCtcpf(char *nick, char *fmt, ...)
{
  va_list args;
  char buf[BIGGERBUFFER];

  va_start(args, fmt);
  vsprintf(buf, fmt, args);
  va_end(args);
  ReplyCtcp(nick, buf);
}

void SendCtcp(char *nick, char *msg)
{
  char buf[BIGGERBUFFER];

  CtcpQuote(msg, buf);
  WriteServer("PRIVMSG %s :\001%s\001", nick, buf);
}

void SendCtcpf(char *nick, char *fmt, ...)
{
  va_list args;
  char buf[BIGGERBUFFER];

  va_start(args, fmt);
  vsprintf(buf, fmt, args);
  va_end(args);
  SendCtcp(nick, buf);
}

/* --- Multicast -------------------------------------------------- */

/* types: see *CAST in header file */

void MulticastLocal(int type, char *msg)
{
  itemclient *p;

  for (p = Succ(clientHead); p; p = Succ(p)) {
    if((type&CHATCAST) &&         /* this is a CHAT message */
       current &&
       current->client &&         /* the current user has a client connected */
       (current->client == p) &&  /* this client is the current user's */
       !p->chatecho)              /* this client has turned off echo */
      continue; /* don't send anything to this client */
    if ((p->status == CL_CONNECTED) && (p->flags & type)) {
      WriteSocket(p->socket, msg);
    }
  }
}

void MulticastLocalf(int type, char *fmt, ...)
{
  va_list args;
  char buf[BIGGERBUFFER];

  va_start(args, fmt);
  vsprintf(buf, fmt, args);
  va_end(args);
  MulticastLocal(type, buf);
}

void Multicast(int type, char *msg)
{
  MulticastLocal(type, msg);
  SendLinkAll(IBCP_MULTICAST, "%d %s", type, msg);
}

void Multicastf(int type, char *fmt, ...)
{
  va_list args;
  char buf[BIGGERBUFFER];

  va_start(args, fmt);
  vsprintf(buf, fmt, args);
  va_end(args);
  Multicast(type, buf);
}

/* --- MessageQueue ----------------------------------------------- */

itemmsg *FreeMessage(itemmsg *p)
{
  itemmsg *pp;

  pp = p->next;
  if (p->nick) free(p->nick);
  if (p->msg) free(p->msg);
  free(p);
  return (pp);
}

void FlushMessages(void)
{
  itemmsg *p;

  p = msgHead->next;
  while (p)
    p = FreeMessage(p);
  msgHead->next = NULL;
}

void MessageQueue()  /* Used to send delayed messages */
{
  itemmsg *p;
  static int sentmsgs = 0;
  static time_t lastsent = 0;

  if ( connected ) {

    if ( kickQ && botop ) {
      if(!KickFromQueue(&lastsent))
        kickQ = 0; /* cleared */

    } else {
      AlertMode(ALERT_OFF); /* switches off alert mode with timeout */
      p = msgHead->next;
      if (p) {
        /* Send queued messages if present and we haven't sent too
           many too fast */
        while ( sentmsgs < 3 ) {
          sentmsgs++;
          WriteNick(p->nick, p->msg);
          if ( (msgHead->next=FreeMessage(p)) == NULL )
            break; /* while */
          p = msgHead->next;
          lastsent = now;
        }
      }
    }
    if ( (lastsent + 2 <= now) && (sentmsgs > 0) )
      sentmsgs--;
  }
}

/* --- MessageReaper ---------------------------------------------- */

void MessageReaper(char *who) /* Removes all messages to 'who' */
{
  itemmsg *p, *pp;

  pp = msgHead;
  p = pp->next;
  while (p) {
    if (!strcasecmp(who, p->nick)) {
      pp->next = p = FreeMessage(p);
    } else {
      pp = p;
      p = p->next;
    }
  }
}

/* --- Execute ---------------------------------------------------- */

/* Remember to redirect stderr to stdout by appending "2>&1" */


itemexec *Exec(char *nick, char *cmd)
{
  itemexec *px = NULL;
  itemexec *pp;

  px = (itemexec *)calloc(1, sizeof(struct Execstruct));
  if (px) {

    if ( (px->pipe=popen(cmd, "r")) ) {

      px->client = client;
      if (nick)
        px->nick = strdup(nick);
      px->socket = fileno(px->pipe);
      FD_SET(px->socket, &rdset);

      /* Insert at tail */
      for (pp=execHead; pp->next; pp=pp->next);
      pp->next = px;

    }
    else {
      free(px);
      px = NULL;
    }
  }
  return px;
}

bool IsQualifier(char c)
{
  switch (c) {
  case '-': case '+': case ' ': case '#': case '.':
  case '0': case '1': case '2': case '3': case '4':
  case '5': case '6': case '7': case '8': case '9':
  case 'h': case 'l': case 'L':
    return TRUE;
  default:
    return FALSE;
  }
}

itemexec *Execute(char *nick, char *fmt, ...)
{
  char buf[BIGGERBUFFER];
  va_list args;
  char *p, *xs;
  bool wrong = FALSE;

  if (execprotect) {
    Send(nick, GetText(msg_execprotect_on));
    return NULL;
  }

  /* First search string arguments for end-quotes.
   * This is done to avoid cracking.
   */
  va_start(args, fmt);
  p = fmt;
  while (*p) {
    if (*p++ == '%') {
      while (IsQualifier(*p)) p++;
      switch(*p++) {
      /* Examine strings */
      case 's':
	xs = va_arg(args, char *);
	if (strchr(xs, '"'))
          wrong = TRUE;
        if(strchr(xs, '`'))
          wrong = TRUE; 
	break;
      /* Ignore the rest */
      case 'e': case 'E':
      case 'g': case 'G':
      case 'f':
	va_arg(args, double);
	break;
      case 'd': case 'i':
      case 'o': case 'u':
      case 'x': case 'X':
      case 'c':
	va_arg(args, int);
        break;
      case 'p':
	va_arg(args, void *);
        break;
      default:
	va_arg(args, void *);
	break;
      }
    }
  }

  if (wrong) {
    Send(nick, GetText(msg_cannot_do_that));
  } else {
    va_start(args, fmt);
    vsprintf(buf, fmt, args);
    va_end(args);
    return Exec(nick, buf);
  }
  return NULL;
}

/* --- RemoveExec ------------------------------------------------- */

itemexec *RemoveExec(itemexec *px)
{
  itemexec *pp = NULL;

  FD_CLR(px->socket, &rdset);
  pclose(px->pipe);

  /* Remove from list */
  for(pp=execHead; pp->next; pp=pp->next) {
    if (pp->next == px) {
      pp->next = px->next;
      pp = px->next; /* return value */
      break; /* for */
    }
  }
  if (px->nick) free(px->nick);
  free(px);
  return (pp);
}

/* --- GotExec ---------------------------------------------------- */

/* Ought to check if socket is still active */

itemexec *GotExec(itemexec *px)
{
  itemexec *pp = NULL;
  char buf[MAXLINE];

  chat = (px->client != NULL);

  if ( fgets(buf, MAXLINE, px->pipe) == NULL ) {
    
    if(px->notify) {
      /* this is a file transfer client, we should therefor set the END OF
         TRANSFER bit in that struct to let it know */
      itemclient *k;

      for (k=Succ(clientHead); k; k=Succ(k)) {
        if (k->ident && !strcasecmp(k->ident->nick, px->nick) &&
            k->linksort==OUT_SEND) /* get the send, nothing else */
          break;
      }
      if(k)
        k->fileflags |= CLF_FILECOMPLETE;
    }
    client = px->client;
    if (client) {
      Send(NULL, GetText(msg_done));
    }
    else if ( px->nick && !IsChannel(px->nick) )
      Send(px->nick, GetText(msg_done));
    pp = RemoveExec(px);

  } else {

    if ( strtok(buf, "\r\n") == buf ) {
      client = px->client;
      Send(px->nick, buf);
    }
  }
  return (pp);
}

/* --- SnoopCommand ----------------------------------------------- */

void SnoopCommand(char *from, char *cmd, char *param)
{
  char buf[BIGGERBUFFER];
  char *who;
  struct Command *command;

  /* Skip if stealth user or no clients are attached */
  if (Succ(clientHead) && current && ((current->user &&
      !current->user->flags.stealth) || !current->user)) {

    who = (from ? from : client->ident->nick);
    if (cmd && *cmd) {
      command = FindCommand(cmd);
      /* Filter certain command from spylink */
      if(command && command->hide) {
        sprintf(buf, GetDefaultText(msg_spy_hidden_command),
		who, cmd, GetDefaultText(msg_snoop_prevented));
      }
      else {
        sprintf(buf, GetDefaultText(msg_spy_who_did_what),
                who, cmd, *param?" ":"", param);
      }
      Multicast(SPYCAST, buf);
    }
  }
}

/* --- Say -------------------------------------------------------- */

void Say(char *msg)
{
  WriteServer("PRIVMSG %s :%s", channel, msg);
  lastpost = now;
}

void Sayf(char *fmt, ...)
{
  char buf[BIGGERBUFFER];
  va_list args;
  
  va_start(args, fmt);
  vsprintf(buf, fmt, args);
  va_end(args);
  Say(buf);
}

/* --- Action ----------------------------------------------------- */

void Action(char *msg)
{
#if 1
  /* If we don't send this raw we can't use i.e control codes etc */
  WriteServer("PRIVMSG %s :\001ACTION %s\001", channel, msg);
#else
  SendCtcpf(channel, "ACTION %s", msg);
#endif
  lastpost = now;
}

void Actionf(char *fmt, ...)
{
  char buf[BIGGERBUFFER];
  va_list args;
  
  va_start(args, fmt);
  vsprintf(buf, fmt, args);
  va_end(args);
  Action(buf);
}

/* --- Mode ------------------------------------------------------- */

void Mode(char *fmt, ...)
{
  char buf[BIGGERBUFFER];
  va_list args;
  
  va_start(args, fmt);
  vsprintf(buf, fmt, args);
  va_end(args);
  WriteServer("MODE %s %s", channel, buf);
  Logf(LOGDBUG, "sent MODE %s %s", channel, buf);
}

/* --- Kick ------------------------------------------------------- */

time_t kicklast=0;
int kickcount=0;

void Kick(char *nick, char *msg)
{
  itemguest *w;

  if(kicklast+1 >= now)
    ++kickcount;
  else
    kickcount=0;
  
  w = FindNick(nick);
  if(!w)
    return;

  w->flags.kick = TRUE;
  w->kicktime = now;

  if(!botop || kickQ || (kickcount > 2)) {
    QueueKick(w, msg);
    /* 
     * Stress situation, stop replying to CTCPs for a little while!
     * We do this is we're not chanops too, since then we'll be able to
     * kick this person as soon as we get opped! ;)
     */
    CTCPignore();
    Logf(LOGDBUG, "Enqueued KICK %s", nick);
  }
  else {
    if(!w->flags.kicked) {
      Logf(LOGDBUG, "Sent KICK %s to server", nick);
      WriteServer("KICK %s %s :%s", channel, nick, (msg ? msg : nickname));
      w->flags.kicked=TRUE;
    }
    kicklast = now;
  }
}

void StickyKick(itemguest *w, char *msg)
{
  AddKick(w->ident, nickname, msg, KICK_BOT);
  if (!w->flags.kick) {
    Kick(w->ident->nick, msg);
  }
#if 0
  else
    Logf(LOGDBUG, "Held back KICK %s (already issued)", w->ident->nick);
#endif
}

static void QueueKick(itemguest *w, char *msg)
{
  if(!w->kickmsg)
    /* only get the first message */
    w->kickmsg = strdup(msg);

  kickQ++; /* one in the pipe */
}

/* --- Invite ----------------------------------------------------- */

void Invite(char *who)
{
  WriteServer("INVITE %s %s", who, channel);
}

/* --- Log -------------------------------------------------------- */

int lastlogday=-1;
int logdays = 10;

static void RenameAndDelete(void)
{
  char buf[MIDBUFFER];
  time_t then = now;
  struct tm *t;
  then -= (24*3600); /* 24 hours ago we were in yesterday land */
  t = localtime(&then);

  sprintf(buf, "%s.%d%02d%02d",
	  logfile, 1900 + t->tm_year, t->tm_mon+1, t->tm_mday);
  rename(logfile, buf); /* rename yesterday's logfile */

  then -= (24*3600*logdays); /* even further back */
  t = localtime(&then); /* get the date to delete */

  sprintf(buf, "%s.%d%02d%02d",
	  logfile, 1900 + t->tm_year, t->tm_mon+1, t->tm_mday);
  unlink(buf); /* remove the old one */
}

void InitLog(void)
{
  struct stat stbuf;
  struct tm *t, *tt;

  t = localtime(&now);
  lastlogday = t->tm_yday;

  if (*logfile) {
    if (stat(logfile, &stbuf) == -1)
      tt = t;
    else
      tt = localtime(&stbuf.st_ctime);

    if (lastlogday != tt->tm_yday)   /* Backup logfile */
      RenameAndDelete();
  }
}

ulong activelog = -1;

/* See enum in header */
char *logtypes[] = {
  "***",    "Join",   "Part",
  "Quit",   "Nick",   "Mode",
  "Kick",   ">>>",    "#>>",
  "-->",    "Ctcp",   "Client",
  "Warn",   "NSplit", "NJoin",
  "NHeal",  "DEBUG",  "DBUG",
  "INIT",   "#",
  NULL
};


void Log(int type, char *buf)
{
  struct tm *t;
  FILE *flog;
  extern char servername[];
  extern time_t uptime;

  t = localtime(&now);

  if ( (activelog & (1<<type)) && (-1 != lastlogday) &&
      *logfile && (flog=fopen(logfile, "a")) ) {
    
    if (lastlogday != t->tm_yday) { /* Timestamp logfile */
      lastlogday = t->tm_yday;
      fclose(flog);
      RenameAndDelete();
#ifdef OLDIE
      sprintf(buf, "%s.%d%02d%02d",
	      logfile, 1900 + t->tm_year, t->tm_mon+1, t->tm_mday);
      rename(logfile, buf);

      if(t->tm_yday - logdays <= 0) {
	t->tm_year--;
	t->tm_mday = 365 + t->tm_yday - logdays;
      }
      else
	t->tm_mday = t->tm_yday - logdays;
      timelocal(t);
      sprintf(buf, "%s.%d%02d%02d",
	      logfile, 1900 + t->tm_year, t->tm_mon+1, t->tm_mday);
      unlink(buf); /* remove the old one */

      sprintf(buffer, "%s.%d.%03d", logfile, 1900 + t->tm_year, t->tm_yday);
      rename(logfile, buffer);
#endif
      /* and now, create the new one */
      if ( !(flog=fopen(logfile, "a")) )
        return;

      t = localtime(&now); /* the struct tm is static date that the
                              RenameAndDelete() ruined */
      fprintf(flog,
	      "\n"
	      "--- Log for %02d.%02d.%d  Server: %s  Channel: %s\n"
	      "--- Nick: %s%s  Version: %s  Started: %s ago\n"
	      "\n",
              t->tm_mday, t->tm_mon + 1, t->tm_year,
              servername, channel, botop?"@":"", nickname, VERSIONMSG,
	      TimeAgo(uptime));
#ifdef OLDIE
      if(t->tm_yday - logdays <= 0) 
        sprintf(buffer, "%s.%d.%03d", logfile, 1899 + t->tm_year,
                365 + t->tm_yday - logdays);
      else
        sprintf(buffer, "%s.%d.%03d", logfile, 1900 + t->tm_year,
                t->tm_yday - logdays);

      unlink(buffer); /* remove the old one */
#endif
    }

#ifdef DBUG
    printf("%02d.%02d.%02d %-7s %s\n",
           t->tm_hour, t->tm_min, t->tm_sec, logtypes[type], buf);
#else
    fprintf(flog, "%02d.%02d.%02d %-7s %s\n",
            t->tm_hour, t->tm_min, t->tm_sec, logtypes[type], buf);
#endif
    fclose(flog);
  }
  else if(-1 == lastlogday)
    fprintf(stderr, "%02d.%02d.%02d %-7s %s\n",
            t->tm_hour, t->tm_min, t->tm_sec, logtypes[type], buf);
}

void Logf(int type, char *fmt, ...)
{
  va_list args;
  char buf[BIGGERBUFFER];
  
  va_start(args, fmt);
  vsprintf(buf, fmt, args);
  va_end(args);
  Log(type, buf);
}

/* --- Snapshot --------------------------------------------------- */

#define MAXSNAP 4
char *snapfile[MAXSNAP];
int snapline[MAXSNAP];
int snapnum = 0;

void makesnapshot(char *file, int line)
{
  snapnum = snapnum++ % MAXSNAP;
  snapfile[snapnum] = file;
  snapline[snapnum] = line;
}

inline int getsnapline(void)
{
  return snapline[snapnum];
}

inline char *getsnapfile(void)
{
  return snapfile[snapnum];
}

/* --- Debug ------------------------------------------------------ */

void Debug(char *fmt, ...)
{
  va_list args;
  char buf[BIGGERBUFFER];
  char *p;

  va_start(args, fmt);
  vsprintf(buf, fmt, args);
  p = strchr(buf, NIL);
  if (p)
    sprintf(p, " (snapshot: %s line %d)", getsnapfile(), getsnapline());
  va_end(args);
  Log(LOGDEBUG, buf);
  Multicastf(DEBUGCAST, "DEBUG: %s", buf);
}

/* --- Quit ------------------------------------------------------- */

void Quit(char *from, char *reason)
{
  WriteServer("QUIT :%s", ((reason && *reason) ? reason : NOREASON));
  /* Seen & Delete also handled by OnQuit, but how about restart/cleanup? */
  SeenInsertAll(SEENQUITED, NULL, NULL);
  DeleteGuests();
  DisconnectServ("QUIT %s", ((reason && *reason) ? reason : NOREASON));
  restart = FALSE;
  cleanup = TRUE;
}
