/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 * ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing autors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjrn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/transfer.h,v $
 * $Revision: 2.1 $
 * $Date: 1997/08/25 18:07:06 $
 * $Author: dast $
 * $State: Exp $
 * $Locker:  $
 *
 * ---------------------------------------------------------------------------
 * $Log: transfer.h,v $
 * Revision 2.1  1997/08/25 18:07:06  dast
 * fileget support, changed a proto
 *
 * Revision 1.15  1997/01/27 17:16:35  dast
 * new protos
 *
 * Revision 1.14  1997/01/07 16:37:27  dast
 * removed LOGBDUG
 *
 * Revision 1.13  1996/12/03 17:02:27  dast
 * new prototype
 *
 * Revision 1.12  1996/08/21 11:17:31  dast
 * breese's update
 *
 * Revision 1.11  1996/08/05 13:34:13  dast
 * breese's major update fix
 *
 * Revision 1.10  1996/07/26 11:34:58  dast
 * snapshot stuff
 * CTCP stuff
 *
 * Revision 1.9  1996/07/10 16:15:00  dast
 * Added the source header.
 *
 *
 *****************************************************************************/

#ifndef __TRANSFER_H
#define __TRANSFER_H

#include "dancer.h"
#include "user.h"

/* See logtypes in code */
enum {
  LOG = 0,
  LOGJOIN, LOGPART, LOGQUIT,
  LOGNICK, LOGMODE, LOGKICK,
  LOGCMD, LOGPCMD, LOGMSG,
  LOGCTCP, LOGCLIENT, LOGWARN,
  LOGSPLIT, LOGNJOIN, LOGNHEAL,
  LOGDEBUG, LOGDBUG,
  LOGINIT, LOGPUB,
  LOGNONE /* Must be the last one */
};

#define LOGALLMASK ((1<<LOGNONE)-1)

typedef struct Execstruct {
  struct Execstruct *next;
  itemclient *client;  /* non-NULL if dcc chat */
  char *nick;  /* Use nick if no dcc chat (or it has been removed) */
  int socket;
  FILE *pipe;
  bool notify; /* we'd like a file transfer (client) for this nick to get
                  notified when this execution is done */
} itemexec;


itemexec *Execute(char *, char *, ...);
itemexec *GotExec(itemexec *);
itemexec *RemoveExec(itemexec *);
void Send(char *, char *);
void Sendf(char *, char *, ...);
inline void SendNick(char *, char *);
void SendNickf(char *, char *, ...);
void SendCtcp(char *, char *);
void SendCtcpf(char *, char *, ...);
void ReplyCtcp(char *, char *);
void ReplyCtcpf(char *, char *, ...);
void MulticastLocal(int, char *);
void MulticastLocalf(int, char *, ...);
void Multicast(int, char *);
void Multicastf(int, char *, ...);
void Wall(char *, char *);
void SnoopCommand(char *, char *, char *);
void MessageQueue();
void MessageReaper(char *);
itemmsg *FreeMessage(itemmsg *);
void FlushMessages(void);
void Action(char *);
void Actionf(char *, ...);
void Mode(char *, ...);
void Kick(char *, char *);
void StickyKick(itemguest *, char *msg);
void Log(int, char *);
void Logf(int, char *, ...);
void InitLog(void);
void Quit(char *, char *);
void Invite(char *who);
void Debug(char *, ...);
void Say(char *);

#endif
