#ifdef RCS
static char rcsid[]="$Id: user.c,v 3.8 1998/04/14 11:30:10 dast Exp dast $";
#endif
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 *  ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing authors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjorn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/user.c,v $
 * $Revision: 3.8 $
 * $Date: 1998/04/14 11:30:10 $
 * $Author: dast $
 * $State: Exp $
 * $Locker: dast $
 *
 * ---------------------------------------------------------------------------
 * $Log: user.c,v $
 * Revision 3.8  1998/04/14 11:30:10  dast
 * __CYGWIN32__ adjusted by  Chris Larsen <vader@vader.dk>
 *
 * Revision 3.7  1998/03/23 18:33:01  dast
 * no longer accepts comments longer than 256 bytes from the userfile
 *
 * Revision 3.6  1998/02/14 11:37:29  dast
 * boundary checks added
 * amiga compile adjusted
 *
 * Revision 3.5  1998/01/27 21:55:12  dast
 * Tero Jnk's suggested fixes
 *
 * Revision 3.4  1998/01/26 17:22:41  dast
 * LAB_PATCH patch
 *
 * Revision 3.3  1997/11/24 23:36:56  dast
 * changeguest now checks for warned users
 *
 * Revision 3.2  1997/08/25 17:17:21  dast
 * dontsiteban now introduced
 * ircop aware addguest()
 *
 * Revision 3.1  1997/05/28 06:25:51  dast
 * Now saves the latest newsid read per user, used by the news system
 *
 * Revision 2.3  1997/05/12 16:27:55  dast
 * added 'illegalname' check that is set TRUE if host name contains *
 *
 * Revision 2.2  1997/04/29 16:20:26  dast
 * Added language to the saved information for each user
 *
 * Revision 2.1  1997/04/28 16:50:08  dast
 * Added 'nonhostisp' support
 * Support for specified default password
 *
 * Revision 1.52  1997/02/10 19:42:10  dast
 * better checking before cleaning up non-existant lists
 *
 * Revision 1.51  1997/01/27 17:08:53  dast
 * Stealth flag support
 * linked bot support added
 *
 * Revision 1.49  1997/01/11 21:11:10  dast
 * hopefully fixed the silly totaljoins counter to get saved for all users
 * properly
 *
 * Revision 1.48  1997/01/07 16:38:28  dast
 * hostisp added
 * delete flag support
 * and more
 *
 * Revision 1.47  1996/12/13 18:11:58  dast
 * new joincounter
 *
 * Revision 1.46  1996/12/12 19:00:33  dast
 * new bot flag and bot field in the guest struct
 *
 * Revision 1.45  1996/12/11 18:37:37  dast
 * frees all struct fields in user and ident free functions
 * better usage of the true user-lines in the .users file in ReadUserfile()
 * ChangeUser() bugfix when a nick changes to the nick he is already using
 * with a client
 * Fixed the DCC double chat bug which could leave an empty struct in the
 * list
 *
 * Revision 1.44  1996/12/10 18:10:22  dast
 * cleans the splitlist in DeleteGuests()
 * counts the guests slightly different
 *
 * Revision 1.43  1996/12/09 18:31:10  dast
 * nows saves comment in .users too
 * new FindUser() syntax
 * new autoop
 *
 * Revision 1.42  1996/12/06 15:59:29  dast
 * safer save
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>   /* Next include needs this */
#include <sys/socket.h>  /* All this to get AF_INET */

#include "dancer.h"
#include "function.h"
#include "user.h"
#include "tell.h"
#include "seen.h"
#include "transfer.h"
#include "flood.h"
#include "ourcrypt.h"
#include "link.h"
#include "bans.h"

#ifdef HAVE_LIBFPL
#include "fplrun.h"
#endif

/* --- Global ----------------------------------------------------- */

extern time_t now;

extern int numUsers, numGuests, numClients;
extern int oplevel;
extern char passfile[], nickname[], commentfile[];

extern bool welcome; /* welcome new users */
extern bool warnmode; /* check people with the warnlist */
extern bool mute;
extern bool nickflood;
extern bool masterflood;
extern time_t mastertime;
extern bool botop; /* channel operator status for the bot */
extern long levels[];
extern char defaultpasswd[];

int totalnumberofsplits = 0;
time_t lastsplittime = NULL;

itemuser *userHead     = NULL;
itemguest *guestHead   = NULL;
itemlink *linkHead     = NULL;
itemclient *clientHead = NULL;
itemident *identHead   = NULL;
itemsplit *splitHead   = NULL;

char myaddr[MIDBUFFER];
char botmatch[MIDBUFFER];

long numSplitGuests=0; /* count number of split guests */

/* --- ReadUserfile ----------------------------------------------- */

void FreeUser(void *v)
{
  itemuser *u;

  if ( u=(itemuser *)v ) {
    DestroyList((void **)&u->domainhead, FreeList);
    if (u->nick)
      free(u->nick);
    if (u->realname)
      free(u->realname);
    if (u->passwd)
      free(u->passwd);
    if (u->comment)
      free(u->comment);
    if(u->stat_bywhom)
      free(u->stat_bywhom);
#ifdef HAVE_LIBFPL
    LabelCleanup(&u->label);
#endif
  }
}

void AddPasswd(char *nick, char *passwd)
{
  itemuser *u;

  for (u = Succ(userHead); u; u = Succ(u)) {
    if ( !strcasecmp(u->nick, nick) ) {
      u->passwd = strdup(passwd);
      break; /* for */
    }
  }
}

bool AddComment(itemuser *u, char *comment)
{
  if(!u->comment) {
    /* security measure, since previous versions had no length limit on
       comments */
    if(strlen(comment) > 256)
      comment[256]=0; /* cut off silly lengths */

    /* only if not previously set */
    u->comment = strdup(comment);
    return TRUE;
  }
  return FALSE;
}

void AddDomain(itemuser *u, char *line)
{
  itemlist *t;

  if ( t=(itemlist *)NewEntry(sizeof(itemlist)) ) {
    AddTail(u->domainhead, t);
    t->ptr = strdup(line);
  }
}

void AddMoreInfo(itemuser *u, char *line)
{
  char buffer[MIDBUFFER];
  time_t when;
  int flags;

  if(3 <= sscanf(line, "%"MIDBUFFERTXT"s %d %d",
                 buffer, &when, &flags)) {
    u->stat_bywhom = strdup(buffer);
    u->stat_lastchange = when;
    u->stat_lastdone = flags;
  }
}

void AddNewData(itemuser *u, char *line)
{
  char buffer[128];
  time_t passwdtime=0;
  time_t modified=0;
  time_t created=0;
  long checksum=0;
  long totaljoins=0;
  char language[128]="";
  long newsid=0;

  sscanf(line, "%127s %d %d %d %d %d %127s %d",
         buffer, &passwdtime, &modified, &created, &checksum, &totaljoins,
	 language, &newsid);
  u->passwd = strdup(buffer);
  u->passwdtime = passwdtime;
  u->created = created;
  u->modified = modified;
  u->checksum = checksum;
  /*
   * New in 4.1.5. (Added to once and for all stop the complaints on
   * the join-count system that currently follows the hostpattern rather
   * than the user.) Do note that this data will get changed on each join
   * without that should count as a 'changed user' and thus the checksum
   * routine MUST NOT include this when calculating.
   * - Bagder
   */
  u->totaljoins = totaljoins;

  /*
   * New in 4.4
   */
  if(language[0])
    u->language = LanguageNum(language);
  else
    u->language = defaultlang;

  /*
   * New in 4.6
   */
  u->newsid = newsid;
}

static long chksumstr(char *str)
{
  long checksum=0;
  if(!str)
    return 0xC0CAC01A;
  while(*str) {
    checksum<<=2;
    checksum+=*str;
    str++;
  }
  return checksum;
}

static long chksumint(int val)
{
  return val+0xDEAD;
}

long ChecksumUser(itemuser *u)
{
  itemlist *t;
  long checksum=0;

  checksum = chksumstr(u->nick);
  checksum += chksumint(u->level);
  checksum += chksumstr(VerboseFlags(&u->flags));
  checksum += chksumstr(u->realname);
  checksum += chksumstr(u->passwd);
  checksum += chksumstr(u->comment);
  checksum += chksumint(u->passwdtime);
  checksum += chksumint(u->modified);
  checksum += chksumint(u->created);
    
  if(u->stat_lastdone && u->stat_lastchange) {
    checksum += chksumstr(u->stat_bywhom);
    checksum += chksumint(u->stat_lastchange);
    checksum += chksumint(u->stat_lastdone);
  }
  for (t = Succ(u->domainhead); t; t = Succ(t)) {
    checksum += chksumstr((char *)t->ptr);
  }

  return checksum;
}


void AddLabel(itemuser *u, char *name)
{
#ifdef HAVE_LIBFPL
  char labelname[BIGBUFFER];
  char labelcontents[BIGBUFFER];
  if(2 == sscanf(name,
                 "%"BIGBUFFERTXT"s :%"BIGBUFFERTXT"[^\n]",
		 labelname, labelcontents)) {
    UserlabelSet(labelname, labelcontents, LAB_STRING,
                 (itemuserlabel **)&u->label);
  }
#endif
}

static long newcommentstyle=0;

bool ReadUserfile(char *name)
{
  FILE *f;
  int NewStyle=0;
  itemuser *u=NULL, *p;
  char line[MAXLINE];
  
  if ( *name && (f=fopen(name, "r")) ) {
  
    while ( fgets(line, MAXLINE, f) ) {
      switch (*line) {

      case '#':
      case '\n':
        break;

      case '$': /* fpl-added labels in the format <label> :<value> */
        if(u)
          AddLabel(u, line+1);
        break;

      case '-': /* password */
        if(u)
          AddNewData(u, line+1);
        NewStyle++; /* DONT read the passwd file */
        break;

      case '!': /* account pattern */
	if (u) {
	  strtok(line, "\n");
          AddDomain(u, line+1);
	}
        break;

      case '*': /* change info */
        if (u)
          AddMoreInfo(u, line+1);
        break;

      case '?': /* comment */	
	if(u) {
	  strtok(line, "\n");
	  AddComment(u, line+1);
	  newcommentstyle++;
	}
	break;

      default:
	/*
	 * In order to make this better forward compatible, we should only
	 * treat lines that actually start with a valid character to start a
	 * nick as a user-line. All other kinds of lines should be ignored
	 * as it simply may be too new for us to recognize.
	 * Letting the space go is done to make this _only_ get performed if
	 * the space is there in the future.
	 *
	 * -Bagder
	 */
	if((' ' == *line) ||
	    /* comparison below stolen from ircd2.9.2 */
	   (((*line) >= 'A' && (*line) <= '~')))
	  u = AddUser(line);
        break;
      }
    }
    fclose(f);
  }
  else
    return FALSE;

  /*
   * This is a "likeliness test" to make one (or a few) single lines like:
   * '-1 10 (<UNKNOWN>)' in the old format *NOT* make the entire file get
   * treated as one of the "new" format. Only really necessary when updating
   * from 3.6 or earlier to post 3.6.
   */
  if(numUsers>3 && NewStyle<3)
    NewStyle = 0; 

  if ( !NewStyle && *passfile && (f=fopen(passfile, "r")) ) {

    while ( fgets(line, MAXLINE, f) )
      if ( line[0] != '\n' ) {
        AddPasswd(strtok(line, ":"), strtok(NULL, "\n"));
      }
    fclose(f);
  }

  /* Fill in default password if none is supplied */
  /* check checksums to track manually modified users */

  for (p = Succ(userHead); p; p = Succ(p)) {
    int checksum;
    bool changed=FALSE;
    if(NewStyle) {
      checksum = ChecksumUser(p);
      if( p->checksum && (p->checksum != checksum)) {
        changed = TRUE;
      }
    }
    if ( !p->passwd ) {
      p->passwd = MakePassword(defaultpasswd);
      p->passwdtime = now;
      changed=TRUE;
    }
    if(changed)
      p->modified=now;
  }

  if(newcommentstyle && *commentfile) {
    /* we consider the old comment file obsolete and we will now
       remove it! (we'll stay with renaming it) */
    sprintf(line, "%s_rm", commentfile);
    rename(commentfile, line); /* gone! */
  }
  
  if ( *commentfile && (f=fopen(commentfile, "r")) ) {
    char nick[NICKLEN+1];
    char comment[MIDBUFFER];
    while ( fgets(line, MAXLINE, f) ) {
      if (2 == sscanf(line, "%"NICKLENTXT"[^:]:%"MIDBUFFERTXT"[^\n]",
		      nick, comment)) {
	itemuser *u = FindUserByNick(nick);
	if(u)
	  AddComment(u, comment);
      }
    }
    fclose(f);
  }

  return TRUE;
}

#if 0
/* --- SavePasswd ------------------------------------------------- */

void SavePasswd(void)
{
  FILE *f;
  char line[MAXLINE];
  itemuser *p;

  sprintf(line, "%s~", passfile);
  rename(passfile, line);

  if ( *passfile && (f=fopen(passfile, "w")) ) {

    for (p = Succ(userHead); p; p = Succ(p))
      fprintf(f, "%s:%s\n", p->nick, p->passwd);

    fclose(f);
  }
}

/* --- SaveComment ------------------------------------------------- */

void SaveComment(void)
{
  FILE *f;
  char tempfile[MAXLINE];
  itemuser *p;
  bool ok=TRUE;

  if (! *commentfile )
    return;

  sprintf(tempfile, "%s~", commentfile);

  f=fopen(tempfile, "w");
  if (f) {
    for (p = Succ(userHead); p; p = Succ(p)) {
      if (p->comment)
	if(0>fprintf(f, "%s:%s\n", p->nick, p->comment)) {
	  ok = FALSE;
	  break;
	}
    }
    fclose(f);
    if(ok)
      rename(tempfile, commentfile);
  }
}
#endif


/* --- ReloadUsers ------------------------------------------------ */

void DeleteUsers()
{
  FlushList(userHead, FreeUser);
  numUsers = 0;
}

void ReloadUsers(char *name)
{

  itemident *q;

  DeleteUsers();

  ReadUserfile(name);

  for (q=Succ(identHead); q; q = Succ(q)) {
    if ( q->user=FindUser(q->nick, q->host) ) {
      q->level = q->user->level;
    } else {
      q->level = 0;
      q->passed = FALSE;
    }
  }
}

char *VerboseFlags(uFlags *flags)
{
  static char buffer[128];
  if(flags->banprotect ||
     flags->autoop ||
     flags->linkbot ||
     flags->regularbot ||
     flags->delete ||
     flags->stealth) {
    sprintf(buffer, "Flags:%s%s%s%s%s",
            flags->autoop?" Autoop":"",
            flags->banprotect?" Banprotected":"",
            flags->linkbot?" Linkbot":"",
	    flags->regularbot?" Bot":"",
	    flags->stealth?" Stealth":"",
	    flags->delete?" DELETED":""
	    );
    return buffer;
  }
  return NULL;
}

char *SetUserFlags(uFlags *flags)
{
  static char buf[FLAG_MAXFLAGS+1];
  char *bufp=buf;
  if(flags->autoop)
    *bufp++=FLAG_AUTOOP;
  if(flags->banprotect)
    *bufp++=FLAG_BANPROTECT;
  if(flags->linkbot)
    *bufp++=FLAG_LINKBOT;
  if(flags->regularbot)
    *bufp++=FLAG_REGULARBOT;
  if(flags->delete)
    *bufp++=FLAG_DELETE;
  if(flags->stealth)
    *bufp++=FLAG_STEALTH;
  *bufp=0;
  return buf;
}

const char *WriteUserHead(itemuser *u)
{
  static char buffer[3*BIGBUFFER];

  sprintf(buffer, " %s %d-%s %s\n" "-%s %d %d %d %d %d %s %d\n",
          u->nick, u->level, SetUserFlags(&u->flags), u->realname,
          u->passwd, u->passwdtime, u->modified, u->created,
          (u->checksum = ChecksumUser(u)),
          u->totaljoins, LanguageLocal(u->language), u->newsid);
  if (u->comment)
    sprintf(&buffer[strlen(buffer)], "?%s\n", u->comment);
  if (u->stat_lastdone && u->stat_lastchange)
    sprintf(&buffer[strlen(buffer)], "*%s %d %d\n",
            u->stat_bywhom, u->stat_lastchange, u->stat_lastdone);
  return buffer;
}

/* returns TRUE if it fails */

bool WriteUsers()
{
  itemuser *u;
  itemlist *t;
  FILE *out;
  extern char userfile[];
#ifdef HAVE_LIBFPL
  itemuserlabel *l;
#endif
  char storename[MIDBUFFER];
  bool ok=TRUE;

  if(!userHead)
    return TRUE;

  sprintf(storename, "%s~", userfile);

  out = fopen(storename, "w");
  if(out) {
    if(0>fprintf(out,
                 "# Dancer userlist version: " VERSIONMSG "\n"))
      ok = FALSE;
    for (u=Succ(userHead); ok && u; u=Succ(u)) {
      if(u->flags.delete &&
	 ((u->modified + USER_DELETE_TIMEOUT) < now))
	/*
	 * This user has been marked for deletion and it has not been
	 * changed for the USER_DELETE_TIMEOUT time. That means we should
	 * no longer save it. It is now deleted for REAL. At least in the
	 * next restart. - Bagder (added to 4.1)
	 */
	continue;

      if(0>fprintf(out,
                   "%s", WriteUserHead(u))) {
        ok = FALSE;
	break;
      }
      for (t = Succ(u->domainhead); ok && t; t = Succ(t)) {
        if(0>fprintf(out,
                     "!%s\n", (char *)t->ptr)) {
          ok = FALSE;
	  break;
	}
      }
#ifdef HAVE_LIBFPL
      if(u->label) {
        for(l = Succ((itemuserlabel *)u->label); ok && l; l = Succ(l)) {
          if(l->label &&
             (l->label->flags&(LAB_SAVE|LAB_DEFINED)==(LAB_SAVE|LAB_DEFINED))) {
            if(l->label->flags&LAB_STRING) {
              if(0>fprintf(out,
                           "$%s :%s\n", l->label->name, l->cont.str)) {
                ok = FALSE;
		break;
	      }
            }
            else {
              if(0>fprintf(out,
                           "$%s :%d\n", l->label->name, l->cont.val)) {
                ok = FALSE;
		break;
	      }
            }
          }
        }
      }
#endif
    }
    fclose(out);
    if(ok ) {
      /* Helps to remove the old file before renaming a file on top of
	 it for some OSes */
      /* if it does it is a violation against posix(?) / ansi (?)
	 - Bagder */
      remove(userfile);
      rename(storename, userfile);
    }
  }

  return ok;
}


void static GetUserFlags(uFlags *flags, char *pnt)
{
  if('-'!=*pnt++)
    return;
  while(*pnt) {
    switch(*pnt) {
    case FLAG_AUTOOP:
      flags->autoop=TRUE;
      break;
    case FLAG_BANPROTECT:
      flags->banprotect=TRUE;
      break;
    case FLAG_LINKBOT:
      flags->linkbot=TRUE;
      break;
    case FLAG_REGULARBOT:
      flags->regularbot=TRUE;
      break;
    case FLAG_DELETE:
      flags->delete=TRUE;
      break;
    case FLAG_STEALTH:
      flags->stealth=TRUE;
      break;
    }
    pnt++;
  }
}

/* --- AddUser ---------------------------------------------------- */

itemuser *AddUser(char *from)
{
  itemuser *u;
  int level;
  char nick[NICKLEN+1];
  char info[BIGBUFFER];
  char flags[MIDBUFFER];
  char *flagp;

  if ( (3 <= sscanf(from,
		    " %"NICKLENTXT"s %"MIDBUFFERTXT"s %"BIGBUFFERTXT"[^\n]",
		    nick, flags, info)) ) {
    level = strtol(flags, &flagp, 10);
    if ( (u=(itemuser *)NewEntry(sizeof(itemuser))) ) {
      AddTail(userHead, u);
      u->domainhead = (itemlist *)CreateList(sizeof(itemlist));
      u->nick     = strdup(nick);
      u->level    = level;
      u->passwd   = NULL;
      u->comment  = NULL;
      GetUserFlags(&u->flags, flagp);
      u->realname = strdup(info);
      numUsers++;
      return u;
    }
  }
  return NULL;
}

/* --- LatestUserUpdate ------------------------------------------- */

time_t LatestUserUpdate(void)
{
  time_t t = NULL;
  itemuser *u;

  for (u=Succ(userHead); u; u=Succ(u))
    if (t < u->modified)
      t = u->modified;
  return t;
}

/* --- FindUserByNick --------------------------------------------- */

itemuser *FindUserByNick(char *nick)
{
  itemuser *u;
  if (nick) {
    for (u=Succ(userHead); u; u=Succ(u)) {
      if ( !strcasecmp(nick, u->nick) ) {
        return u;
      }
    }
  }
  return NULL;
}

/* --- FindUser --------------------------------------------------- */

itemuser *FindUser(char *nick, char *userhost)
{
  itemuser *u;
  itemlist *t;
  char namebuffer[BIGBUFFER];
  char *compare;
  char *host;
  if(nick && *nick) {
    host = userhost;
    if(IsPrefix(host))
      host++;
    sprintf(namebuffer, "%s!%s", nick, host);
  }
  else
    nick = NULL;
  if (userhost) {
    for (u=Succ(userHead); u; u=Succ(u)) {
      for (t = Succ(u->domainhead); t; t = Succ(t)) {
        compare= (char *)t->ptr;
	if(nick && strchr(compare, '!')) {
	  /* nick was specified, and the match-pattern contains a nick-part
	     so we check the full host-pattern */
	  if(Match(namebuffer, compare))
	    return u;
	}
	else {
	  host = userhost;
	  if ( Match(host, compare) )
	    return u;
	  if ( IsPrefix(host) ) {
	    host++;
	    if ( Match(host, compare) )
	      return u;
	  }
	  if ( IsPrefix(compare) ) {
	    compare++;
	    if ( Match(host, compare) )
	      return u;
	  }
	}
      }
    }
  }
  return NULL;
}

/* --- SplitHost -------------------------------------------------- */

int SplitHost(char *userhost,     /* user@machine.host.domain */
              char *parsedhost,   /* should become 'machine.host.domain' */
              char *parseddomain, /* should become '*.host.domain' OR
				     'machine.host.domain' if it is hostisp */
              char *parseduser)   /* should become 'user' */
{
  char *host;
  char *xs;
  char *pnt;
  int i;
 
  if (host=strrchr(userhost, '@')) {
    strcpy(parsedhost, &host[1]);
    if (xs = Userdomain(userhost)) {
      pnt = strchr(xs, '@');
      if(pnt) {
	strcpy(parseddomain, pnt+1);
      }
      free(xs);
    } else
      strcpy(parseddomain, &host[1]);
    for (i=0; i < 10 && &userhost[i] != host; i++)
      parseduser[i] = userhost[i];
    parseduser[i]=0;
  }
  else
    return 1;
  return 0;
}

/* --- AddIdent --------------------------------------------------- */

itemident *AddIdent(char *nick,
                    char *userhost,
                    itemuser *u,
                    itemguest *w,
                    itemclient *k)
{
  itemident *p;

  char parsedhost[BIGBUFFER];
  char parseddomain[BIGBUFFER];
  char parseduser[11];

  if(SplitHost(userhost, parsedhost, parseddomain, parseduser))
    return NULL;

  if ( p=(itemident *)NewEntry(sizeof(itemident)) ) {
    AddTail(identHead, p);
    p->level      = u ? u->level : 0;
    p->host       = strdup(userhost);
    p->userdomain = Userdomain(userhost);
    p->signature  = HashSignature(userhost);
    p->user       = u;
    p->guest      = w;
    p->client     = k;
    p->passed     = FALSE;
    p->phost       = strdup(parsedhost);
    p->puserdomain = strdup(parseddomain);
    p->pname       = strdup(parseduser);
#ifdef HAVE_LIBFPL
    p->label = u? u->label:NULL;
#endif
    strncpy(p->nick, nick, NICKLEN+1);

    p->illegalname = strchr(parsedhost, '*')?TRUE:FALSE;
  }
  return (p);
}

void FreeIdent(void *v)
{
  itemident *p;

  if (p=(itemident *)v) {
    if (p->host)
      free(p->host);
    if (p->userdomain)
      free(p->userdomain);
    if(p->phost)
      free(p->phost);
    if(p->pname)
      free(p->pname);
    if(p->puserdomain)
      free(p->puserdomain);
  }
}

/* --- AutoOp ----------------------------------------------------- */

bool IsAutoOp(itemguest *g)
{
  itemuser *iuser = g->ident->user;

  return (iuser && iuser->flags.autoop);
}

void CheckForAutoOp()
{
  bool thereisone=FALSE;
  extern long autoopswaiting;
  if(botop && autoopswaiting) {
    register itemguest *w;
    for (w=Succ(guestHead); w; w=Succ(w)) {
      if ( !w->flags.chanop && w->op_this_person) {
	if( w->op_this_person < now) {
	  Mode("+o %s", w->ident->nick);
	  w->op_this_person = 0; /* don't do it again */
	  return;
	}
	thereisone = TRUE; /* but not right now! */
      }
    }
    if(!thereisone)
      /* there are no users [left] to make chanops */
      autoopswaiting=0; /* we are not having more to do */
  }
}

/* --- NetSplits -------------------------------------------------- */

/*
 * These functions keep a list with all users that quit as the result
 * of a split. If one of them joins within SPLITTIMEOUT seconds, we
 * consider the split to be healed, otherwise we remove them from this
 * list and consider them just quit.
 */

void FreeGuest(void *);

void FreeSplit(void *v)
{
  itemsplit *p;

  if ( p=(itemsplit *)v ) {
    if (p->servers) free(p->servers);
    DestroyList((void **)&p->wholeft, FreeGuest);
  }
}

void AddSplitter(itemguest *w, char *servers)
{
  itemsplit *p;

  if (w) {
    w->flags.split = TRUE;

    totalnumberofsplits++; /* never decrease */

    numSplitGuests++; /* one more [amount in the split lists] */
    numGuests--;      /* one less [in the channel right now]  */

    for (p=Succ(splitHead); p; p=Succ(p)) {
      if (!strcasecmp(p->servers, servers))
        break;
    }
    if (!p) {  /* Make new if non-existant */
      if( p=(itemsplit *)NewEntry(sizeof(itemsplit) ) ) {
        AddHead(splitHead, p);
        p->splittime = lastsplittime = now;
        p->servers = strdup(servers);
        p->wholeft = CreateList(sizeof(itemguest));
        Log(LOGSPLIT, servers);
      } else
        return; /* Error, no mem */
    }

    MoveTail(guestHead, w, p->wholeft);
  }
}


itemguest *SplitterReturns(char *nick, char *host)
{
  itemguest *w;
  itemsplit *p;

  for (p=Succ(splitHead); p; p=Succ(p)) {
    for (w=Succ(p->wholeft); w; w=Succ(w)) {
      if (!strcasecmp(nick, w->ident->nick)) {
        if (!strcasecmp(host, w->ident->host)) {
          if (!p->heal) {  /* Not previously healed */
            Log(LOGNHEAL, p->servers);
            p->heal = TRUE; /* this is now considered healed */
          }
          MoveTail(p->wholeft, w, guestHead);
          if (w->flags.chanop)
            w->flags.splitop = TRUE;
          else
            w->flags.splitop = FALSE;
          w->flags.split = w->flags.chanop = w->flags.voice = FALSE;
          return w; /* The prodigal son */

        } else if (!mute) /* Warn about a potential collision */
          SendNickf(nick, GetDefaultText(msg_warn_nick_collide),
		    nick, TimeAgo(p->splittime), w->ident->host, p->servers);
      }
    }
  }
  return NULL; /* No, not a netjoin */
}

void ScanSplitServers(bool cleanall)
{
  itemsplit *p, *t;

  if(!splitHead)
    return;
 
  p = Succ(splitHead);
  while (p) {
    t = Succ(p);
    if ( cleanall ||
	EmptyList(p->wholeft) ||
	((p->splittime + SPLITTIMEOUT) < now) ) {
      if(!cleanall && !p->heal) {
        Logf(LOGNHEAL, "(timeout) %s", p->servers);
      }
      DeleteEntry(splitHead, p, FreeSplit);
    }
    p = t;
  }
}

/* --- DoCountJoins ----------------------------------------------- */

int DoCountJoins(itemguest *w)
{
  itemaux *p;
  long joins;
  char line[256];

  itemseen *ps;
  extern itemseen **hashsite;
  ulong x;

  joins = 1;
  x = Hash(w->ident->userdomain);
  for (ps = hashsite[x]; ps; ps = ps->next) {
    char *host = w->ident->host;
    char *usite = ps->usite;
    if(IsPrefix(host))
      host++;
    if(IsPrefix(usite))
      usite++;
    if ( Match(host, usite) ) {
      for (p = ps->first; p; p = p->link)
	joins += p->count;  /* Accumulate all joins for user */
        break;
    }
  }
  w->joins = joins;
  return joins;
}

char *GetPrefix(char prefix)
{
  switch(prefix) {
  case PREFIX_HAT:
    return "^";
  case PREFIX_EQUAL:
    return "=";
  case PREFIX_PLUS:
    return "+";
  case PREFIX_TILDE:
    return "~";
  case PREFIX_DASH:
    return "-";
  default:
    return "";
  }
}

char IsPrefix(char *name)
{
  switch(*name) {
  case PREFIX_HAT:
  case PREFIX_TILDE:
  case PREFIX_PLUS:
  case PREFIX_EQUAL:
  case PREFIX_DASH:
    return *name;
  default:
    return PREFIX_NONE;
  }
}


/* --- BadUsername --------------------------------------------------
 * Returns TRUE if the 'username' consists of any of the characters we
 * consider "illegal" and therefore enforces site bans/warns patterns.
 */
int BadUsername(char *name)
{
  while(*name) {
    switch(*name) {
    case '*':
    case '?':
#if 0
      /* caused major confusion, better leave them out for now */
    case '[':
    case ']':
    case '!':
#endif
    case '@':
      return TRUE;
    }
    name++;
  }
  return FALSE;
}

/* --- NewGuest --------------------------------------------------- */

void NewGuest_Who(char *line)
{
  char username[MIDBUFFER], host[MIDBUFFER], nick[NICKLEN+1],
       status[16];
  char buf[MIDBUFFER];
  bool chop, voice, ircop;
  itemguest *g;

  if (4 <= sscanf(line, "%*s %*s %"MIDBUFFERTXT"s %"MIDBUFFERTXT"s %*s %"NICKLENTXT"s %15s",
                  username, host, nick, status) ) {

    chop = (strchr(status, '@') ? TRUE : FALSE);
    voice = (strchr(status, '+') ? TRUE : FALSE);
    ircop = (strchr(status, '*') ? TRUE : FALSE);

    /*
     * Further:
     * '*' means the person is an ircop
     * 'H' means the person is not away
     * 'G' means the person _is_ away
     *
     * But since we cannot get this info from joined users without making
     * additional /WHO calls on each joined person, we won't get this kind
     * of info on people not already joined when we join. - Bagder
     */

    sprintf(buf, "%s@%s", username, host);
    AddGuest(nick, buf, chop, voice, ircop, &g);

    if ( !strcmp(nick, nickname) ) {
      /* this is us */
      botop = chop;
      if (g)
        g->flags.bot = TRUE; /* after all, we are a bot */

      sprintf(myaddr, "%s@%s", username, host);
      sprintf(botmatch, "%s!%s", nick, myaddr);
    }
  } else
    Debug("Strange format: %s", line);
}

/* --- RemoveGuest ------------------------------------------------ */

void FreeGuest(void *v)
{
  itemguest *w;

  if ( w=(itemguest *)v ) {
    if (w->ident->client)
      w->ident->guest = NULL;
    else
      DeleteEntry(identHead, w->ident, FreeIdent);
    if(w->kickmsg)
      free(w->kickmsg);
    if(w->flags.split)
      numSplitGuests--;
    else
      numGuests--;
  }
}

void RemoveGuest(char *nick)
{
  itemguest *w;

  if ( w=FindNick(nick) ) {
    if (welcome && !mute) {  /* we are set to welcome / wave ! */
      if (!w->posts)
        Sayf("How rude, %s just left without saying *anything* to us!",
             w->ident->nick);
      else if ((w->jointime + SECINMIN) > now) 
        Actionf("sighs, a %d seconds visit! Is that all we deserve? :-(",
                now - w->jointime);
    }
#ifdef HAVE_LIBFPL
    if(w->ident->user)
      w->ident->user->label=w->ident->label;
#endif
      
    DeleteEntry(guestHead, w, FreeGuest);
  }
}

/* --- DeleteGuests ----------------------------------------------- */

void DeleteGuests()
{
  if(guestHead) {
#ifdef HAVE_LIBFPL
    {
      itemguest *w;
      for (w=Succ(guestHead); w; w=Succ(w)) {
        if (w->ident->user)
          w->ident->user->label = w->ident->label;
      }
    }

#endif

    FlushList(guestHead, FreeGuest);
  }
/*
 * Remove all servers in the split-list because we want to remove all the
 * guests that might be linked on them
 */
  ScanSplitServers(TRUE); 
  numGuests = numSplitGuests = 0;
}

/* --- NetHeal ----------------------------------------------------- */

/*
 * May be called several times each netheal!
 */
void NetHeal()
{
  extern bool possiblyfresh; /* this might be a restarted server!! */
  extern int possiblyfreshtime; /* timeout for refreshed server netheals */

  masterflood = TRUE;
  mastertime = now;
  if(possiblyfresh) {
    possiblyfreshtime=now;
    possiblyfresh = FALSE;
  }
}

/* --- AddGuest --------------------------------------------------- */

bool AddGuest(char *nick, char *host,
              bool chop, bool voice, bool ircop,
              itemguest **guest)
{
  itemguest *w;
  itemclient *k;

  bool realjoin;

  if ( w=SplitterReturns(nick, host) ) {

    Logf(LOGNJOIN, "%s [%d] (%s)", nick, w->ident->level, host);
    NetHeal();
    realjoin = FALSE; /* no "real" join */
    numSplitGuests--; /* one less */
    numGuests++;      /* one more */
  }
  else {
    /*
     * At certain occasions, when the bot makes a /who call, and the list isn't
     * done yet, and a nick joins, we can get two entries with the same nick.
     * We prevent this by checking that the nick we're about to add isn't
     * already added.
     */
    w = FindNick(nick);
    if(!w || strcasecmp(w->ident->host, host)) {

      if ( w=(itemguest *)NewEntry(sizeof(itemguest)) ) {      
	AddTail(guestHead, w);

	/* Inherit privileges from client. If a user has made a client,
	 * changed nick and joined, we cannot know if it's really him...
	 * tough luck.
	 */
	if ( (k=FindClientByNick(nick)) &&
	    !strcasecmp(k->ident->host, host) ) {
	  w->ident = k->ident; /* this is our ident struct */
	  k->ident->guest = w; /* make the ident point back to us */
	} else {

	  /* Each itemguest _must_ have an ident structure attached! */
	  if ( !(w->ident=AddIdent(nick, host,
				   FindUser(nick, host),
				   w, NULL)) ) {
	    DeleteEntry(guestHead, w, FreeGuest);
	    Debug("Out of memory. Cannot add guest %s (%s)",
		  nick, host);
	    return FALSE;
	  }
	}
	/*
	 * Check if the guest matched as a user that is some kind of
	 * bot, and if so, set the guest-flag for BOT.
	 */
	if(w->ident->user &&
	   (w->ident->user->flags.linkbot ||
	    w->ident->user->flags.regularbot))
	  w->flags.bot = TRUE;
	else
	  w->flags.bot = FALSE;
	w->flags.chanop = chop;
	w->flags.voice  = voice;
        w->flags.ircop  = ircop;
        w->flags.splitop = FALSE;
      } else {
	Debug("Out of memory");
	return FALSE;
      }
      numGuests++;
      Logf(LOGJOIN, "%s%s [%d] (%s)", chop?"@":"",
	   w->ident->nick, w->ident->level, w->ident->host);

      w->jointime = now;
      /*
       * I think this might need some explanation. The joincount system has
       * always been based on the seen data. When the user joins, we check
       * the hostpattern and then sums the number of joins all the different
       * nick names have done with that hostpattern.
       * Now, since I intend to improve this system while there are already
       * lots of systems running and many many joins counted, I need a way
       * to get the old joins somehow read into the new system. I will
       * therefore make the ->totalcount of the user struct count the total
       * number of joins (for regged users) but I will continue doing the old
       * count. If the old count shows a higher count than the new, the new
       * will be raised to the old one. That way, the new should seen get at
       * least the value of the largest old one for the users hostpatterns.
       * - Bagder
       */

      DoCountJoins(w);

      if(w->ident->user) {
	w->ident->user->totaljoins++; /* yeps, this user did join right now */
	if(w->joins > w->ident->user->totaljoins)
	  /* old system contains more joins, copy them to the new system */
	  w->ident->user->totaljoins = w->joins;
	else
	  /* well, this is the total amount we know of: */
	  w->joins = w->ident->user->totaljoins;
      }
    }
    realjoin = TRUE; /* standard join */
  }
  /* Don't sent messages for the bot owner to the bot */
  if (strcmp(w->ident->nick, nickname))
    TellNotify(w);

  if(guest)
    *guest = w;

  return (realjoin);
}

/* --- FindNick --------------------------------------------------- */

/* Used very often! Make hashed nicks instead? */

itemguest *FindNick(char *nick)
{
  register itemguest *w;

  if (nick) {
  
    for (w=Succ(guestHead); w; w=Succ(w)) {
      if ( !strcasecmp(w->ident->nick, nick) )
        return (w);
    }
  }
  return NULL;
}

itemguest *FindSplitNick(char *nick)
{
  itemsplit *p;
  itemguest *w;

  for (p=Succ(splitHead); p; p=Succ(p)) {
    for (w=Succ(p->wholeft); w; w=Succ(w)) {
      if (!strcasecmp(nick, w->ident->nick)) {
        return w;
      }
    }
  }
  return NULL;
}

/* --- FindHost --------------------------------------------------- */
#if 1
/* Not used? */
itemguest *FindHost(char *host)
{
  itemguest *w;

  if(strchr(host, '!')) {
    /* full *!*@* pattern expected */
    char nick[NICKLEN+1];
    char hostb[MIDBUFFER];
    if(2 == sscanf(host, "%" NICKLENTXT "[^!]!%" MIDBUFFERTXT "s",
		   nick, hostb)) {
      for (w=Succ(guestHead); w; w=Succ(w)) {
	if (Match(w->ident->nick, nick) &&
	    Match(w->ident->host, hostb) )
	  return (w);
      }
    }
  }
  else 
    for (w=Succ(guestHead); w; w=Succ(w)) {
      if ( Match(w->ident->host, host) )
	return (w);
    }
  return NULL;
}
#endif

/* --- ChangeGuest ------------------------------------------------ */

void ChangeGuest(char *oldnick, char *newnick)
{
  itemguest *w, *n;
  itemclient *k;
  itemsplit *p;
  
  if ( w=FindNick(oldnick) ) {
    strncpy(w->ident->nick, newnick, NICKLEN+1);

    w->flags.kicked=FALSE;
    if (w->flags.kick) {
      Kick(newnick, w->kickmsg ? w->kickmsg : "Gotcha!");
      AddKick(w->ident, nickname, "Nick flooder!", KICK_BOT);
    }
    else if (nickflood) {
      if ((w->nicktime + 10) >= now) {
	if (++w->nickchanges > 2)
	  Warning(w, "nick-flooders", "Nick flooder!");
      } else {
	w->nickchanges = 0;
        if(warnmode)
          WarnCheck(newnick, newnick, w->ident->host);
      }
    }
    w->nicktime = now;

    /* Try to unify structures */
    if (!w->ident->client &&
        (k=FindClientByNick(w->ident->nick)) &&
        (w->ident->user == k->ident->user) &&
        !strcasecmp(w->ident->host, k->ident->host) ) {
      w->ident->passed |= k->ident->passed;
      k->ident->client = NULL;
      DeleteEntry(identHead, k->ident, FreeIdent);
      k->ident = w->ident;

      /*
       * Hm, we should let the ident know it is used to identify a client
       * too.
       * - Bagder
       */
      w->ident->client = k;
    }

    if (!mute) {
      for (p=Succ(splitHead); p; p=Succ(p)) {
        for (n=Succ(p->wholeft); n; n=Succ(n)) {
          if ((n->ident != w->ident) &&
              !strcasecmp(n->ident->nick, newnick))
            SendNickf(newnick, GetDefaultText(msg_warn_nick_collide),
		      newnick, TimeAgo(p->splittime), n->ident->host,
                      p->servers);
        }
      }
    }
  }
  else
    Debug("Internal confusion. Unknown user \"%s\" changed nick.", oldnick);
}


/* --- FindClientByNick ------------------------------------------- */

itemclient *FindClientByNick(char *nick)
{
  itemclient *k;

  for (k=Succ(clientHead); k; k=Succ(k)) {
    if (k->ident && !strcasecmp(k->ident->nick, nick))
      break;
  }
  return (k);
}

/* --- RemoveClient ----------------------------------------------- */

void FreeClient(void *v)
{
  itemclient *k;

  if ( k=(itemclient *)v ) {
    if (k->ident->guest)
      k->ident->client = NULL;
    else
      DeleteEntry(identHead, k->ident, FreeIdent);
    if(k->filebuffer)
      free(k->filebuffer);
  }
}

itemclient *RemoveClient(itemclient *k)
{
  itemclient *p;
  char buf[MIDBUFFER];

  sprintf(buf, "%s removed at socket %d", k->ident->nick, k->socket);
  Log(LOGCLIENT, buf);
  CloseConnection(k->socket);
  numClients--;
  p = (itemclient *)DeleteEntry(clientHead, k, FreeClient);
  Multicast(SPYCAST, buf);
  return p;
}

/* --- AddClient -------------------------------------------------- */

itemclient *AddClient(char *nick, char *uhost, itemuser *u, int sock)
{
  itemclient *k;
  itemguest *w;
  
  if ( k=(itemclient *)NewEntry(sizeof(itemclient)) ) {
    AddTail(clientHead, k);
    /* Find nick on channel, and inherit it's privileges */
    if ( w=FindNick(nick) ) {
      if (w->ident->client) {
	DeleteEntry(clientHead, k, FreeClient); /* remove again */
        return NULL; /* Client already exist */
      }
      k->ident = w->ident;
      w->ident->client = k;
    } else {
      if ( !(k->ident=AddIdent(nick, uhost, u, NULL, k)) ) {
        DeleteEntry(clientHead, k, FreeClient);
        Debug("Out of memory. Cannot add client %s (%s)",
              nick, uhost);
        return NULL;
      }
    }
    k->socket = sock;
    k->status = CL_NONE;
    k->buildtime = k->lasttime = now;
    k->flags = WALLCAST;
    k->chatecho = TRUE; /* we start in echomode by default */
    if (u->level >= LEVELPUB)
      k->flags |= REPORTCAST;
    if (u->level >= LEVELOWNER)
      k->flags |= DEBUGCAST;
    numClients++;
    Logf(LOGCLIENT, "%s (%s) added",
         k->ident->nick, u->nick);
    Multicastf(SPYCAST, "client %s has connected", k->ident->nick);
  }
  return (k);
}

/* --- DeleteClients ---------------------------------------------- */

void DeleteClients(void)
{
  Log(LOGCLIENT, "All clients removed");
  FlushList(clientHead, FreeClient);
}

/* --- Links ------------------------------------------------------ */

/* addr and port must be in network order */
itemlink *FindLink(ulong addr, ushort port)
{
  itemlink *r;

  for (r = Succ(linkHead); r; r = Succ(r))
    if ((r->addr.sin_addr.s_addr == addr) && (r->addr.sin_port == port))
      return r;
  return NULL;
}

itemlink *FindLinkByNick(char *nick)
{
  itemlink *r;

  for (r = Succ(linkHead); r; r = Succ(r))
    if ( !strcasecmp(r->name, nick) )
      return r;
  return NULL;
}

itemlink *AddLink(char *name, itemuser *u, ulong num, ushort port)
{
  itemlink *r;

  if (r=FindLink(htonl(num), htons(port)))
    return NULL;

  if ( r=(itemlink *)NewEntry(sizeof(itemlink)) ) {
    AddTail(linkHead, r);
    r->user = u;
    r->name = strdup(name);
    r->addr.sin_family = AF_INET;
    r->addr.sin_port = htons(port);
    r->addr.sin_addr.s_addr = htonl(num);
    r->passed = FALSE;
    r->buildtime = r->lasttime = now;
    r->mymsgid = 0;
    r->yourmsgid = -1;
    rtt_init(r);
  }
  return r;
}

void FreeLink(void *v)
{
  itemlink *r;

  if ( r=(itemlink *)v ) {
    FlushLinkQueue(r);
    if (r->name) free(r->name);
  }
}

itemlink *RemoveLink(itemlink *r)
{
  return (DeleteEntry(linkHead, r, FreeLink));
}


/* --- UsersInit -------------------------------------------------- */

void UsersInit()
{
  userHead   = CreateList(sizeof(itemuser));
  identHead  = CreateList(sizeof(itemident));
  linkHead   = CreateList(sizeof(itemlink));
  clientHead = CreateList(sizeof(itemclient));
  guestHead  = CreateList(sizeof(itemguest));
  splitHead  = CreateList(sizeof(itemsplit));
}

/* --- UsersCleanup ----------------------------------------------- */

void UsersCleanup()
{
  WriteUsers();

  DestroyList((void **)&splitHead, FreeSplit);
  DestroyList((void **)&guestHead, FreeGuest);
  DestroyList((void **)&clientHead, FreeClient);
  DestroyList((void **)&linkHead, FreeLink);
  DestroyList((void **)&identHead, FreeIdent);
  DestroyList((void **)&userHead, FreeUser);
}

/* ---- DefaultPassword ------------------------------------------- */

char *MakePassword(char *password)
{
  unsigned char salt[3];
  int rnd = (int)(Rnd()*4096);
  to64(salt, rnd, 2);
  salt[2]=0;
  return strdup(mycrypt(password, salt));
}
#define SALT "k9"

bool CheckPassword(char *plain, char *passwd)
{
  char salt[3];
  if(!strncmp(passwd, "$1$", 3)) {
    salt[0] = passwd[3];
    salt[1] = passwd[4];
    salt[2] = 0;
    
    return !strcmp(mycrypt(plain, salt), passwd); /*NEW*/
  }
  else {
#if defined(HAVE__CRYPT)
    return !strcmp((char *)_crypt(plain, SALT), passwd);
#elif (!defined(AMIGA) || defined(__GNUC__)) && !defined(__CYGWIN32__) /* amiga version has no crypt() of its own at all */
    return !strcmp((char *)crypt(plain, SALT), passwd); 
#endif
  }
}

int User2ID(char *nick, char *flags)
{
  itemguest *g;
  itemuser *u;
  itemclient *c;

  g= FindNick(nick);
  if(!g)
    g= FindSplitNick(nick);
  u = FindUserByNick(nick);
  c = FindClientByNick(nick);

  if(strstr(flags, "join"))
    return (int)g;

  if(strstr(flags, "reg"))
    return (int)u;

  if(g)
    return (int)g;
  if(u)
    return (int)u;
  if(c)
    return (int)c;
  return 0;
}

#define ID_NONE 0
#define ID_GUEST 1
#define ID_SPLIT 2
#define ID_CLIENT 4
#define ID_USER  8

int ID2User(int id, itemuser **user, itemguest **guest, itemclient **client)
{
  itemguest *g;
  itemuser *u;
  itemclient *c;
  itemsplit *p;

  for (g=Succ(guestHead); g; g=Succ(g)) {
    if ( g == (itemguest *)id) {
      *guest = g;
      return ID_GUEST;
    }
  }
  for (p=Succ(splitHead); p; p=Succ(p)) {
    for (g=Succ(p->wholeft); g; g=Succ(g)) {
      if (g == (itemguest *)id ) {
        *guest = g;
        return ID_SPLIT;
      }
    }
  }
  for (u=Succ(userHead); u; u=Succ(u)) {
    if ( u == (itemuser *)id ) {
      *user = u;
      return ID_USER;
    }
  }
  for (c=Succ(clientHead); c; c=Succ(c)) {
    if (c == (itemclient *)id) {
      *client = c;
      return ID_CLIENT;
    }
  }
  return ID_NONE;
}

itemident *ID2Ident(int id)
{
  itemguest *g;
  itemuser *u;
  itemclient *c;

  switch(ID2User(id, &u, &g, &c)) {
  case ID_NONE:
    return NULL; /* nada */
  case ID_GUEST:
  case ID_SPLIT:
    return g->ident;
  case ID_USER:
    return NULL;
  case ID_CLIENT:
    return c->ident;
  }
  return NULL;
}

#if (defined(LAB_PATCH) && defined(HAVE_LIBFPL))
itemuserlabel **ID2Label(int id)
{
  itemguest *g;
  itemuser *u;
  itemclient *c;

  switch(ID2User(id, &u, &g, &c)) {
  case ID_NONE:
    return NULL; /* nada */
  case ID_GUEST:
  case ID_SPLIT:
    return (itemuserlabel **)&g->ident->label;
  case ID_USER:
    return (itemuserlabel **)&u->label;
  case ID_CLIENT:
    return (itemuserlabel **)&c->ident->label;
  }
  return NULL;
}
#endif

/* =========================================================================

   NickReport() experiments, please have patience!

   ========================================================================= */

/*****************

GENERAL-SEEN-NICK (no options)

  A  SEEN as usual. Say the usual. If joined, abort.

  B  Get the host pattern and search the ppl currently joined,
     any match? If yes, say:
    = "A person matching that pattern is currently joined as 'nick'"

  -  Check for the registered nick. If none of the reg'ed nick's hosts
     match the already found pattern, check the channel for anyone
     matching. Anyone joined?
     1- If yes, say and abort.
        = "The nick is registered to the user now joined as 'nick'."
     2- If no, say and abort
        = "The nick is registered to another user."

  C  Perform a seen -MOST- on the nick. If that gives us another
     host, check the channel for it. Anyone joined?
     1- If yes, say and abort
        = "Another hostpattern 'host' has used the nick more often and is
           currently joined as 'nick'."
     2- If no. Say and abort
        = "Another hostpattern 'host' has used the nick more often."

  D  Get the host pattern and search for a more frequently used nick.
     Any match? If yes, say and abort.
     = "The nick 'nick' has been used more often with that hostpattern."

*********************/

void NickReport(char *from, char *nick)
{
  itemaux *p;
  itemaux *pp;
  itemaux *maxnick=NULL;
  itemaux *recentnick=NULL;
  itemuser *regnick;
  itemguest *joinednick;
  itemguest *g;

  extern itemaux **hashnick; /* from seen */

  char *joineddomain=NULL; /* user@*.domain.top */
  
  long max = 0;
  time_t recent = 0;
  long hits = 0;

  joinednick = FindNick(nick);
  regnick = FindUserByNick(nick);

  if(joinednick) {
    joineddomain = joinednick->ident->userdomain;
    Sendf(from, "%s (%s) %s.", nick, joineddomain,
          GetText(msg_is_joined_now));
    if(regnick && (regnick == joinednick->ident->user)) {
      Send(from, GetText(msg_regged_user_with_nick));
    }
    else if(regnick) {
      itemguest *j=NULL;
      itemlist *t;
      for (t = Succ(regnick->domainhead); t; t = Succ(t)) {
	j = FindHost((char *)t->ptr);
	if(j)
	  break;
      }
      Send(from, GetText(msg_not_his_nick));
      if(j) {
	Sendf(from, GetText(msg_who_is_now), j->ident->nick);
      }
    }
  }
  
  if ( pp=hashnick[HashU(nick)] ) { /* beginning of list */
    for (p = pp; p; p = p->next) {
      if ( !strcasecmp(p->nick, nick) ) {

	hits++;
	if ( p->count > max ) {
	  max = p->count;
	  maxnick = p;
	}
	if ( p->root->departure > recent ) {
	  recent = p->root->departure;
	  recentnick = p;
	}
      }
    }
  }
  if(hits) {
    g = FindHost(recentnick->root->host);
    Sendf(from, GetText(msg_most_recently_used_by), recentnick->root->host);
    if(g) {
      Sendf(from, GetText(msg_from_which_host), g->ident->nick);
    }
    if(strcasecmp(recentnick->root->host, maxnick->root->host)) {
      Sendf(from, GetText(msg_most_often_used_by), maxnick->root->host);
      g = FindHost(maxnick->root->host);
      if(g) {
	Sendf(from, GetText(msg_from_which_host), g->ident->nick);
      }
    }
    else
      Send(from, GetText(msg_and_also_most_often_used));
  }

}

/*
 * NonHostISP()
 *
 * Returns TRUE if the input parameter is listed as a non-host-ISP in
 * the .config file.
 */

bool NonHostISP(char *checkthis)
{
  extern itemlist *nonhostispHead;
  itemlist *p;

  if(nonhostispHead) {
    for (p=Succ(nonhostispHead); p; p=Succ(p)) {
      if(Match(checkthis, p->ptr))
        return TRUE;
    }
  }
  return FALSE;
}

/*
 * HostISP()
 *
 * Returns TRUE if the input parameter is listed as a host-ban-only ISP in
 * the .config file.
 */

bool HostISP(char *checkthis)
{
  extern itemlist *hostispHead;
  itemlist *p;

  for (p=Succ(hostispHead); p; p=Succ(p)) {
    if(Match(checkthis, p->ptr)) {
      if(NonHostISP(checkthis))
	return FALSE; /* then toggle back */
      else
	return TRUE; /* straight and clean hostisp */
    }
  }
  return FALSE;
}

/*
 * DontSiteBan()
 *
 * Returns TRUE if the input parameter is listed as a dontsiteban ISP in the
 * .config file.
 */

bool DontSiteBan(char *checkthis)
{
  extern itemlist *dontsitebanHead;
  itemlist *p;

  for (p=Succ(dontsitebanHead); p; p=Succ(p)) {
    if(Match(checkthis, p->ptr)) {
      return TRUE; /* prevent sitebans on this domain */
    }
  }
  return FALSE;
}
