#ifdef RCS
static char rcsid[]="$Id: server.c,v 2.8 1998/05/16 20:47:20 dast Exp dast $";
#endif
/******************************************************************************
 *                    Internetting Cooperating Programmers
 * ----------------------------------------------------------------------------
 *
 *  ____    PROJECT
 * |  _ \  __ _ _ __   ___ ___ _ __ 
 * | | | |/ _` | '_ \ / __/ _ \ '__|
 * | |_| | (_| | | | | (_|  __/ |   
 * |____/ \__,_|_| |_|\___\___|_|   the IRC bot
 *
 * Main authors:
 *  - Bjrn Reese <breese@imada.ou.dk>
 *  - Daniel Stenberg <Daniel.Stenberg@sth.frontec.se>
 *
 * Contributing authors (and ports):
 *  - Philippe Brand <phb@telesys-innov.fr>
 *  - Bjrn Stenberg <Bjorn.Stenberg@sth.frontec.se>
 *
 * All files in this archive are subject to the GNU General Public License.
 * 
 *               HTTP://www.imada.ou.dk/~breese/dancer.html
 *                FTP://ftp.netcom.com/pub/ra/raydar/Dancer
 *
 * $Source: /home/hardcore/dast/dancer/src/RCS/server.c,v $
 * $Revision: 2.8 $
 * $Date: 1998/05/16 20:47:20 $
 * $Author: dast $
 * $State: Exp $
 * $Locker: dast $
 *
 * ---------------------------------------------------------------------------
 * $Log: server.c,v $
 * Revision 2.8  1998/05/16 20:47:20  dast
 * allows high-levels and bots to multijoin
 * parse NOSPOOF pings properly
 *
 * Revision 2.7  1998/03/23 18:32:40  dast
 * server command loop bug fixed
 *
 * Revision 2.6  1998/02/14 11:35:11  dast
 * boundary checks
 * 'current' set correctly on CTCPs
 *
 * Revision 2.5  1998/01/29 15:28:30  dast
 * Removed ACUTAL flag from all bans when kicked!
 *
 * Revision 2.4  1998/01/26 17:21:08  dast
 * Fixed the terrible nick detection flaw that caused a crash when exploited
 *
 * Revision 2.3  1997/11/24 23:36:12  dast
 * breese's extended join-mode patch
 * new warncheck call
 *
 * Revision 2.2  1997/11/05 22:02:51  dast
 * updated!
 *
 * Revision 2.1  1997/08/25 17:53:33  dast
 * limit stuff
 * ircop aware addguest()
 *
 * Revision 1.43  1997/05/12 16:26:24  dast
 * added 'fakenamemode'
 *
 * Revision 1.42  1997/04/28 16:44:43  dast
 * Added a patch for memmove() lacking systems
 * fixed the strictop-implementation
 *
 * Revision 1.41  1997/02/10 19:40:30  dast
 * logs error messages from server
 * added STRICTOP
 *
 * Revision 1.40  1997/01/27 17:13:43  dast
 * millisecond pings
 * better recording of +v
 *
 * Revision 1.39  1997/01/07 16:21:51  dast
 * new usage of multicheck()
 *
 * Revision 1.38  1996/12/16 18:22:27  dast
 * new try-to-get-nick-from-pattern code on ban-reading in the channel
 *
 * Revision 1.37  1996/12/13 18:11:32  dast
 * a lot of FindNick() return code checks
 *
 * Revision 1.36  1996/12/11 18:36:28  dast
 * now USE the smaller buffer when copying too!
 *
 * Revision 1.35  1996/12/10 18:09:11  dast
 * made the topic buffer smaller
 *
 * Revision 1.34  1996/12/09 18:26:02  dast
 * much better autoop
 * new FindUser() syntax
 * better sscanf()s
 * tiny fixes
 *
 * Revision 1.33  1996/12/06 15:56:57  dast
 * AUTOUNBAN support added
 *
 * Revision 1.32  1996/11/04 18:55:19  dast
 * Fixed two ifdefs for HAVE_LIBFPL
 *
 * Revision 1.31  1996/09/23 18:12:52  dast
 * made it once again do its job on server ops and deops
 *
 * Revision 1.30  1996/09/06 08:53:16  dast
 * less waste of bandwidth when server-modes is done and the bot is unopped
 * server-ops are now taken care of "properly" even if not opped
 *
 * Revision 1.29  1996/09/05 06:03:14  dast
 * Added a bunch of hooks
 *
 *****************************************************************************/

#include <stdio.h>
#include <string.h>

#include "numeric.h" /* From the irc server source */
#include "list.h"
#include "dancer.h"
#include "function.h"
#include "user.h"
#include "command.h"
#include "ctcp.h"
#include "transfer.h"
#include "seen.h"
#include "server.h"
#include "bans.h"
#include "link.h"

#include "servfunc.h"
#include "fplrun.h"

/* --- Global ----------------------------------------------------- */

extern time_t now;

extern char cmodes[], chanmodes[], ckey[], chankey[];
extern char channel[], nickname[], servername[];
extern char botmatch[], myaddr[], myhost[];
extern char askforops[];
extern char *errfrom;

extern bool nickflag, connected, restart, moderateflag;
extern bool lockmode, lockkey, locklimit;
extern bool netsplitmode;
extern bool deopprotect;
extern bool talkative;
extern bool warnmode; /* check people with the warnlist */
extern bool multimode;
extern bool cleanup;
extern bool invitable;
extern bool autojoin;
extern bool autoop;
extern bool dispcomment;
extern bool autoop;
extern bool kickbans;
extern bool autounban;
extern bool strictopmode;
extern bool fakenamemode;
extern bool banprotect;
extern bool opprotect;
extern bool oplevel;
extern bool mute;

extern bool possiblyfresh;
extern bool bantimeouts;

extern int possiblyfreshtime;
extern int pubbantime;
extern int retry;

extern long climit;
extern long levels[];

extern itemident *current;


time_t topictime = 0;
time_t lastservertime = 0;

char topicwho[BIGBUFFER];
char topic[BIGBUFFER];

bool botop = FALSE; /* TRUE if the bot has channel operator status */

long numofbotmodes;
long modecount[11] = { 0,0,0,0,0,0,0,0,0,0,0 };
long autoopswaiting = 0;
long limitc = 0;


/* ---------------------------------------------------------------- */

struct
{
  char *name;
  void (*function)(char *a, char *b);
} messages[] =
{
  {"PRIVMSG", OnPrivmsg}, {"MODE",    OnMode},   {"JOIN",    OnJoin},
  {"PART",    OnPart},    {"QUIT",    OnQuit},   {"NICK",    OnNick},
  {"KICK",    OnKick},    {"PING",    OnPing},   {"PONG",    OnPong},
  {"TOPIC",   OnTopic},   {"NOTICE",  OnNotice}, {"INVITE",  OnInvite},
  {"ERROR",   OnError},
  {"", (void(*)())(NULL)}
};

#ifndef HAVE_MEMMOVE
void memmove(char *to, char *from, int len)
{
  int i;
  if(to>from) {
    for(i=len-1; i>=0; i--)
      to[i]=from[i];
  }
  else {
    for(i=0; i>len; i++)
      to[i]=from[i];
  }
}
#endif

/* --- ParseServer ------------------------------------------------ */

#include "server_gperf.c"

void ParseServer(char *line)
{
  int i, num;
  char *command, *from, *rest = NULL, *end;
  extern char servername[];

  snapshot;
  if ( *line != ':' ) {
    from = servername;
    command = line;
    rest = strchr(line, ' ');
    if(!rest)
      return;
    *rest++ = NIL;
  } else {
    from = ++line;
    command = strchr(from, ' ');
    if(!command)
      return;
    *command++ = NIL;
    rest = strchr(command, ' ');
    if(!rest)
      return;
    *rest++ = NIL;
  }
  if ( end=strchr(rest, '\n') ) {
    if ( end[-1] == '\r' )
      end--;
    *end = NIL;
  }

  if ( num=atoi(command) )
    OnNumeric(from, num, rest);
  else {
#if 0
    for (i=0; messages[i].name[0]; i++) {
      if ( !strcmp(messages[i].name, command) ) {
        messages[i].function(from, rest);
        break;
      }
    }
#else
    struct Servercmds *p;
    if (p=FindServerKey(command, strlen(command))) {
      lastservertime = now;
      p->function(from,rest);
    }
#endif
  }
}

/* --- OnPrivmsg -------------------------------------------------- */

void OnPrivmsg(char *from, char *line)
{
  char *msg, *xs, *ys;
  char ctcpbuffer[MAXLINE];
  char ctcpfrom[MIDBUFFER];
  int len;
  bool onchannel;

  char frombuf[NICKLEN+1];
  itemguest *w=NULL;

  if(sscanf(from, "%"NICKLENTXT"[^!]", frombuf)) {
    w = FindNick(frombuf);
    current = w?w->ident:NULL;
  }

  snapshot;
  if (*line == '$')  /* Ignore global messages */
    return;

  if ( (msg=strchr(line, ' ')) == NULL)
    return;
  *msg++ = NIL;
  if (*msg == ':') msg++;

  onchannel = IsChannel(line);
  xs = msg;
  while (xs=strchr(xs, '\001')) {
    if ( (ys = strchr(xs + 1, '\001')) == NULL )
      break;  /* while */
    if ( (len = ys - xs - 1) > 0 ) {
      memmove(ctcpbuffer, xs + 1, len);
      ctcpbuffer[len] = '\0';
      if ( (len = strlen(ys + 1)) > 0 ) {
        memmove(xs, ys + 1, len);
        xs[len] = '\0';
      } else {
	*xs = '\0';
	xs = ys + 1;
      }
      strcpy(ctcpfrom, from);
      if (onchannel)
        PubCTCP(ctcpfrom, ctcpbuffer);
      else
        CTCP(ctcpfrom, ctcpbuffer);
    } else xs = ys + 1;  /* Empty ctcp */
  }

  if (*msg) {
    if (onchannel)
      PubCommand(from, msg);
    else
      Command(from, msg);
  }


#if 0
  char *msg;

  snapshot;
  if ( msg = strchr(line, ' ') )
    *msg++ = NIL;

  if ( !IsChannel(line) ) {
    if (*(++msg) == '\001')
      CTCP(from, msg);
    else
      Command(from, msg);
  } else {
    if (*(++msg) == '\001')
      PubCTCP(from, msg);
    else
      PubCommand(from, msg);
  }
#endif
}

/* --- OnNotice --------------------------------------------------- */

void OnNotice(char *from, char *line)
{
  char *where;
  int index;
  char mde[MIDBUFFER];
  char kanal[MIDBUFFER];
  char nik[NICKLEN+1];
  char buf[BIGBUFFER];

  snapshot;
  if ( !from || IsServer(from) ) {  /* Server notices */
    if ( where=strstr(line, "Fake:") ) {
      if (2 <= sscanf(where, "%*s %"NICKLENTXT"s %*s %"MIDBUFFERTXT"s %"MIDBUFFERTXT"[^\n]",
                      nik, kanal, mde) ) {
        if ( !strcasecmp(kanal, channel) ) {
          sprintf(buf, "Fake: \"%s\" on channel %s by %s [%s]",
                  mde, kanal, nik, from);
          Multicast(REPORTCAST, buf);
          Log(LOG, buf);
        }
      }
    }
  }
}

/* --- OnTopic ---------------------------------------------------- */

void OnTopic(char *from, char *line)
{
  snapshot;
#ifdef HAVE_LIBFPL
  if(runfpl(RUN_TOPIC, line, FPLRUN_PRE))
    return;
#endif
  topictime = now;
  strncpy(topicwho, from, BIGBUFFER);
  strncpy(topic, strchr(line, ':') + 1, BIGBUFFER);
  runfpl(RUN_TOPIC, line, FPLRUN_POST);
}

/* --- OnInvite --------------------------------------------------- */

void OnInvite(char *from, char *line)
{
  itemlist *p;
  char kanal[MIDBUFFER];
  char *nik, *uhost;
  itemuser *u;

  snapshot;
  sscanf(line, "%*s %*[:]%"MIDBUFFERTXT"s", kanal);

#ifdef HAVE_LIBFPL
  if(runfpl(RUN_INVITE, kanal, FPLRUN_PRE))
    return;
#endif
  nik = strtok(from, "!");
  uhost = strtok(NULL, "");
  if ( (u=FindUser(from, uhost)) && (u->level >= LEVELTRUST) ) {
    if (invitable) {
      errfrom = nik;
      Logf(LOG, "Invited to %s by %s!%s", kanal, nik, uhost);
      CmdJoin(nik, kanal);
    } else
      Send(nik, GetDefaultText(msg_no_invitation));
  }
  runfpl(RUN_INVITE, kanal, FPLRUN_POST);
}

/* --- OnMode ----------------------------------------------------- */

void OnMode(char *from, char *line)
{
  itemuser *p;
  itemguest *pc, *who = NULL;
  char c, cursign = '+';
  int i=0, j=0, bans=0, deops=0, opmodes=0;
  char domode[8], undomode[8];
  char *uhost, *modes, *param;
  char *banon[5], *banoff[5], *chopon[5], *chopoff[5];
  char **pbanon=banon, **pbanoff=banoff;
  char **pchopon=chopon, **pchopoff=chopoff;
  char limit = -1;  /* 0 => +l
                       1 => -l  */
  char dodeop = -1; /* 0 => dont deop the (de)oper (strictop / opprotect),
                       1 => deop the (de)oper (strictop / opprotect) */
  bool botmode = FALSE; /* bot did the mode? */
  bool servermode; /* servermode? */

  snapshot;
  strtok(from, "!");
  uhost = strtok(NULL, "");

  Logf(LOGMODE, "\"%s\" by %s%s%s%s", line, from,
       uhost ? " (" : "",
       uhost ? uhost : "",
       uhost ? ")" : "");

  if (!IsChannel(NextWord(line)))
    return; /* Ignore user mode changes */

  servermode = IsServer(from);
  if (!servermode) {
    botmode = !strcmp(from, nickname);
    who = FindNick(from); /* who did the mode change? */
  }

  modes = NextWord(line);

  while (c = *modes++) {
    switch (c) {
      case '+':
      case '-':
        cursign = c;
        break;
      case 'o':
        param = NextWord(line);
        opmodes++;
        if (cursign == '+') {
          modecount[0]++;
          *pchopon++ = param;
        }
        else {
          deops++;
          *pchopoff++ = param;
        }
        if (!strcmp(param, nickname)) {
          /* this is us! */
          if (talkative && !mute) {
            if (cursign == '+') {
              if (!botop)
                Actionf(GetDefaultText(msg_thanks_for_ops), from);
            }
            else {
              if (botop)
                Actionf(GetDefaultText(msg_slaps_for_deop), from);
            }
          }
          botop = (cursign == '+');
        }
        if (botmode) {
          if (pc = FindNick(param))
            pc->flags.chanop = (cursign == '+');
        }
        break;
      case 'b':
        param = NextWord(line);
        if (cursign == '+') {
          modecount[1]++;
          *pbanon++ = param;
          bans++;
        }
        else
          *pbanoff++ = param;
        if (!servermode) {
          if (cursign == '+') {
	    char *nick=NULL;

            if (who)
              who->bans++;
            if (!botmode && /* not set by bot */
                who && (who->ident->level < LEVELBOT) &&
                (Match(botmatch, param) || /* matches the bot, or... */
                (banprotect && IllegalBan(param)))) { /* matches a ban-proctected person */
              Mode("-o-b %s %s", from, param);
              dodeop = 0;
/*              Kick(from, Gimme(MSG_KICK_BADBAN) ); */
            }
	    /*
	     * We make an attempt to see if we can find a nick to attach
	     * with the specified ban pattern. This works [pretty good]
	     * in all cases when the ban is set before the kick...
	     */
	    pc = FindHost(param);
	    if (pc)
	      nick = pc->ident->nick;
	    else {
	      /*
	       * Ok, no user matched the banpattern that was set. We're
	       * going for more casual guesses. Now, let's take a quick look
	       * and see if any of the recent kicks match the pattern.
	       */
	      /*
	       * We don't try the SEEN functions since they could be very
	       * extensive and take quite some time (a few months in #Amiga
	       * gives a lot more than 10000 hosts and 20000 nicks).
	       */
	      itemkick *k = KickMatch(param);
	      if (k)
		nick = k->nick;
	    }

	    /* if we found the nick the 'guess-way', we set the GUESS bit */
            AddToBanList(BAN_ACTUAL|(nick?BAN_GUESSNICK:0), from, nick, param,
                         botmode?-1:pubbantime, NULL);
          }
          else
            Unbanned(from, param, botmode);
        }
        else {
          /* server shit */
          if (cursign == '+')
            AddToBanList(BAN_ACTUAL, from, NULL, param, 0, NULL);
        }
        if (cursign == '+') {
          int num=CountBans(BAN_ACTUAL);

          if (num >= BANLIST_ALERTSIZE) {
	    static int lastwarn;

	    if (!autounban || !botop || !UnbanLoprio(from)) {
	      /*
	       * The bot can be told to automatically unban the least important
	       * ban when reaching this amount. If it isn't, or it isn't
	       * opped, or the unban failed for some reason, we procede
	       * (and make the ALERT output).
	       */
	      
	      if ((now - lastwarn) > 600) {
		/*
		 * Max-rate is every 10th minute!
		 */
                if (!mute)
		  Actionf(GetDefaultText(msg_alert_banlist_full), num);
		Logf(LOGWARN, "Banlist contains %d bans!", num);
		lastwarn = now;
	      }
	    }
          }
        }
        break;
      case 'k':
        param = NextWord(line);
        if (cursign == '+') {
	  modecount[2]++;
          strcpy(chankey, param);
	}
        else
          chankey[0] = NIL;
        break;
      case 'l':
        if (cursign == '+') {
	  modecount[3]++;
          limit = 0;
	}
        else
          limit = 1;

        param = NextWord(line);
        limitc = atoi(param); /* get the limit */
        break;
      case 'v':
        param = NextWord(line);
	if (cursign == '+')
	  modecount[4]++;
        pc = FindNick(param);
        if (pc)
          pc->flags.voice = (cursign == '+');
        break;
      case 'p':
      case 's':
      case 'i':
      case 't':
      case 'n':
      case 'm': /* undo changes */
        if (strchr(cmodes, c)) {
          if (cursign == '-')
            domode[i++]=c;
        }
        else {
          if (cursign == '+')
            undomode[j++]=c;
        }
	if (cursign == '+') {
	  switch(c) {
	  case 'p': modecount[5]++; break;
	  case 's': modecount[6]++; break;
	  case 'i': modecount[7]++; break;
	  case 't': modecount[8]++; break;
	  case 'n': modecount[9]++; break;
	  case 'm': modecount[10]++; break;
	  }
	}
        break;
    } /* switch */
  } /* while */

  *pchopon = *pchopoff = *pbanon = *pbanoff = NULL;
  domode[i] = NIL;
  undomode[j] = NIL;

  /* React */

  if (!botmode) { /* Don't react on my own mode changes */

    /* Handle netsplit hacks, strictop and opprotect */
    for (i = j = 0; chopon[i]; i++) {
      if (pc = FindNick(chopon[i])) {
        if (!pc->flags.chanop &&
            (pc->ident->level < max(LEVELRECOG, oplevel))) {
          if (servermode) {
            if (netsplitmode)
              if (!pc->flags.splitop)
                chopon[j++] = chopon[i];
          }
          else { /* not by server */
            if (strictopmode) {
              if (strcmp(chopon[i], nickname) && /* lets not deop ourselves */
                  who && (who->ident->level < max(LEVELBOT, oplevel))) {
                chopon[j++] = chopon[i];
              }
            }
          }
        }
        pc->flags.chanop = TRUE; /* user *IS* chanop right now */
      }
    }
    while (j < 5)
      chopon[j++] = NULL;

    for (i = j = 0; chopoff[i]; i++) {
      if (pc = FindNick(chopoff[i])) {
        if (pc->flags.chanop &&
            (pc->ident->level >= max(LEVELCHANOP, oplevel))) {
          if (servermode) {
            if (netsplitmode)
              chopoff[j++] = chopoff[i];
          }
          else {
            if (opprotect) {
              if (who && (who->ident->level < max(LEVELCHANOP, oplevel)))
                chopoff[j++] = chopoff[i];
            }
          }
        }
        pc->flags.chanop = pc->flags.splitop = FALSE; /* user isn't op anymore */
      }
    }
    while (j < 5)
      chopoff[j++] = NULL;

    if (!servermode &&
        (chopon[0] || chopoff[0]) &&
        (dodeop < 0) &&
        who && (who->ident->level < max(LEVELCHANOP, oplevel))) {
      /*  A guest did the mode change and
       *  we want to reset some of the op-modes back and
       *  we haven't yet sent a "mode -o" for this guest and
       *  his level is too low, so we want to deop him too
       */

      dodeop = 1;
      for (i=4; i > 0; i--) /* deop the 'abuser' first */
        chopon[i] = chopon[i-1];
      chopon[0] = from;
      if (opmodes < 4) { /* we try to guess how many op modes are allowed */
        if (chopon[3]) {
          chopon[4] = chopon[3];
          chopon[3] = NULL;
        }
      }
    }
    else
      dodeop = 0;

    if (botop) {
      if (chopon[0]) {
        Mode("-oooo %s %s %s %s",
             (chopon[0] ? chopon[0] : ""),
             (chopon[1] ? chopon[1] : ""),
             (chopon[2] ? chopon[2] : ""),
             (chopon[3] ? chopon[3] : ""));
        if (chopon[4])
          Mode("-o %s", chopon[4]);
      }
      if (chopoff[0]) {
        Mode("+oooo %s %s %s %s",
             (chopoff[0] ? chopoff[0] : ""),
             (chopoff[1] ? chopoff[1] : ""),
             (chopoff[2] ? chopoff[2] : ""),
             (chopoff[3] ? chopoff[3] : ""));
      }

      if (lockkey) {  /* Handle key changes */
        if (who && (who->ident->level >= max(LEVELBOT, oplevel)))
          ;
        else {
          if (strcmp(ckey, chankey)) {
            if (*chankey)
              Mode("-k %s", chankey);
            if (*ckey)
              Mode("+k %s", ckey);
          }
        }
      }
      if (lockmode) {  /* Handle channel mode changes */
        if (*domode || *undomode) {
          if (who && (who->ident->level >= max(LEVELCHANOP, oplevel)))
            ;
          else
            Mode("+%s-%s", domode, undomode);
        }
      }
      if (locklimit && (limit >= 0)) {
        if (who && (who->ident->level >= max(LEVELCHANOP, oplevel)))
          ;
        else {
          /* limit was changed, check if we want limit and if it matches
             our wish */
          if (0 == limit) {
            /* we got a +l */
            if (!climit)
              Mode("-l"); /* we don't want limit */
            else if (climit != limitc)
              /* we got a limit we don't like */
              Mode("+l %d", climit); /* set our preferred one */
          }
          else {
            /* we got a -l */
            if (climit)
              /* we want a limit set */
              Mode("+l %d", climit);
          }
        }
      }
    }

    if (servermode) {
      NetHeal(); /* server actions are only here on net-heals! */

      /* Remove bans set by server */
      if (possiblyfreshtime &&
         ((now - possiblyfreshtime) < SERVERBANTIMEOUT)) {
        for (i=0; (i < bans) && !IsUnban(banon[i]); i++);
        if (i != bans) {
          /*  If one of them bans matched an unbanned one! It means that we
              don't consider this a "fresh" split! */
          possiblyfreshtime = 0;
        }
        else
          bans = 0;
      }
      if (botop) {
        if (bans > 0)
          Mode("-bbb %s %s %s", (bans > 0 ? banon[0] : ""),
               (bans > 1 ? banon[1] : ""), (bans > 2 ? banon[2] : ""));
      }
    }
    else { /* Not server */
      if (deopprotect && (deops > 1) && botop && who)
        Warning(who, "deoppers", "Mass-deop detected");
      if (!mute && chopon[dodeop] && !chopon[dodeop+1]) /* lets not inform mass-oppers */
        SendNickf(from, GetDefaultText(msg_no_ops_allowed), chopon[dodeop]);
    }
  }
  else
    numofbotmodes++; /* bot changed a mode in the channel */
}

/* --- OnJoin ----------------------------------------------------- */

void OnJoin(char *from, char *line)
{
  char *host, *site;
  itemguest *w;
  char *servermodes;
  bool nethealjoin = FALSE;

  snapshot;
  strtok(from, "!");
  host = strtok(NULL, "");

  /* ircd2.9 uses \a to append modes (server ops/voice) */
  servermodes = strchr(line, '\a');
  if (servermodes)
    *servermodes++ = NIL;
  /* Channel names cannot contain spaces, bells, or commas */
  strtok(++line, " \a,");

  runfpl(RUN_JOIN, from, FPLRUN_PRE);

  if ( !strcmp(from, nickname) ) {
    strcpy(channel, line);
    if ( site=strrchr(myhost, '@') )
      strcpy(myhost, site);  /* This is how the server sees me */
#ifdef NICKSERV
    WriteServer("CHANSERV op %s %s", channel, nickname);
#endif
    WriteServer("WHO %s", channel);    /* Who are on the channel */
    WriteServer("MODE %s", channel);   /* What are the channel modes */
    WriteServer("MODE %s b", channel); /* What are the bans */
  }
  else {
    
    if (AddGuest(from, host, FALSE, FALSE, FALSE, &w)) {
      current = w->ident;
      if (moderateflag && botop)
        Mode("+v %s", from);
    } else /* netjoin or error */
      nethealjoin = TRUE;

    if(fakenamemode && w->ident->illegalname)
      StickyKick(w, GetDefaultText(msg_illegal_name));

    if(kickbans) {
      /* check done even if not opped for the purpose of being better aware
	 of the situation when later opped */
      char match[MINIBUFFER];
      sprintf(match, "*!%s", host);
      if(IsBan(match))
        StickyKick(w, "Go away, you're banned here!");
    }

    if (servermodes)
      {
      /* Make a fake mode change */
      char xfrom[MIDBUFFER], xline[MIDBUFFER];
      sprintf(xfrom, "%s", servername);
      sprintf(xline, "%s +%s %s %s", channel, servermodes, from,
              ((NIL == servermodes[1]) ? "" : from));
      OnMode(xfrom, xline);
      }

    if (autoop && IsAutoOp(w)) {
      /* DONT op anyone at this join, when several bots/people run services
	 like this the channel simply gets flooded after long lasting netheals.
	 Let's wait a (random) while before checking this user if it is op,
	 and if it still isn't, op the poor thing. */
      w->op_this_person = now + Rnd()*10+10;
      autoopswaiting++;
      /* Mode("+o %s", from); */
    }
    if (multimode && w->ident->level<LEVELEXPERT && !w->flags.bot) {
      /* do this check even if not opped, the knowledge can be good if we
	 are suddenly opped in the middle of an attack */
      MultiCheck(w->ident->userdomain);
    }

    if (warnmode)
      WarnCheck(from, from, host);

    if (dispcomment && !nethealjoin)
      DispComment(w);
  }
  runfpl(RUN_JOIN, from, FPLRUN_POST);
}

/* --- OnPart ----------------------------------------------------- */

void OnPart(char *from, char *line)
{
  snapshot;
  strtok(from, "!");
  runfpl(RUN_LEAVE, from, FPLRUN_PRE);
  if ( !strcmp(from, nickname) ) {  /* I left */
    SeenInsertAll(SEENLEFT, NULL, NULL);
    DeleteGuests();
    BanDisable(); /* no vaild bans anymore */
  } else {
    itemguest *g=FindNick(from);
    if(g) {
      SeenInsert(g, SEENLEAVE, NULL, NULL);
      RemoveGuest(from);
    }
    else
      Debug("Internal confusion. Unknown user \"%s\" left.", from);
  }
  Log(LOGPART, from);
  runfpl(RUN_LEAVE, from, FPLRUN_POST);
}

/* --- OnQuit ----------------------------------------------------- */

void OnQuit(char *from, char *line)
{
  snapshot;
  if (*line == ':')
    line++;
  strtok(from, "!");
  runfpl(RUN_QUIT, from, FPLRUN_PRE);
  if ( !strcmp(from, nickname) ) {  /* I quitted */
    SeenInsertAll(SEENQUITED, NULL, NULL);
    DeleteGuests();
    BanDisable();
  } else {
    bool split=FALSE;
    itemguest *g=FindNick(from);
    if(!g) {
      Debug("Internal confusion. Unknown user \"%s\" quit.", from);
    }
    else {
      SeenInsert(g, SEENQUIT, NULL, line);
      if(PatternExist(line, "^[-A-Z0-9a-z.*]+[.][A-Za-z]+ [-A-Z0-9a-z.*]+[.][A-Za-z]+")) {
	/* Enhanced split detection to trap even more faked ones */
	char name1[MIDBUFFER];
	char name2[MIDBUFFER];
	split = TRUE;
	if(2 == sscanf(line, "%"MIDBUFFERTXT"s %"MIDBUFFERTXT"s",
		       name1, name2)) {
	  char *p=strrchr(name1, '.')+1;
	  if(!FindByCode(p))
	    split=FALSE;
	  else {
	    p=strrchr(name2, '.')+1;
	    if(!FindByCode(p))
	      split=FALSE;
	  }
	}
      }
      if(split)
	AddSplitter(g, line);
      else
	/* a "real" quit */
	RemoveGuest(from);
    }
  }
  Logf(LOGQUIT, "%s (%s)", from, line);
  runfpl(RUN_QUIT, from, FPLRUN_POST);
}

/* --- OnKick ----------------------------------------------------- */

void OnKick(char *from, char *line)
{
  char *who;
  char nick[NICKLEN+1];
  itemguest *u;

  snapshot;
  sscanf(from, "%" NICKLENTXT"[^!] ", nick);
  if (u = FindNick(nick))
    u->kicks++;

  Logf(LOGKICK, "(%s) by %s", line, from);

  runfpl(RUN_KICK, line, FPLRUN_PRE);

  strtok(line, " ");
  who = strtok(NULL, " ");

  if (!strcmp(who, nickname)) {  /* Someone kicked me */
    SeenInsertAll(SEENKICKED, from, NULL);
    DeleteGuests();
    BanDisable(); /* no vaild bans anymore */
    if (autojoin)
      WriteServer("JOIN %s %s", channel, chankey);
#ifdef HAVE_LIBFPL
    if (!runfpl(RUN_KICKBOT, from, FPLRUN_PRE))
      runfpl(RUN_KICKBOT, from, FPLRUN_POST);
#endif
  }
  else {
    itemguest *g = FindNick(who); /* this *CAN* return NULL */
    char *kickmsg = strtok(NULL, "");
    if (g) {
      if (strcmp(from, botmatch)) {
	/* not a bot kick */
	AddKick(g->ident, from, kickmsg,
		g->ident->level<LEVELTRUST?KICK_COMMON:KICK_TRUSTEDUSER);

        if (opprotect) {
          if (botop && u &&
              (u->ident->level < max(LEVELCHANOP, oplevel)) &&
              (g->ident->level >= max(LEVELCHANOP, oplevel))) {
            Mode("-o %s", nick);
          }
        }
      }
      else
	/*
	 * This is an ordinary kick when recorded here!
	 */
	AddKick(g->ident, from, kickmsg, KICK_COMMON);
      SeenInsert(g, SEENKICK, from, kickmsg);
      RemoveGuest(who);
    }
    else
      Debug("Internal confusion. Unknown user \"%s\" was kicked.", who);
  }
  runfpl(RUN_KICK, line, FPLRUN_POST);
}

/* --- OnNick ----------------------------------------------------- */

void OnNick(char *from, char *line)
{
  snapshot;
  strtok(from, "!");
  line++;
  runfpl(RUN_NICK, from, FPLRUN_PRE);
  Logf(LOGNICK, "%s is now known as %s (%s)", from, line, strtok(NULL, ""));
  if ( !strcmp(nickname, from) ) {
    strcpy(nickname, line);
    sprintf(botmatch, "%s!%s", nickname, myaddr);
    SendLinkAll(IBCP_NICKNAME, "%s", nickname);
  }
  ChangeGuest(from, line);
  runfpl(RUN_NICK, line, FPLRUN_POST);
}

/* --- OnPing ----------------------------------------------------- */

void OnPing(char *from, char *line)
{
  char forward[MIDBUFFER];

  snapshot;
  /* To avoid "(Ping timeout)" by the server */
  if (*line == ':')
    line++;

  if (2 == sscanf(line, "%*s %" MIDBUFFERTXT "s", forward))
    WriteServer("PONG %s", forward);
  else
    WriteServer("PONG %s", line);
}

/* --- OnPong ----------------------------------------------------- */

int pendingpings = 0;
struct timeval pingval;
struct timeval pongval;
struct timeval delayval;

void OnPong(char *from, char *line)
{
  struct timeval helpval;

  snapshot;
  pendingpings--;
  gettimeofday(&pongval, NULL);
  delayval.tv_sec = pongval.tv_sec - pingval.tv_sec;
  delayval.tv_usec = pongval.tv_usec - pingval.tv_usec;
  /* Normalize the time values */
  while (delayval.tv_usec > MILLION) {
    delayval.tv_usec -= MILLION;
    delayval.tv_sec++;
  }
  while (delayval.tv_usec < 0) {
    delayval.tv_usec += MILLION;
    delayval.tv_sec--;
  }
}

void PingServer(void)
{
  snapshot;
  gettimeofday(&pingval, NULL);
  WriteServer("PING :%s", servername);
  pendingpings++;
}

/* --- OnError ---------------------------------------------------- */

void OnError(char *from, char *line)
{
  char buffer[BIGBUFFER];
  snapshot;
  sprintf(buffer, "ERROR: (%s) from %s", line, from);
  Log(LOG, buffer);
#ifdef HAVE_LIBFPL
  if(!runfpl(RUN_ERROR, line, FPLRUN_PRE))
    runfpl(RUN_ERROR, line, FPLRUN_POST);
#endif
  DisconnectServ(buffer);
  connected = FALSE;
  SeenInsertAll(SEENERROR, line, NULL);
  DeleteGuests();
  BanDisable();
  restart = cleanup = TRUE;
}

/* --- OnNumeric -------------------------------------------------- */

#ifdef NICKSERV
extern char nickpasswd[];
#endif

void OnNumeric(char *from, int num, char *line)
{
  char buf[BIGBUFFER];
  char nick[NICKLEN+1];

  char number[22];
  sprintf(number, "%d", num);
  runfpl(RUN_NUMERIC, number, FPLRUN_PRE);

  snapshot;
  switch (num) {

  case RPL_WELCOME: /* Welcomming message */
    connected = TRUE;
    strcpy(servername, from);
    sscanf(line, "%"NICKLENTXT"s", nickname);
#ifndef DBUG
    WriteServer("MODE %s +is", nickname);
#else
    WriteServer("MODE %s +i", nickname);
#endif
#ifdef NICKSERV
    WriteServer("NICKSERV identify %s", nickpasswd); 
#endif
    WriteServer("JOIN %s %s", channel, chankey);
    gettimeofday(&pongval, NULL);
    retry = 0;
    break;

  case ERR_NICKNAMEINUSE: /* Nickname already in use */
  case ERR_ERRONEUSNICKNAME: /* or wrong nickname */
  case ERR_UNAVAILRESOURCE: /* Nick/channel is temporarily unavailable */
    if (nickflag == FALSE)
      nickflag = TRUE;
    else {
      NewNick();
      WriteServer("NICK %s", nickname);
    }
    break;

  case ERR_NICKCOLLISION: /* Nickname collision */
    Log(LOG, "Nickname collision");
    restart = cleanup = TRUE;
    break;

  case ERR_NOTREGISTERED: /* You have not registered */
    Hello(NULL);
    break;

  case RPL_WHOREPLY:  /* Users on channel at join time */
    NewGuest_Who(line);
    break;

  case RPL_TOPIC:  /* The topic on join */
    topictime = now;
    strncpy(topicwho, from, BIGBUFFER);
    strncpy(topic, strchr(line, ':') + 1, BIGBUFFER);
    break;

  case RPL_NOTOPIC:
    topictime = 0;
    break;

  case RPL_CHANNELMODEIS:
    strcpy(chanmodes, strchr(line, '+') + 1);
    break;

  case RPL_BANLIST: /* get 3rd word */
    if (1 <= sscanf(line, "%*s %*s %"BIGBUFFERTXT"s", buf) ) {
      /* fprintf(stderr, "BANLIST ENTRY: '%s'\n", buf); */
      AddToBanList(BAN_ACTUAL, NULL, NULL, buf, -1, NULL);
    }
    break;

  case RPL_ENDOFBANLIST:
    /* we're at the end of banlist */
    bantimeouts=TRUE; /* enable timeouts now */
    if(!CountBans(BAN_ACTUAL)) {
      /* no actual bans in the channel */
      possiblyfresh = TRUE; /* restarted server? */
      /* fprintf(stderr, "### no bans in channel! ###\n"); */
    }
    break;

  case ERR_NOSUCHNICK: /* Flush messages if target has disappeared */
  case ERR_NOSUCHCHANNEL:
    if (1 >= sscanf(line, "%*s %"BIGBUFFERTXT"s", buf) )
      MessageReaper(buf);
    break;

  case ERR_CANNOTSENDTOCHAN:  /* Check for channel desync */
  case ERR_CHANOPRIVSNEEDED:
    if (strcasecmp(from, servername)) {
      sprintf(buf, "Desync: Server %s rejected request", from);
      Multicast(REPORTCAST, buf);
      Log(LOG, buf);
    }
    break;

  case RPL_ENDOFNAMES: /* End of /NAMES list */
    if (*askforops && !botop)
      Action(askforops);
    break;

  case ERR_CHANNELISFULL:
    sprintf(buf, "Channel %s is full", channel);
    Log(LOG, buf);
    Multicast(REPORTCAST, buf);
    break;

  case ERR_INVITEONLYCHAN:
    sprintf(buf, "Channel %s is invite-only", channel);
    Log(LOG, buf);
    Multicast(REPORTCAST, buf);
    break;

  case ERR_BANNEDFROMCHAN:
    sprintf(buf, "Banned from channel %s", channel);
    Log(LOG, buf);
    Multicast(REPORTCAST, buf);
    break;

  case ERR_BADCHANNELKEY:
    sprintf(buf, "Bad channel key for %s", channel);
    Log(LOG, buf);
    Multicast(REPORTCAST, buf);
    break;

  case ERR_NOPERMFORHOST: /* Not I-lined */
    Logf(LOG, "No permission to connect to server %s", servername);
    break;

  case ERR_YOUREBANNEDCREEP: /* K-lined */
    Logf(LOG, "Banned from server %s", servername);
    break;

#if 0
    /*
     * Messages we definetely ignore: */
    /* MOTD junk */
  case RPL_MOTDSTART:
  case RPL_MOTD:
  case RPL_ENDOFMOTD:

    /* Inital crap info: */
  case RPL_YOURHOST: /* 'Darxide :Your host is irc.ludd.luth.se, running
                        version 2.9.2+Cr8' */
  case RPL_CREATED: /* 'Darxide :This server was created Sun Jan 26 
                       1997 at 16:54:21 MET' */
  case RPL_MYINFO: /* 'Darxide irc.ludd.luth.se 2.9.2+Cr8 oirw abiklmnopqstv'
                    */

    /* Luser statistics: */
  case RPL_LUSERCLIENT: /* 'Darxide :There are 11523 users and 0 services
                           on 61 servers' */
  case RPL_LUSEROP: /* 'Darxide 88 :operators online' */
  case RPL_LUSERUNKNOWN: /* 'Darxide 2 :unknown connections' */
  case RPL_LUSERCHANNELS: /* 'Darxide 4319 :channels formed' */
  case RPL_LUSERME: /* 'Darxide :I have 309 clients, 0 services and 3
                       servers' */

  case RPL_NAMREPLY: /* the name list we get automatically when we join a
                        channel */

  case RPL_ENDOFWHO: /* End of /WHO list */

#endif

  default: /* Recommended ending of a switch() */

    /* case ERR_RESTRICTED:  we're restricted here, could try to change to a
       different server */

    if(num>=ERR_NOSUCHNICK) {
      /* Log errors only */
      Logf(LOG, "Server message %d: '%s'", num, line);
    }
    break;
  }
  runfpl(RUN_NUMERIC, number, FPLRUN_POST);

}
